                                Release Notes

   The release notes contain the significant changes in each PostgreSQL
   release, with major features and migration issues listed at the top.
   The release notes do not contain changes that affect only a few users
   or changes that are internal and therefore not user-visible. For
   example, the optimizer is improved in almost every release, but the
   improvements are usually observed by users as simply faster queries.

   A complete list of changes for each release can be obtained by viewing
   the Git logs for each release. The pgsql-committers email list records
   all source code changes as well. There is also a web interface that
   shows changes to specific files.

   The name appearing next to each item represents the major developer for
   that item. Of course all changes involve community discussion and patch
   review, so each item is truly a community effort.
     __________________________________________________________________

                                Release 9.3.2

     Release Date: 2013-12-05

   This release contains a variety of fixes from 9.3.1. For information
   about new features in the 9.3 major release, see the Section called
   Release 9.3.
     __________________________________________________________________

Migration to Version 9.3.2

   A dump/restore is not required for those running 9.3.X.

   However, this release corrects a number of potential data corruption
   issues. See the first three changelog entries below to find out whether
   your installation has been affected and what steps you can take if so.

   Also, if you are upgrading from a version earlier than 9.3.1, see the
   release notes for 9.3.1.
     __________________________________________________________________

Changes

     * Fix "VACUUM"'s tests to see whether it can update relfrozenxid
       (Andres Freund)
       In some cases "VACUUM" (either manual or autovacuum) could
       incorrectly advance a table's relfrozenxid value, allowing tuples
       to escape freezing, causing those rows to become invisible once
       2^31 transactions have elapsed. The probability of data loss is
       fairly low since multiple incorrect advancements would need to
       happen before actual loss occurs, but it's not zero. In 9.2.0 and
       later, the probability of loss is higher, and it's also possible to
       get "could not access status of transaction" errors as a
       consequence of this bug. Users upgrading from releases 9.0.4 or
       8.4.8 or earlier are not affected, but all later versions contain
       the bug.
       The issue can be ameliorated by, after upgrading, vacuuming all
       tables in all databases while having vacuum_freeze_table_age set to
       zero. This will fix any latent corruption but will not be able to
       fix all pre-existing data errors. However, an installation can be
       presumed safe after performing this vacuuming if it has executed
       fewer than 2^31 update transactions in its lifetime (check this
       with SELECT txid_current() < 2^31).
     * Fix multiple bugs in MultiXactId freezing (Andres Freund, Alvaro
       Herrera)
       These bugs could lead to "could not access status of transaction"
       errors, or to duplicate or vanishing rows. Users upgrading from
       releases prior to 9.3.0 are not affected.
       The issue can be ameliorated by, after upgrading, vacuuming all
       tables in all databases while having vacuum_freeze_table_age set to
       zero. This will fix latent corruption but will not be able to fix
       all pre-existing data errors.
       As a separate issue, these bugs can also cause standby servers to
       get out of sync with the primary, thus exhibiting data errors that
       are not in the primary. Therefore, it's recommended that 9.3.0 and
       9.3.1 standby servers be re-cloned from the primary (e.g., with a
       new base backup) after upgrading.
     * Fix initialization of "pg_clog" and "pg_subtrans" during hot
       standby startup (Andres Freund, Heikki Linnakangas)
       This bug can cause data loss on standby servers at the moment they
       start to accept hot-standby queries, by marking committed
       transactions as uncommitted. The likelihood of such corruption is
       small unless, at the time of standby startup, the primary server
       has executed many updating transactions since its last checkpoint.
       Symptoms include missing rows, rows that should have been deleted
       being still visible, and obsolete versions of updated rows being
       still visible alongside their newer versions.
       This bug was introduced in versions 9.3.0, 9.2.5, 9.1.10, and
       9.0.14. Standby servers that have only been running earlier
       releases are not at risk. It's recommended that standby servers
       that have ever run any of the buggy releases be re-cloned from the
       primary (e.g., with a new base backup) after upgrading.
     * Fix multiple bugs in update chain traversal (Andres Freund, Alvaro
       Herrera)
       These bugs could result in incorrect behavior, such as locking or
       even updating the wrong row, in the presence of concurrent updates.
       Spurious "unable to fetch updated version of tuple" errors were
       also possible.
     * Fix dangling-pointer problem in fast-path locking (Tom Lane)
       This could lead to corruption of the lock data structures in shared
       memory, causing "lock already held" and other odd errors.
     * Fix assorted race conditions in timeout management (Tom Lane)
       These errors could result in a server process becoming unresponsive
       because it had blocked SIGALRM and/or SIGINT.
     * Truncate "pg_multixact" contents during WAL replay (Andres Freund)
       This avoids ever-increasing disk space consumption in standby
       servers.
     * Ensure an anti-wraparound "VACUUM" counts a page as scanned when
       it's only verified that no tuples need freezing (Sergey Burladyan,
       Jeff Janes)
       This bug could result in failing to advance relfrozenxid, so that
       the table would still be thought to need another anti-wraparound
       vacuum. In the worst case the database might even shut down to
       prevent wraparound.
     * Fix full-table-vacuum request mechanism for MultiXactIds (Andres
       Freund)
       This bug could result in large amounts of useless autovacuum
       activity.
     * Fix race condition in GIN index posting tree page deletion (Heikki
       Linnakangas)
       This could lead to transient wrong answers or query failures.
     * Fix "unexpected spgdoinsert() failure" error during SP-GiST index
       creation (Teodor Sigaev)
     * Fix assorted bugs in materialized views (Kevin Grittner, Andres
       Freund)
     * Re-allow duplicate table aliases if they're within aliased JOINs
       (Tom Lane)
       Historically PostgreSQL has accepted queries like
SELECT ... FROM tab1 x CROSS JOIN (tab2 x CROSS JOIN tab3 y) z
       although a strict reading of the SQL standard would forbid the
       duplicate usage of table alias x. A misguided change in 9.3.0
       caused it to reject some such cases that were formerly accepted.
       Restore the previous behavior.
     * Avoid flattening a subquery whose SELECT list contains a volatile
       function wrapped inside a sub-SELECT (Tom Lane)
       This avoids unexpected results due to extra evaluations of the
       volatile function.
     * Fix planner's processing of non-simple-variable subquery outputs
       nested within outer joins (Tom Lane)
       This error could lead to incorrect plans for queries involving
       multiple levels of subqueries within JOIN syntax.
     * Fix incorrect planning in cases where the same non-strict
       expression appears in multiple WHERE and outer JOIN equality
       clauses (Tom Lane)
     * Fix planner crash with whole-row reference to a subquery (Tom Lane)
     * Fix incorrect generation of optimized MIN()/MAX() plans for
       inheritance trees (Tom Lane)
       The planner could fail in cases where the MIN()/MAX() argument was
       an expression rather than a simple variable.
     * Fix premature deletion of temporary files (Andres Freund)
     * Prevent intra-transaction memory leak when printing range values
       (Tom Lane)
       This fix actually cures transient memory leaks in any datatype
       output function, but range types are the only ones known to have
       had a significant problem.
     * Fix memory leaks when reloading configuration files (Heikki
       Linnakangas, Hari Babu)
     * Prevent incorrect display of dropped columns in NOT NULL and CHECK
       constraint violation messages (Michael Paquier and Tom Lane)
     * Allow default arguments and named-argument notation for window
       functions (Tom Lane)
       Previously, these cases were likely to crash.
     * Suppress trailing whitespace on each line when pretty-printing
       rules and views (Tom Lane)
       9.3.0 generated such whitespace in many more cases than previous
       versions did. To reduce unexpected behavioral changes, suppress
       unnecessary whitespace in all cases.
     * Fix possible read past end of memory in rule printing (Peter
       Eisentraut)
     * Fix array slicing of int2vector and oidvector values (Tom Lane)
       Expressions of this kind are now implicitly promoted to regular
       int2 or oid arrays.
     * Return a valid JSON value when converting an empty hstore value to
       json (Oskari Saarenmaa)
     * Fix incorrect behaviors when using a SQL-standard, simple GMT
       offset timezone (Tom Lane)
       In some cases, the system would use the simple GMT offset value
       when it should have used the regular timezone setting that had
       prevailed before the simple offset was selected. This change also
       causes the timeofday function to honor the simple GMT offset zone.
     * Prevent possible misbehavior when logging translations of Windows
       error codes (Tom Lane)
     * Properly quote generated command lines in pg_ctl (Naoya Anzai and
       Tom Lane)
       This fix applies only to Windows.
     * Fix pg_dumpall to work when a source database sets
       default_transaction_read_only via "ALTER DATABASE SET" (Kevin
       Grittner)
       Previously, the generated script would fail during restore.
     * Fix pg_isready to handle its "-d" option properly (Fabrizio de
       Royes Mello and Fujii Masao)
     * Fix parsing of WAL file names in pg_receivexlog (Heikki
       Linnakangas)
       This error made pg_receivexlog unable to restart streaming after
       stopping, once at least 4 GB of WAL had been written.
     * Report out-of-disk-space failures properly in pg_upgrade (Peter
       Eisentraut)
     * Make ecpg search for quoted cursor names case-sensitively (Zoltan
       Boszormenyi)
     * Fix ecpg's processing of lists of variables declared varchar
       (Zoltan Boszormenyi)
     * Make "contrib/lo" defend against incorrect trigger definitions
       (Marc Cousin)
     * Update time zone data files to tzdata release 2013h for DST law
       changes in Argentina, Brazil, Jordan, Libya, Liechtenstein,
       Morocco, and Palestine. Also, new timezone abbreviations WIB, WIT,
       WITA for Indonesia.
     __________________________________________________________________

                                Release 9.3.1

     Release Date: 2013-10-10

   This release contains a variety of fixes from 9.3.0. For information
   about new features in the 9.3 major release, see the Section called
   Release 9.3.
     __________________________________________________________________

Migration to Version 9.3.1

   A dump/restore is not required for those running 9.3.X.

   However, if you use the hstore extension, see the first changelog
   entry.
     __________________________________________________________________

Changes

     * Ensure new-in-9.3 JSON functionality is added to the hstore
       extension during an update (Andrew Dunstan)
       Users who upgraded a pre-9.3 database containing hstore should
       execute
ALTER EXTENSION hstore UPDATE;
       after installing 9.3.1, to add two new JSON functions and a cast.
       (If hstore is already up to date, this command does nothing.)
     * Fix memory leak when creating B-tree indexes on range columns
       (Heikki Linnakangas)
     * Fix memory leak caused by lo_open() failure (Heikki Linnakangas)
     * Serializable snapshot fixes (Kevin Grittner, Heikki Linnakangas)
     * Fix deadlock bug in libpq when using SSL (Stephen Frost)
     * Fix timeline handling bugs in pg_receivexlog (Heikki Linnakangas,
       Andrew Gierth)
     * Prevent "CREATE FUNCTION" from checking "SET" variables unless
       function body checking is enabled (Tom Lane)
     * Remove rare inaccurate warning during vacuum of index-less tables
       (Heikki Linnakangas)
     __________________________________________________________________

                                 Release 9.3

     Release Date: 2013-09-09
     __________________________________________________________________

Overview

   Major enhancements in PostgreSQL 9.3 include:

     * Add materialized views
     * Make simple views auto-updatable
     * Add many features for the JSON data type, including operators and
       functions to extract elements from JSON values
     * Implement SQL-standard LATERAL option for FROM-clause subqueries
       and function calls
     * Allow foreign data wrappers to support writes
       (inserts/updates/deletes) on foreign tables
     * Add a Postgres foreign data wrapper to allow access to other
       Postgres servers
     * Add support for event triggers
     * Add optional ability to checksum data pages and report corruption
     * Prevent non-key-field row updates from blocking foreign key checks
     * Greatly reduce System V shared memory requirements

   The above items are explained in more detail in the sections below.
     __________________________________________________________________

Migration to Version 9.3

   A dump/restore using pg_dumpall, or use of pg_upgrade, is required for
   those wishing to migrate data from any previous release.

   Version 9.3 contains a number of changes that may affect compatibility
   with previous releases. Observe the following incompatibilities:
     __________________________________________________________________

Server Settings

     * Rename replication_timeout to wal_sender_timeout (Amit Kapila)
       This setting controls the WAL sender timeout.
     * Require superuser privileges to set commit_delay because it can now
       potentially delay other sessions (Simon Riggs)
     * Allow in-memory sorts to use their full memory allocation (Jeff
       Janes)
       Users who have set work_mem based on the previous behavior may need
       to revisit that setting.
     __________________________________________________________________

Other

     * Throw an error if a tuple to be updated or deleted has already been
       updated or deleted by a BEFORE trigger (Kevin Grittner)
       Formerly, the originally-intended update was silently skipped,
       resulting in logical inconsistency since the trigger might have
       propagated data to other places based on the intended update. Now
       an error is thrown to prevent the inconsistent results from being
       committed. If this change affects your application, the best
       solution is usually to move the data-propagation actions to an
       AFTER trigger.
       This error will also be thrown if a query invokes a volatile
       function that modifies rows that are later modified by the query
       itself. Such cases likewise previously resulted in silently
       skipping updates.
     * Change multicolumn ON UPDATE SET NULL/SET DEFAULT foreign key
       actions to affect all columns of the constraint, not just those
       changed in the "UPDATE" (Tom Lane)
       Previously, we would set only those referencing columns that
       correspond to referenced columns that were changed by the "UPDATE".
       This was what was required by SQL-92, but more recent editions of
       the SQL standard specify the new behavior.
     * Force cached plans to be replanned if the search_path changes (Tom
       Lane)
       Previously, cached plans already generated in the current session
       were not redone if the query was re-executed with a new search_path
       setting, resulting in surprising behavior.
     * Fix to_number() to properly handle a period used as a thousands
       separator (Tom Lane)
       Previously, a period was considered to be a decimal point even when
       the locale says it isn't and the D format code is used to specify
       use of the locale-specific decimal point. This resulted in wrong
       answers if FM format was also used.
     * Fix STRICT non-set-returning functions that have set-returning
       functions in their arguments to properly return null rows (Tom
       Lane)
       A null value passed to the strict function should result in a null
       output, but instead, that output row was suppressed entirely.
     * Store WAL in a continuous stream, rather than skipping the last
       16MB segment every 4GB (Heikki Linnakangas)
       Previously, WAL files with names ending in FF were not used because
       of this skipping. If you have WAL backup or restore scripts that
       took this behavior into account, they will need to be adjusted.
     * In pg_constraint.confmatchtype, store the default foreign key match
       type (non-FULL, non-PARTIAL) as s for "simple" (Tom Lane)
       Previously this case was represented by u for "unspecified".
     __________________________________________________________________

Changes

   Below you will find a detailed account of the changes between
   PostgreSQL 9.3 and the previous major release.
     __________________________________________________________________

Server

Locking

     * Prevent non-key-field row updates from blocking foreign key checks
       (Alvaro Herrera, Noah Misch, Andres Freund, Alexander Shulgin,
       Marti Raudsepp, Alexander Shulgin)
       This change improves concurrency and reduces the probability of
       deadlocks when updating tables involved in a foreign-key
       constraint. "UPDATE"s that do not change any columns referenced in
       a foreign key now take the new NO KEY UPDATE lock mode on the row,
       while foreign key checks use the new KEY SHARE lock mode, which
       does not conflict with NO KEY UPDATE. So there is no blocking
       unless a foreign-key column is changed.
     * Add configuration variable lock_timeout to allow limiting how long
       a session will wait to acquire any one lock (Zoltan Boszormenyi)
     __________________________________________________________________

Indexes

     * Add SP-GiST support for range data types (Alexander Korotkov)
     * Allow GiST indexes to be unlogged (Jeevan Chalke)
     * Improve performance of GiST index insertion by randomizing the
       choice of which page to descend to when there are multiple equally
       good alternatives (Heikki Linnakangas)
     * Improve concurrency of hash index operations (Robert Haas)
     __________________________________________________________________

Optimizer

     * Collect and use histograms of upper and lower bounds, as well as
       range lengths, for range types (Alexander Korotkov)
     * Improve optimizer's cost estimation for index access (Tom Lane)
     * Improve optimizer's hash table size estimate for doing DISTINCT via
       hash aggregation (Tom Lane)
     * Suppress no-op Result and Limit plan nodes (Kyotaro Horiguchi, Amit
       Kapila, Tom Lane)
     * Reduce optimizer overhead by not keeping plans on the basis of
       cheap startup cost when the optimizer only cares about total cost
       overall (Tom Lane)
     __________________________________________________________________

General Performance

     * Add "COPY FREEZE" option to avoid the overhead of marking tuples as
       frozen later (Simon Riggs, Jeff Davis)
     * Improve performance of NUMERIC calculations (Kyotaro Horiguchi)
     * Improve synchronization of sessions waiting for commit_delay (Peter
       Geoghegan)
       This greatly improves the usefulness of commit_delay.
     * Improve performance of the "CREATE TEMPORARY TABLE ... ON COMMIT
       DELETE ROWS" option by not truncating such temporary tables in
       transactions that haven't touched any temporary tables (Heikki
       Linnakangas)
     * Make vacuum recheck visibility after it has removed expired tuples
       (Pavan Deolasee)
       This increases the chance of a page being marked as all-visible.
     * Add per-resource-owner lock caches (Jeff Janes)
       This speeds up lock bookkeeping at statement completion in
       multi-statement transactions that hold many locks; it is
       particularly useful for pg_dump.
     * Avoid scanning the entire relation cache at commit of a transaction
       that creates a new relation (Jeff Janes)
       This speeds up sessions that create many tables in successive small
       transactions, such as a pg_restore run.
     * Improve performance of transactions that drop many relations (Tomas
       Vondra)
     __________________________________________________________________

Monitoring

     * Add optional ability to checksum data pages and report corruption
       (Simon Riggs, Jeff Davis, Greg Smith, Ants Aasma)
       The checksum option can be set during initdb.
     * Split the statistics collector's data file into separate global and
       per-database files (Tomas Vondra)
       This reduces the I/O required for statistics tracking.
     * Fix the statistics collector to operate properly in cases where the
       system clock goes backwards (Tom Lane)
       Previously, statistics collection would stop until the time again
       reached the latest time previously recorded.
     * Emit an informative message to postmaster standard error when we
       are about to stop logging there (Tom Lane)
       This should help reduce user confusion about where to look for log
       output in common configurations that log to standard error only
       during postmaster startup.
     __________________________________________________________________

Authentication

     * When an authentication failure occurs, log the relevant
       "pg_hba.conf" line, to ease debugging of unintended failures
       (Magnus Hagander)
     * Improve LDAP error reporting and documentation (Peter Eisentraut)
     * Add support for specifying LDAP authentication parameters in URL
       format, per RFC 4516 (Peter Eisentraut)
     * Change the ssl_ciphers parameter to start with DEFAULT, rather than
       ALL, then remove insecure ciphers (Magnus Hagander)
       This should yield a more appropriate SSL cipher set.
     * Parse and load "pg_ident.conf" once, not during each connection
       (Amit Kapila)
       This is similar to how "pg_hba.conf" is processed.
     __________________________________________________________________

Server Settings

     * Greatly reduce System V shared memory requirements (Robert Haas)
       On Unix-like systems, mmap() is now used for most of PostgreSQL's
       shared memory. For most users, this will eliminate any need to
       adjust kernel parameters for shared memory.
     * Allow the postmaster to listen on multiple Unix-domain sockets
       (Honza Horak)
       The configuration parameter unix_socket_directory is replaced by
       unix_socket_directories, which accepts a list of directories.
     * Allow a directory of configuration files to be processed (Magnus
       Hagander, Greg Smith, Selena Deckelmann)
       Such a directory is specified with include_dir in the server
       configuration file.
     * Increase the maximum initdb-configured value for shared_buffers to
       128MB (Robert Haas)
       This is the maximum value that initdb will attempt to set in
       "postgresql.conf"; the previous maximum was 32MB.
     * Remove the external PID file, if any, on postmaster exit (Peter
       Eisentraut)
     __________________________________________________________________

Replication and Recovery

     * Allow a streaming replication standby to follow a timeline switch
       (Heikki Linnakangas)
       This allows streaming standby servers to receive WAL data from a
       slave newly promoted to master status. Previously, other standbys
       would require a resync to begin following the new master.
     * Add SQL functions pg_is_in_backup() and pg_backup_start_time()
       (Gilles Darold)
       These functions report the status of base backups.
     * Improve performance of streaming log shipping with
       synchronous_commit disabled (Andres Freund)
     * Allow much faster promotion of a streaming standby to primary
       (Simon Riggs, Kyotaro Horiguchi)
     * Add the last checkpoint's redo location to pg_controldata's output
       (Fujii Masao)
       This information is useful for determining which WAL files are
       needed for restore.
     * Allow tools like pg_receivexlog to run on computers with different
       architectures (Heikki Linnakangas)
       WAL files can still only be replayed on servers with the same
       architecture as the primary; but they can now be transmitted to and
       stored on machines of any architecture, since the streaming
       replication protocol is now machine-independent.
     * Make pg_basebackup "--write-recovery-conf" output a minimal
       "recovery.conf" file (Zoltan Boszormenyi, Magnus Hagander)
       This simplifies setting up a standby server.
     * Allow pg_receivexlog and pg_basebackup "--xlog-method" to handle
       streaming timeline switches (Heikki Linnakangas)
     * Add wal_receiver_timeout parameter to control the WAL receiver's
       timeout (Amit Kapila)
       This allows more rapid detection of connection failure.
     * Change the WAL record format to allow splitting the record header
       across pages (Heikki Linnakangas)
       The new format is slightly more compact, and is more efficient to
       write.
     __________________________________________________________________

Queries

     * Implement SQL-standard LATERAL option for FROM-clause subqueries
       and function calls (Tom Lane)
       This feature allows subqueries and functions in FROM to reference
       columns from other tables in the FROM clause. The LATERAL keyword
       is optional for functions.
     * Add support for piping "COPY" and psql "\copy" data to/from an
       external program (Etsuro Fujita)
     * Allow a multirow VALUES clause in a rule to reference OLD/NEW (Tom
       Lane)
     __________________________________________________________________

Object Manipulation

     * Add support for event triggers (Dimitri Fontaine, Robert Haas,
       Alvaro Herrera)
       This allows server-side functions written in event-enabled
       languages to be called when DDL commands are run.
     * Allow foreign data wrappers to support writes
       (inserts/updates/deletes) on foreign tables (KaiGai Kohei)
     * Add "CREATE SCHEMA ... IF NOT EXISTS" clause (Fabrizio de Royes
       Mello)
     * Make "REASSIGN OWNED" also change ownership of shared objects
       (Alvaro Herrera)
     * Make "CREATE AGGREGATE" complain if the given initial value string
       is not valid input for the transition datatype (Tom Lane)
     * Suppress "CREATE TABLE"'s messages about implicit index and
       sequence creation (Robert Haas)
       These messages now appear at DEBUG1 verbosity, so that they will
       not be shown by default.
     * Allow "DROP TABLE IF EXISTS" to succeed when a non-existent schema
       is specified in the table name (Bruce Momjian)
       Previously, it threw an error if the schema did not exist.
     * Provide clients with constraint violation details as separate
       fields (Pavel Stehule)
       This allows clients to retrieve table, column, data type, or
       constraint name error details. Previously such information had to
       be extracted from error strings. Client library support is required
       to access these fields.
     __________________________________________________________________

ALTER

     * Support IF NOT EXISTS option in "ALTER TYPE ... ADD VALUE" (Andrew
       Dunstan)
       This is useful for conditionally adding values to enumerated types.
     * Add "ALTER ROLE ALL SET" to establish settings for all users (Peter
       Eisentraut)
       This allows settings to apply to all users in all databases. "ALTER
       DATABASE SET" already allowed addition of settings for all users in
       a single database. "postgresql.conf" has a similar effect.
     * Add support for "ALTER RULE ... RENAME" (Ali Dar)
     __________________________________________________________________

VIEWs

     * Add materialized views (Kevin Grittner)
       Unlike ordinary views, where the base tables are read on every
       access, materialized views create physical tables at creation or
       refresh time. Access to the materialized view then reads from its
       physical table. There is not yet any facility for incrementally
       refreshing materialized views or auto-accessing them via base table
       access.
     * Make simple views auto-updatable (Dean Rasheed)
       Simple views that reference some or all columns from a single base
       table are now updatable by default. More complex views can be made
       updatable using INSTEAD OF triggers or INSTEAD rules.
     * Add "CREATE RECURSIVE VIEW" syntax (Peter Eisentraut)
       Internally this is translated into "CREATE VIEW ... WITH RECURSIVE
       ...".
     * Improve view/rule printing code to handle cases where referenced
       tables are renamed, or columns are renamed, added, or dropped (Tom
       Lane)
       Table and column renamings can produce cases where, if we merely
       substitute the new name into the original text of a rule or view,
       the result is ambiguous. This change fixes the rule-dumping code to
       insert manufactured table and column aliases when needed to
       preserve the original semantics.
     __________________________________________________________________

Data Types

     * Increase the maximum size of large objects from 2GB to 4TB (Nozomi
       Anzai, Yugo Nagata)
       This change includes adding 64-bit-capable large object access
       functions, both in the server and in libpq.
     * Allow text timezone designations, e.g. "America/Chicago", in the
       "T" field of ISO-format timestamptz input (Bruce Momjian)
     __________________________________________________________________

JSON

     * Add operators and functions to extract elements from JSON values
       (Andrew Dunstan)
     * Allow JSON values to be converted into records (Andrew Dunstan)
     * Add functions to convert scalars, records, and hstore values to
       JSON (Andrew Dunstan)
     __________________________________________________________________

Functions

     * Add array_remove() and array_replace() functions (Marco Nenciarini,
       Gabriele Bartolini)
     * Allow concat() and format() to properly expand VARIADIC-labeled
       arguments (Pavel Stehule)
     * Improve format() to provide field width and left/right alignment
       options (Pavel Stehule)
     * Make to_char(), to_date(), and to_timestamp() handle negative (BC)
       century values properly (Bruce Momjian)
       Previously the behavior was either wrong or inconsistent with
       positive/AD handling, e.g. with the format mask "IYYY-IW-DY".
     * Make to_date() and to_timestamp() return proper results when mixing
       ISO and Gregorian week/day designations (Bruce Momjian)
     * Cause pg_get_viewdef() to start a new line by default after each
       SELECT target list entry and FROM entry (Marko Tiikkaja)
       This reduces line length in view printing, for instance in pg_dump
       output.
     * Fix map_sql_value_to_xml_value() to print values of domain types
       the same way their base type would be printed (Pavel Stehule)
       There are special formatting rules for certain built-in types such
       as boolean; these rules now also apply to domains over these types.
     __________________________________________________________________

Server-Side Languages

PL/pgSQL Server-Side Language

     * Allow PL/pgSQL to use RETURN with a composite-type expression (Asif
       Rehman)
       Previously, in a function returning a composite type, RETURN could
       only reference a variable of that type.
     * Allow PL/pgSQL to access constraint violation details as separate
       fields (Pavel Stehule)
     * Allow PL/pgSQL to access the number of rows processed by "COPY"
       (Pavel Stehule)
       A "COPY" executed in a PL/pgSQL function now updates the value
       retrieved by "GET DIAGNOSTICS x = ROW_COUNT".
     * Allow unreserved keywords to be used as identifiers everywhere in
       PL/pgSQL (Tom Lane)
       In certain places in the PL/pgSQL grammar, keywords had to be
       quoted to be used as identifiers, even if they were nominally
       unreserved.
     __________________________________________________________________

PL/Python Server-Side Language

     * Add PL/Python result object string handler (Peter Eisentraut)
       This allows plpy.debug(rv) to output something reasonable.
     * Make PL/Python convert OID values to a proper Python numeric type
       (Peter Eisentraut)
     * Handle SPI errors raised explicitly (with PL/Python's RAISE) the
       same as internal SPI errors (Oskari Saarenmaa and Jan Urbanski)
     __________________________________________________________________

Server Programming Interface (SPI)

     * Prevent leakage of SPI tuple tables during subtransaction abort
       (Tom Lane)
       At the end of any failed subtransaction, the core SPI code now
       releases any SPI tuple tables that were created during that
       subtransaction. This avoids the need for SPI-using code to keep
       track of such tuple tables and release them manually in
       error-recovery code. Failure to do so caused a number of
       transaction-lifespan memory leakage issues in PL/pgSQL and perhaps
       other SPI clients. SPI_freetuptable() now protects itself against
       multiple freeing requests, so any existing code that did take care
       to clean up shouldn't be broken by this change.
     * Allow SPI functions to access the number of rows processed by
       "COPY" (Pavel Stehule)
     __________________________________________________________________

Client Applications

     * Add command-line utility pg_isready to check if the server is ready
       to accept connections (Phil Sorber)
     * Support multiple "--table" arguments for pg_restore, clusterdb,
       reindexdb, and vacuumdb (Josh Kupershmidt)
       This is similar to the way pg_dump's "--table" option works.
     * Add "--dbname" option to pg_dumpall, pg_basebackup, and
       pg_receivexlog to allow specifying a connection string (Amit
       Kapila)
     * Add libpq function PQconninfo() to return connection information
       (Zoltan Boszormenyi, Magnus Hagander)
     __________________________________________________________________

psql

     * Adjust function cost settings so psql tab completion and pattern
       searching are more efficient (Tom Lane)
     * Improve psql's tab completion coverage (Jeff Janes, Dean Rasheed,
       Peter Eisentraut, Magnus Hagander)
     * Allow the psql "--single-transaction" mode to work when reading
       from standard input (Fabien Coelho, Robert Haas)
       Previously this option only worked when reading from a file.
     * Remove psql warning when connecting to an older server (Peter
       Eisentraut)
       A warning is still issued when connecting to a server of a newer
       major version than psql's.
     __________________________________________________________________

Backslash Commands

     * Add psql command "\watch" to repeatedly execute a SQL command (Will
       Leinweber)
     * Add psql command "\gset" to store query results in psql variables
       (Pavel Stehule)
     * Add SSL information to psql's "\conninfo" command (Alastair Turner)
     * Add "Security" column to psql's "\df+" output (Jon Erdman)
     * Allow psql command "\l" to accept a database name pattern (Peter
       Eisentraut)
     * In psql, do not allow "\connect" to use defaults if there is no
       active connection (Bruce Momjian)
       This might be the case if the server had crashed.
     * Properly reset state after failure of a SQL command executed with
       psql's \g "file" (Tom Lane)
       Previously, the output from subsequent SQL commands would
       unexpectedly continue to go to the same file.
     __________________________________________________________________

Output

     * Add a latex-longtable output format to psql (Bruce Momjian)
       This format allows tables to span multiple pages.
     * Add a border=3 output mode to the psql latex format (Bruce Momjian)
     * In psql's tuples-only and expanded output modes, no longer emit
       "(No rows)" for zero rows (Peter Eisentraut)
     * In psql's unaligned, expanded output mode, no longer print an empty
       line for zero rows (Peter Eisentraut)
     __________________________________________________________________

pg_dump

     * Add pg_dump "--jobs" option to dump tables in parallel (Joachim
       Wieland)
     * Make pg_dump output functions in a more predictable order (Joel
       Jacobson)
     * Fix tar files emitted by pg_dump to be POSIX conformant (Brian
       Weaver, Tom Lane)
     * Add "--dbname" option to pg_dump, for consistency with other client
       commands (Heikki Linnakangas)
       The database name could already be supplied last without a flag.
     __________________________________________________________________

initdb

     * Make initdb fsync the newly created data directory (Jeff Davis)
       This insures data integrity in event of a system crash shortly
       after initdb. This can be disabled by using "--nosync".
     * Add initdb "--sync-only" option to sync the data directory to
       durable storage (Bruce Momjian)
       This is used by pg_upgrade.
     * Make initdb issue a warning about placing the data directory at the
       top of a file system mount point (Bruce Momjian)
     __________________________________________________________________

Source Code

     * Add infrastructure to allow plug-in background worker processes
       (Alvaro Herrera)
     * Create a centralized timeout API (Zoltan Boszormenyi)
     * Create libpgcommon and move pg_malloc() and other functions there
       (Alvaro Herrera, Andres Freund)
       This allows libpgport to be used solely for portability-related
       code.
     * Add support for list links embedded in larger structs (Andres
       Freund)
     * Use SA_RESTART for all signals, including SIGALRM (Tom Lane)
     * Ensure that the correct text domain is used when translating
       errcontext() messages (Heikki Linnakangas)
     * Standardize naming of client-side memory allocation functions (Tom
       Lane)
     * Provide support for "static assertions" that will fail at compile
       time if some compile-time-constant condition is not met (Andres
       Freund, Tom Lane)
     * Support Assert() in client-side code (Andrew Dunstan)
     * Add decoration to inform the C compiler that some ereport() and
       elog() calls do not return (Peter Eisentraut, Andres Freund, Tom
       Lane, Heikki Linnakangas)
     * Allow options to be passed to the regression test output comparison
       utility via PG_REGRESS_DIFF_OPTS (Peter Eisentraut)
     * Add isolation tests for "CREATE INDEX CONCURRENTLY" (Abhijit
       Menon-Sen)
     * Remove typedefs for int2/int4 as they are better represented as
       int16/int32 (Peter Eisentraut)
     * Fix install-strip on Mac OS X (Peter Eisentraut)
     * Remove configure flag "--disable-shared", as it is no longer
       supported (Bruce Momjian)
     * Rewrite pgindent in Perl (Andrew Dunstan)
     * Provide Emacs macro to set Perl formatting to match PostgreSQL's
       perltidy settings (Peter Eisentraut)
     * Run tool to check the keyword list whenever the backend grammar is
       changed (Tom Lane)
     * Change the way UESCAPE is lexed, to significantly reduce the size
       of the lexer tables (Heikki Linnakangas)
     * Centralize flex and bison make rules (Peter Eisentraut)
       This is useful for pgxs authors.
     * Change many internal backend functions to return object OIDs rather
       than void (Dimitri Fontaine)
       This is useful for event triggers.
     * Invent pre-commit/pre-prepare/pre-subcommit events for transaction
       callbacks (Tom Lane)
       Loadable modules that use transaction callbacks might need
       modification to handle these new event types.
     * Add function pg_identify_object() to produce a machine-readable
       description of a database object (Alvaro Herrera)
     * Add post-"ALTER"-object server hooks (KaiGai Kohei)
     * Implement a generic binary heap and use it for Merge-Append
       operations (Abhijit Menon-Sen)
     * Provide a tool to help detect timezone abbreviation changes when
       updating the "src/timezone/data" files (Tom Lane)
     * Add pkg-config support for libpq and ecpg libraries (Peter
       Eisentraut)
     * Remove "src/tool/backend", now that the content is on the
       PostgreSQL wiki (Bruce Momjian)
     * Split out WAL reading as an independent facility (Heikki
       Linnakangas, Andres Freund)
     * Use a 64-bit integer to represent WAL positions (XLogRecPtr)
       instead of two 32-bit integers (Heikki Linnakangas)
       Generally, tools that need to read the WAL format will need to be
       adjusted.
     * Allow PL/Python to support platform-specific include directories
       (Peter Eisentraut)
     * Allow PL/Python on OS X to build against custom versions of Python
       (Peter Eisentraut)
     __________________________________________________________________

Additional Modules

     * Add a Postgres foreign data wrapper contrib module to allow access
       to other Postgres servers (Shigeru Hanada)
       This foreign data wrapper supports writes.
     * Add pg_xlogdump contrib program (Andres Freund)
     * Add support for indexing of regular-expression searches in pg_trgm
       (Alexander Korotkov)
     * Improve pg_trgm's handling of multibyte characters (Tom Lane)
       On a platform that does not have the wcstombs() or towlower()
       library functions, this could result in an incompatible change in
       the contents of pg_trgm indexes for non-ASCII data. In such cases,
       "REINDEX" those indexes to ensure correct search results.
     * Add a pgstattuple function to report the size of the
       pending-insertions list of a GIN index (Fujii Masao)
     * Make oid2name, pgbench, and vacuumlo set fallback_application_name
       (Amit Kapila)
     * Improve output of pg_test_timing (Bruce Momjian)
     * Improve output of pg_test_fsync (Peter Geoghegan)
     * Create a dedicated foreign data wrapper, with its own option
       validator function, for dblink (Shigeru Hanada)
       When using this FDW to define the target of a dblink connection,
       instead of using a hard-wired list of connection options, the
       underlying libpq library is consulted to see what connection
       options it supports.
     __________________________________________________________________

pg_upgrade

     * Allow pg_upgrade to do dumps and restores in parallel (Bruce
       Momjian, Andrew Dunstan)
       This allows parallel schema dump/restore of databases, as well as
       parallel copy/link of data files per tablespace. Use the "--jobs"
       option to specify the level of parallelism.
     * Make pg_upgrade create Unix-domain sockets in the current directory
       (Bruce Momjian, Tom Lane)
       This reduces the possibility that someone will accidentally connect
       during the upgrade.
     * Make pg_upgrade "--check" mode properly detect the location of
       non-default socket directories (Bruce Momjian, Tom Lane)
     * Improve performance of pg_upgrade for databases with many tables
       (Bruce Momjian)
     * Improve pg_upgrade's logs by showing executed commands (Alvaro
       Herrera)
     * Improve pg_upgrade's status display during copy/link (Bruce
       Momjian)
     __________________________________________________________________

pgbench

     * Add "--foreign-keys" option to pgbench (Jeff Janes)
       This adds foreign key constraints to the standard tables created by
       pgbench, for use in foreign key performance testing.
     * Allow pgbench to aggregate performance statistics and produce
       output every "--aggregate-interval" seconds (Tomas Vondra)
     * Add pgbench "--sampling-rate" option to control the percentage of
       transactions logged (Tomas Vondra)
     * Reduce and improve the status message output of pgbench's
       initialization mode (Robert Haas, Peter Eisentraut)
     * Add pgbench "-q" mode to print one output line every five seconds
       (Tomas Vondra)
     * Output pgbench elapsed and estimated remaining time during
       initialization (Tomas Vondra)
     * Allow pgbench to use much larger scale factors, by changing
       relevant columns from integer to bigint when the requested scale
       factor exceeds 20000 (Greg Smith)
     __________________________________________________________________

Documentation

     * Allow EPUB-format documentation to be created (Peter Eisentraut)
     * Update FreeBSD kernel configuration documentation (Brad Davis)
     * Improve WINDOW function documentation (Bruce Momjian, Florian
       Pflug)
     * Add instructions for setting up the documentation tool chain on Mac
       OS X (Peter Eisentraut)
     * Improve commit_delay documentation (Peter Geoghegan)
     __________________________________________________________________

                                Release 9.2.6

     Release Date: 2013-12-05

   This release contains a variety of fixes from 9.2.5. For information
   about new features in the 9.2 major release, see the Section called
   Release 9.2.
     __________________________________________________________________

Migration to Version 9.2.6

   A dump/restore is not required for those running 9.2.X.

   However, this release corrects a number of potential data corruption
   issues. See the first two changelog entries below to find out whether
   your installation has been affected and what steps you can take if so.

   Also, if you are upgrading from a version earlier than 9.2.4, see the
   release notes for 9.2.4.
     __________________________________________________________________

Changes

     * Fix "VACUUM"'s tests to see whether it can update relfrozenxid
       (Andres Freund)
       In some cases "VACUUM" (either manual or autovacuum) could
       incorrectly advance a table's relfrozenxid value, allowing tuples
       to escape freezing, causing those rows to become invisible once
       2^31 transactions have elapsed. The probability of data loss is
       fairly low since multiple incorrect advancements would need to
       happen before actual loss occurs, but it's not zero. In 9.2.0 and
       later, the probability of loss is higher, and it's also possible to
       get "could not access status of transaction" errors as a
       consequence of this bug. Users upgrading from releases 9.0.4 or
       8.4.8 or earlier are not affected, but all later versions contain
       the bug.
       The issue can be ameliorated by, after upgrading, vacuuming all
       tables in all databases while having vacuum_freeze_table_age set to
       zero. This will fix any latent corruption but will not be able to
       fix all pre-existing data errors. However, an installation can be
       presumed safe after performing this vacuuming if it has executed
       fewer than 2^31 update transactions in its lifetime (check this
       with SELECT txid_current() < 2^31).
     * Fix initialization of "pg_clog" and "pg_subtrans" during hot
       standby startup (Andres Freund, Heikki Linnakangas)
       This bug can cause data loss on standby servers at the moment they
       start to accept hot-standby queries, by marking committed
       transactions as uncommitted. The likelihood of such corruption is
       small unless, at the time of standby startup, the primary server
       has executed many updating transactions since its last checkpoint.
       Symptoms include missing rows, rows that should have been deleted
       being still visible, and obsolete versions of updated rows being
       still visible alongside their newer versions.
       This bug was introduced in versions 9.3.0, 9.2.5, 9.1.10, and
       9.0.14. Standby servers that have only been running earlier
       releases are not at risk. It's recommended that standby servers
       that have ever run any of the buggy releases be re-cloned from the
       primary (e.g., with a new base backup) after upgrading.
     * Fix dangling-pointer problem in fast-path locking (Tom Lane)
       This could lead to corruption of the lock data structures in shared
       memory, causing "lock already held" and other odd errors.
     * Truncate "pg_multixact" contents during WAL replay (Andres Freund)
       This avoids ever-increasing disk space consumption in standby
       servers.
     * Ensure an anti-wraparound "VACUUM" counts a page as scanned when
       it's only verified that no tuples need freezing (Sergey Burladyan,
       Jeff Janes)
       This bug could result in failing to advance relfrozenxid, so that
       the table would still be thought to need another anti-wraparound
       vacuum. In the worst case the database might even shut down to
       prevent wraparound.
     * Fix race condition in GIN index posting tree page deletion (Heikki
       Linnakangas)
       This could lead to transient wrong answers or query failures.
     * Fix "unexpected spgdoinsert() failure" error during SP-GiST index
       creation (Teodor Sigaev)
     * Avoid flattening a subquery whose SELECT list contains a volatile
       function wrapped inside a sub-SELECT (Tom Lane)
       This avoids unexpected results due to extra evaluations of the
       volatile function.
     * Fix planner's processing of non-simple-variable subquery outputs
       nested within outer joins (Tom Lane)
       This error could lead to incorrect plans for queries involving
       multiple levels of subqueries within JOIN syntax.
     * Fix incorrect planning in cases where the same non-strict
       expression appears in multiple WHERE and outer JOIN equality
       clauses (Tom Lane)
     * Fix planner crash with whole-row reference to a subquery (Tom Lane)
     * Fix incorrect generation of optimized MIN()/MAX() plans for
       inheritance trees (Tom Lane)
       The planner could fail in cases where the MIN()/MAX() argument was
       an expression rather than a simple variable.
     * Fix premature deletion of temporary files (Andres Freund)
     * Prevent intra-transaction memory leak when printing range values
       (Tom Lane)
       This fix actually cures transient memory leaks in any datatype
       output function, but range types are the only ones known to have
       had a significant problem.
     * Prevent incorrect display of dropped columns in NOT NULL and CHECK
       constraint violation messages (Michael Paquier and Tom Lane)
     * Allow default arguments and named-argument notation for window
       functions (Tom Lane)
       Previously, these cases were likely to crash.
     * Fix possible read past end of memory in rule printing (Peter
       Eisentraut)
     * Fix array slicing of int2vector and oidvector values (Tom Lane)
       Expressions of this kind are now implicitly promoted to regular
       int2 or oid arrays.
     * Fix incorrect behaviors when using a SQL-standard, simple GMT
       offset timezone (Tom Lane)
       In some cases, the system would use the simple GMT offset value
       when it should have used the regular timezone setting that had
       prevailed before the simple offset was selected. This change also
       causes the timeofday function to honor the simple GMT offset zone.
     * Prevent possible misbehavior when logging translations of Windows
       error codes (Tom Lane)
     * Properly quote generated command lines in pg_ctl (Naoya Anzai and
       Tom Lane)
       This fix applies only to Windows.
     * Fix pg_dumpall to work when a source database sets
       default_transaction_read_only via "ALTER DATABASE SET" (Kevin
       Grittner)
       Previously, the generated script would fail during restore.
     * Make ecpg search for quoted cursor names case-sensitively (Zoltan
       Boszormenyi)
     * Fix ecpg's processing of lists of variables declared varchar
       (Zoltan Boszormenyi)
     * Make "contrib/lo" defend against incorrect trigger definitions
       (Marc Cousin)
     * Update time zone data files to tzdata release 2013h for DST law
       changes in Argentina, Brazil, Jordan, Libya, Liechtenstein,
       Morocco, and Palestine. Also, new timezone abbreviations WIB, WIT,
       WITA for Indonesia.
     __________________________________________________________________

                                Release 9.2.5

     Release Date: 2013-10-10

   This release contains a variety of fixes from 9.2.4. For information
   about new features in the 9.2 major release, see the Section called
   Release 9.2.
     __________________________________________________________________

Migration to Version 9.2.5

   A dump/restore is not required for those running 9.2.X.

   However, if you are upgrading from a version earlier than 9.2.4, see
   the release notes for 9.2.4.
     __________________________________________________________________

Changes

     * Prevent corruption of multi-byte characters when attempting to
       case-fold identifiers (Andrew Dunstan)
       PostgreSQL case-folds non-ASCII characters only when using a
       single-byte server encoding.
     * Fix memory leak when creating B-tree indexes on range columns
       (Heikki Linnakangas)
     * Fix checkpoint memory leak in background writer when wal_level =
       hot_standby (Naoya Anzai)
     * Fix memory leak caused by lo_open() failure (Heikki Linnakangas)
     * Fix memory overcommit bug when work_mem is using more than 24GB of
       memory (Stephen Frost)
     * Serializable snapshot fixes (Kevin Grittner, Heikki Linnakangas)
     * Fix deadlock bug in libpq when using SSL (Stephen Frost)
     * Fix possible SSL state corruption in threaded libpq applications
       (Nick Phillips, Stephen Frost)
     * Improve estimate of planner cost when choosing between generic and
       custom plans (Tom Lane)
       This change will favor generic plans when planning cost is high.
     * Properly compute row estimates for boolean columns containing many
       NULL values (Andrew Gierth)
       Previously tests like col IS NOT TRUE and col IS NOT FALSE did not
       properly factor in NULL values when estimating plan costs.
     * Fix accounting for qualifier evaluation costs in UNION ALL and
       inheritance queries (Tom Lane)
       This fixes cases where suboptimal query plans could be chosen if
       some WHERE clauses are expensive to calculate.
     * Prevent pushing down WHERE clauses into unsafe UNION/INTERSECT
       subqueries (Tom Lane)
       Subqueries of a UNION or INTERSECT that contain set-returning
       functions or volatile functions in their SELECT lists could be
       improperly optimized, leading to run-time errors or incorrect query
       results.
     * Fix rare case of "failed to locate grouping columns" planner
       failure (Tom Lane)
     * Fix pg_dump of foreign tables with dropped columns (Andrew Dunstan)
       Previously such cases could cause a pg_upgrade error.
     * Reorder pg_dump processing of extension-related rules and event
       triggers (Joe Conway)
     * Force dumping of extension tables if specified by "pg_dump -t" or
       -n (Joe Conway)
     * Improve view dumping code's handling of dropped columns in
       referenced tables (Tom Lane)
     * Fix "pg_restore -l" with the directory archive to display the
       correct format name (Fujii Masao)
     * Properly record index comments created using UNIQUE and PRIMARY KEY
       syntax (Andres Freund)
       This fixes a parallel pg_restore failure.
     * Cause "pg_basebackup -x" with an empty xlog directory to throw an
       error rather than crashing (Magnus Hagander, Haruka Takatsuka)
     * Properly guarantee transmission of WAL files before clean
       switchover (Fujii Masao)
       Previously, the streaming replication connection might close before
       all WAL files had been replayed on the standby.
     * Fix WAL segment timeline handling during recovery (Mitsumasa Kondo,
       Heikki Linnakangas)
       WAL file recycling during standby recovery could lead to premature
       recovery completion, resulting in data loss.
     * Fix "REINDEX TABLE" and "REINDEX DATABASE" to properly revalidate
       constraints and mark invalidated indexes as valid (Noah Misch)
       "REINDEX INDEX" has always worked properly.
     * Avoid deadlocks during insertion into SP-GiST indexes (Teodor
       Sigaev)
     * Fix possible deadlock during concurrent "CREATE INDEX CONCURRENTLY"
       operations (Tom Lane)
     * Fix GiST index lookup crash (Tom Lane)
     * Fix regexp_matches() handling of zero-length matches (Jeevan
       Chalke)
       Previously, zero-length matches like '^' could return too many
       matches.
     * Fix crash for overly-complex regular expressions (Heikki
       Linnakangas)
     * Fix regular expression match failures for back references combined
       with non-greedy quantifiers (Jeevan Chalke)
     * Prevent "CREATE FUNCTION" from checking "SET" variables unless
       function body checking is enabled (Tom Lane)
     * Allow "ALTER DEFAULT PRIVILEGES" to operate on schemas without
       requiring CREATE permission (Tom Lane)
     * Loosen restriction on keywords used in queries (Tom Lane)
       Specifically, lessen keyword restrictions for role names, language
       names, "EXPLAIN" and "COPY" options, and "SET" values. This allows
       COPY ... (FORMAT BINARY) to work as expected; previously BINARY
       needed to be quoted.
     * Print proper line number during "COPY" failure (Heikki Linnakangas)
     * Fix pgp_pub_decrypt() so it works for secret keys with passwords
       (Marko Kreen)
     * Make pg_upgrade use pg_dump --quote-all-identifiers to avoid
       problems with keyword changes between releases (Tom Lane)
     * Remove rare inaccurate warning during vacuum of index-less tables
       (Heikki Linnakangas)
     * Ensure that "VACUUM ANALYZE" still runs the ANALYZE phase if its
       attempt to truncate the file is cancelled due to lock conflicts
       (Kevin Grittner)
     * Avoid possible failure when performing transaction control commands
       (e.g "ROLLBACK") in prepared queries (Tom Lane)
     * Ensure that floating-point data input accepts standard spellings of
       "infinity" on all platforms (Tom Lane)
       The C99 standard says that allowable spellings are inf, +inf, -inf,
       infinity, +infinity, and -infinity. Make sure we recognize these
       even if the platform's strtod function doesn't.
     * Avoid unnecessary reporting when track_activities is off (Tom Lane)
     * Expand ability to compare rows to records and arrays (Rafal
       Rzepecki, Tom Lane)
     * Prevent crash when psql's PSQLRC variable contains a tilde (Bruce
       Momjian)
     * Add spinlock support for ARM64 (Mark Salter)
     * Update time zone data files to tzdata release 2013d for DST law
       changes in Israel, Morocco, Palestine, and Paraguay. Also,
       historical zone data corrections for Macquarie Island.
     __________________________________________________________________

                                Release 9.2.4

     Release Date: 2013-04-04

   This release contains a variety of fixes from 9.2.3. For information
   about new features in the 9.2 major release, see the Section called
   Release 9.2.
     __________________________________________________________________

Migration to Version 9.2.4

   A dump/restore is not required for those running 9.2.X.

   However, this release corrects several errors in management of GiST
   indexes. After installing this update, it is advisable to "REINDEX" any
   GiST indexes that meet one or more of the conditions described below.

   Also, if you are upgrading from a version earlier than 9.2.2, see the
   release notes for 9.2.2.
     __________________________________________________________________

Changes

     * Fix insecure parsing of server command-line switches (Mitsumasa
       Kondo, Kyotaro Horiguchi)
       A connection request containing a database name that begins with
       "-" could be crafted to damage or destroy files within the server's
       data directory, even if the request is eventually rejected.
       (CVE-2013-1899)
     * Reset OpenSSL randomness state in each postmaster child process
       (Marko Kreen)
       This avoids a scenario wherein random numbers generated by
       "contrib/pgcrypto" functions might be relatively easy for another
       database user to guess. The risk is only significant when the
       postmaster is configured with ssl = on but most connections don't
       use SSL encryption. (CVE-2013-1900)
     * Make REPLICATION privilege checks test current user not
       authenticated user (Noah Misch)
       An unprivileged database user could exploit this mistake to call
       pg_start_backup() or pg_stop_backup(), thus possibly interfering
       with creation of routine backups. (CVE-2013-1901)
     * Fix GiST indexes to not use "fuzzy" geometric comparisons when it's
       not appropriate to do so (Alexander Korotkov)
       The core geometric types perform comparisons using "fuzzy"
       equality, but gist_box_same must do exact comparisons, else GiST
       indexes using it might become inconsistent. After installing this
       update, users should "REINDEX" any GiST indexes on box, polygon,
       circle, or point columns, since all of these use gist_box_same.
     * Fix erroneous range-union and penalty logic in GiST indexes that
       use "contrib/btree_gist" for variable-width data types, that is
       text, bytea, bit, and numeric columns (Tom Lane)
       These errors could result in inconsistent indexes in which some
       keys that are present would not be found by searches, and also in
       useless index bloat. Users are advised to "REINDEX" such indexes
       after installing this update.
     * Fix bugs in GiST page splitting code for multi-column indexes (Tom
       Lane)
       These errors could result in inconsistent indexes in which some
       keys that are present would not be found by searches, and also in
       indexes that are unnecessarily inefficient to search. Users are
       advised to "REINDEX" multi-column GiST indexes after installing
       this update.
     * Fix gist_point_consistent to handle fuzziness consistently
       (Alexander Korotkov)
       Index scans on GiST indexes on point columns would sometimes yield
       results different from a sequential scan, because
       gist_point_consistent disagreed with the underlying operator code
       about whether to do comparisons exactly or fuzzily.
     * Fix buffer leak in WAL replay (Heikki Linnakangas)
       This bug could result in "incorrect local pin count" errors during
       replay, making recovery impossible.
     * Ensure we do crash recovery before entering archive recovery, if
       the database was not stopped cleanly and a "recovery.conf" file is
       present (Heikki Linnakangas, Kyotaro Horiguchi, Mitsumasa Kondo)
       This is needed to ensure that the database is consistent in certain
       scenarios, such as initializing a standby server with a filesystem
       snapshot from a running server.
     * Avoid deleting not-yet-archived WAL files during crash recovery
       (Heikki Linnakangas, Fujii Masao)
     * Fix race condition in "DELETE RETURNING" (Tom Lane)
       Under the right circumstances, "DELETE RETURNING" could attempt to
       fetch data from a shared buffer that the current process no longer
       has any pin on. If some other process changed the buffer meanwhile,
       this would lead to garbage RETURNING output, or even a crash.
     * Fix infinite-loop risk in regular expression compilation (Tom Lane,
       Don Porter)
     * Fix potential null-pointer dereference in regular expression
       compilation (Tom Lane)
     * Fix to_char() to use ASCII-only case-folding rules where
       appropriate (Tom Lane)
       This fixes misbehavior of some template patterns that should be
       locale-independent, but mishandled "I" and "i" in Turkish locales.
     * Fix unwanted rejection of timestamp 1999-12-31 24:00:00 (Tom Lane)
     * Fix SQL-language functions to be safely usable as support functions
       for range types (Tom Lane)
     * Fix logic error when a single transaction does "UNLISTEN" then
       "LISTEN" (Tom Lane)
       The session wound up not listening for notify events at all, though
       it surely should listen in this case.
     * Fix possible planner crash after columns have been added to a view
       that's depended on by another view (Tom Lane)
     * Fix performance issue in EXPLAIN (ANALYZE, TIMING OFF) (Pavel
       Stehule)
     * Remove useless "picksplit doesn't support secondary split" log
       messages (Josh Hansen, Tom Lane)
       This message seems to have been added in expectation of code that
       was never written, and probably never will be, since GiST's default
       handling of secondary splits is actually pretty good. So stop
       nagging end users about it.
     * Remove vestigial secondary-split support in gist_box_picksplit()
       (Tom Lane)
       Not only was this implementation of secondary-split not better than
       the default implementation, it's actually worse. So remove it and
       let the default code path handle the case.
     * Fix possible failure to send a session's last few transaction
       commit/abort counts to the statistics collector (Tom Lane)
     * Eliminate memory leaks in PL/Perl's spi_prepare() function (Alex
       Hunsaker, Tom Lane)
     * Fix pg_dumpall to handle database names containing "=" correctly
       (Heikki Linnakangas)
     * Avoid crash in pg_dump when an incorrect connection string is given
       (Heikki Linnakangas)
     * Ignore invalid indexes in pg_dump and pg_upgrade (Michael Paquier,
       Bruce Momjian)
       Dumping invalid indexes can cause problems at restore time, for
       example if the reason the index creation failed was because it
       tried to enforce a uniqueness condition not satisfied by the
       table's data. Also, if the index creation is in fact still in
       progress, it seems reasonable to consider it to be an uncommitted
       DDL change, which pg_dump wouldn't be expected to dump anyway.
       pg_upgrade now also skips invalid indexes rather than failing.
     * In pg_basebackup, include only the current server version's
       subdirectory when backing up a tablespace (Heikki Linnakangas)
     * Add a server version check in pg_basebackup and pg_receivexlog, so
       they fail cleanly with version combinations that won't work (Heikki
       Linnakangas)
     * Fix "contrib/dblink" to handle inconsistent settings of DateStyle
       or IntervalStyle safely (Daniel Farina, Tom Lane)
       Previously, if the remote server had different settings of these
       parameters, ambiguous dates might be read incorrectly. This fix
       ensures that datetime and interval columns fetched by a "dblink"
       query will be interpreted correctly. Note however that inconsistent
       settings are still risky, since literal values appearing in SQL
       commands sent to the remote server might be interpreted differently
       than they would be locally.
     * Fix "contrib/pg_trgm"'s similarity() function to return zero for
       trigram-less strings (Tom Lane)
       Previously it returned NaN due to internal division by zero.
     * Enable building PostgreSQL with Microsoft Visual Studio 2012 (Brar
       Piening, Noah Misch)
     * Update time zone data files to tzdata release 2013b for DST law
       changes in Chile, Haiti, Morocco, Paraguay, and some Russian areas.
       Also, historical zone data corrections for numerous places.
       Also, update the time zone abbreviation files for recent changes in
       Russia and elsewhere: CHOT, GET, IRKT, KGT, KRAT, MAGT, MAWT, MSK,
       NOVT, OMST, TKT, VLAT, WST, YAKT, YEKT now follow their current
       meanings, and VOLT (Europe/Volgograd) and MIST
       (Antarctica/Macquarie) are added to the default abbreviations list.
     __________________________________________________________________

                                Release 9.2.3

     Release Date: 2013-02-07

   This release contains a variety of fixes from 9.2.2. For information
   about new features in the 9.2 major release, see the Section called
   Release 9.2.
     __________________________________________________________________

Migration to Version 9.2.3

   A dump/restore is not required for those running 9.2.X.

   However, if you are upgrading from a version earlier than 9.2.2, see
   the release notes for 9.2.2.
     __________________________________________________________________

Changes

     * Prevent execution of enum_recv from SQL (Tom Lane)
       The function was misdeclared, allowing a simple SQL command to
       crash the server. In principle an attacker might be able to use it
       to examine the contents of server memory. Our thanks to Sumit Soni
       (via Secunia SVCRP) for reporting this issue. (CVE-2013-0255)
     * Fix multiple problems in detection of when a consistent database
       state has been reached during WAL replay (Fujii Masao, Heikki
       Linnakangas, Simon Riggs, Andres Freund)
     * Fix detection of end-of-backup point when no actual redo work is
       required (Heikki Linnakangas)
       This mistake could result in incorrect "WAL ends before end of
       online backup" errors.
     * Update minimum recovery point when truncating a relation file
       (Heikki Linnakangas)
       Once data has been discarded, it's no longer safe to stop recovery
       at an earlier point in the timeline.
     * Fix recycling of WAL segments after changing recovery target
       timeline (Heikki Linnakangas)
     * Properly restore timeline history files from archive on cascading
       standby servers (Heikki Linnakangas)
     * Fix lock conflict detection on hot-standby servers (Andres Freund,
       Robert Haas)
     * Fix missing cancellations in hot standby mode (Noah Misch, Simon
       Riggs)
       The need to cancel conflicting hot-standby queries would sometimes
       be missed, allowing those queries to see inconsistent data.
     * Prevent recovery pause feature from pausing before users can
       connect (Tom Lane)
     * Fix SQL grammar to allow subscripting or field selection from a
       sub-SELECT result (Tom Lane)
     * Fix performance problems with autovacuum truncation in busy
       workloads (Jan Wieck)
       Truncation of empty pages at the end of a table requires exclusive
       lock, but autovacuum was coded to fail (and release the table lock)
       when there are conflicting lock requests. Under load, it is easily
       possible that truncation would never occur, resulting in table
       bloat. Fix by performing a partial truncation, releasing the lock,
       then attempting to re-acquire the lock and continue. This fix also
       greatly reduces the average time before autovacuum releases the
       lock after a conflicting request arrives.
     * Improve performance of SPI_execute and related functions, thereby
       improving PL/pgSQL's EXECUTE (Heikki Linnakangas, Tom Lane)
       Remove some data-copying overhead that was added in 9.2 as a
       consequence of revisions in the plan caching mechanism. This
       eliminates a performance regression compared to 9.1, and also saves
       memory, especially when the query string to be executed contains
       many SQL statements.
       A side benefit is that multi-statement query strings are now
       processed fully serially, that is we complete execution of earlier
       statements before running parse analysis and planning on the
       following ones. This eliminates a long-standing issue, in that DDL
       that should affect the behavior of a later statement will now
       behave as expected.
     * Restore pre-9.2 cost estimates for index usage (Tom Lane)
       An ill-considered change of a fudge factor led to undesirably high
       cost estimates for use of very large indexes.
     * Fix intermittent crash in DROP INDEX CONCURRENTLY (Tom Lane)
     * Fix potential corruption of shared-memory lock table during
       "CREATE/DROP INDEX CONCURRENTLY" (Tom Lane)
     * Fix "COPY"'s multiple-tuple-insertion code for the case of a tuple
       larger than page size minus fillfactor (Heikki Linnakangas)
       The previous coding could get into an infinite loop.
     * Protect against race conditions when scanning pg_tablespace
       (Stephen Frost, Tom Lane)
       "CREATE DATABASE" and "DROP DATABASE" could misbehave if there were
       concurrent updates of pg_tablespace entries.
     * Prevent "DROP OWNED" from trying to drop whole databases or
       tablespaces (Alvaro Herrera)
       For safety, ownership of these objects must be reassigned, not
       dropped.
     * Fix error in vacuum_freeze_table_age implementation (Andres Freund)
       In installations that have existed for more than
       vacuum_freeze_min_age transactions, this mistake prevented
       autovacuum from using partial-table scans, so that a full-table
       scan would always happen instead.
     * Prevent misbehavior when a RowExpr or XmlExpr is parse-analyzed
       twice (Andres Freund, Tom Lane)
       This mistake could be user-visible in contexts such as CREATE TABLE
       LIKE INCLUDING INDEXES.
     * Improve defenses against integer overflow in hashtable sizing
       calculations (Jeff Davis)
     * Fix some bugs associated with privileges on datatypes (Tom Lane)
       There were some issues with default privileges for types, and
       pg_dump failed to dump such privileges at all.
     * Fix failure to ignore leftover temporary tables after a server
       crash (Tom Lane)
     * Fix failure to rotate postmaster log files for size reasons on
       Windows (Jeff Janes, Heikki Linnakangas)
     * Reject out-of-range dates in to_date() (Hitoshi Harada)
     * Fix pg_extension_config_dump() to handle extension-update cases
       properly (Tom Lane)
       This function will now replace any existing entry for the target
       table, making it usable in extension update scripts.
     * Fix PL/pgSQL's reporting of plan-time errors in possibly-simple
       expressions (Tom Lane)
       The previous coding resulted in sometimes omitting the first line
       in the CONTEXT traceback for the error.
     * Fix PL/Python's handling of functions used as triggers on multiple
       tables (Andres Freund)
     * Ensure that non-ASCII prompt strings are translated to the correct
       code page on Windows (Alexander Law, Noah Misch)
       This bug affected psql and some other client programs.
     * Fix possible crash in psql's "\?" command when not connected to a
       database (Meng Qingzhong)
     * Fix possible error if a relation file is removed while
       pg_basebackup is running (Heikki Linnakangas)
     * Tolerate timeline switches while pg_basebackup -X fetch is backing
       up a standby server (Heikki Linnakangas)
     * Make pg_dump exclude data of unlogged tables when running on a
       hot-standby server (Magnus Hagander)
       This would fail anyway because the data is not available on the
       standby server, so it seems most convenient to assume
       "--no-unlogged-table-data" automatically.
     * Fix pg_upgrade to deal with invalid indexes safely (Bruce Momjian)
     * Fix pg_upgrade's -O/-o options (Marti Raudsepp)
     * Fix one-byte buffer overrun in libpq's PQprintTuples (Xi Wang)
       This ancient function is not used anywhere by PostgreSQL itself,
       but it might still be used by some client code.
     * Make ecpglib use translated messages properly (Chen Huajun)
     * Properly install ecpg_compat and pgtypes libraries on MSVC (Jiang
       Guiqing)
     * Include our version of isinf() in libecpg if it's not provided by
       the system (Jiang Guiqing)
     * Rearrange configure's tests for supplied functions so it is not
       fooled by bogus exports from libedit/libreadline (Christoph Berg)
     * Ensure Windows build number increases over time (Magnus Hagander)
     * Make pgxs build executables with the right .exe suffix when
       cross-compiling for Windows (Zoltan Boszormenyi)
     * Add new timezone abbreviation FET (Tom Lane)
       This is now used in some eastern-European time zones.
     __________________________________________________________________

                                Release 9.2.2

     Release Date: 2012-12-06

   This release contains a variety of fixes from 9.2.1. For information
   about new features in the 9.2 major release, see the Section called
   Release 9.2.
     __________________________________________________________________

Migration to Version 9.2.2

   A dump/restore is not required for those running 9.2.X.

   However, you may need to perform "REINDEX" operations to correct
   problems in concurrently-built indexes, as described in the first
   changelog item below.

   Also, if you are upgrading from version 9.2.0, see the release notes
   for 9.2.1.
     __________________________________________________________________

Changes

     * Fix multiple bugs associated with "CREATE/DROP INDEX CONCURRENTLY"
       (Andres Freund, Tom Lane, Simon Riggs, Pavan Deolasee)
       An error introduced while adding "DROP INDEX CONCURRENTLY" allowed
       incorrect indexing decisions to be made during the initial phase of
       "CREATE INDEX CONCURRENTLY"; so that indexes built by that command
       could be corrupt. It is recommended that indexes built in 9.2.X
       with "CREATE INDEX CONCURRENTLY" be rebuilt after applying this
       update.
       In addition, fix "CREATE/DROP INDEX CONCURRENTLY" to use in-place
       updates when changing the state of an index's pg_index row. This
       prevents race conditions that could cause concurrent sessions to
       miss updating the target index, thus again resulting in corrupt
       concurrently-created indexes.
       Also, fix various other operations to ensure that they ignore
       invalid indexes resulting from a failed "CREATE INDEX CONCURRENTLY"
       command. The most important of these is "VACUUM", because an
       auto-vacuum could easily be launched on the table before corrective
       action can be taken to fix or remove the invalid index.
       Also fix "DROP INDEX CONCURRENTLY" to not disable insertions into
       the target index until all queries using it are done.
       Also fix misbehavior if "DROP INDEX CONCURRENTLY" is canceled: the
       previous coding could leave an un-droppable index behind.
     * Correct predicate locking for "DROP INDEX CONCURRENTLY" (Kevin
       Grittner)
       Previously, SSI predicate locks were processed at the wrong time,
       possibly leading to incorrect behavior of serializable transactions
       executing in parallel with the "DROP".
     * Fix buffer locking during WAL replay (Tom Lane)
       The WAL replay code was insufficiently careful about locking
       buffers when replaying WAL records that affect more than one page.
       This could result in hot standby queries transiently seeing
       inconsistent states, resulting in wrong answers or unexpected
       failures.
     * Fix an error in WAL generation logic for GIN indexes (Tom Lane)
       This could result in index corruption, if a torn-page failure
       occurred.
     * Fix an error in WAL replay logic for SP-GiST indexes (Tom Lane)
       This could result in index corruption after a crash, or on a
       standby server.
     * Fix incorrect detection of end-of-base-backup location during WAL
       recovery (Heikki Linnakangas)
       This mistake allowed hot standby mode to start up before the
       database reaches a consistent state.
     * Properly remove startup process's virtual XID lock when promoting a
       hot standby server to normal running (Simon Riggs)
       This oversight could prevent subsequent execution of certain
       operations such as "CREATE INDEX CONCURRENTLY".
     * Avoid bogus "out-of-sequence timeline ID" errors in standby mode
       (Heikki Linnakangas)
     * Prevent the postmaster from launching new child processes after
       it's received a shutdown signal (Tom Lane)
       This mistake could result in shutdown taking longer than it should,
       or even never completing at all without additional user action.
     * Fix the syslogger process to not fail when log_rotation_age exceeds
       2^31 milliseconds (about 25 days) (Tom Lane)
     * Fix WaitLatch() to return promptly when the requested timeout
       expires (Jeff Janes, Tom Lane)
       With the previous coding, a steady stream of non-wait-terminating
       interrupts could delay return from WaitLatch() indefinitely. This
       has been shown to be a problem for the autovacuum launcher process,
       and might cause trouble elsewhere as well.
     * Avoid corruption of internal hash tables when out of memory
       (Hitoshi Harada)
     * Prevent file descriptors for dropped tables from being held open
       past transaction end (Tom Lane)
       This should reduce problems with long-since-dropped tables
       continuing to occupy disk space.
     * Prevent database-wide crash and restart when a new child process is
       unable to create a pipe for its latch (Tom Lane)
       Although the new process must fail, there is no good reason to
       force a database-wide restart, so avoid that. This improves
       robustness when the kernel is nearly out of file descriptors.
     * Avoid planner crash with joins to unflattened subqueries (Tom Lane)
     * Fix planning of non-strict equivalence clauses above outer joins
       (Tom Lane)
       The planner could derive incorrect constraints from a clause
       equating a non-strict construct to something else, for example
       WHERE COALESCE(foo, 0) = 0 when foo is coming from the nullable
       side of an outer join. 9.2 showed this type of error in more cases
       than previous releases, but the basic bug has been there for a long
       time.
     * Fix "SELECT DISTINCT" with index-optimized MIN/MAX on an
       inheritance tree (Tom Lane)
       The planner would fail with "failed to re-find MinMaxAggInfo
       record" given this combination of factors.
     * Make sure the planner sees implicit and explicit casts as
       equivalent for all purposes, except in the minority of cases where
       there's actually a semantic difference (Tom Lane)
     * Include join clauses when considering whether partial indexes can
       be used for a query (Tom Lane)
       A strict join clause can be sufficient to establish an "x" IS NOT
       NULL predicate, for example. This fixes a planner regression in
       9.2, since previous versions could make comparable deductions.
     * Limit growth of planning time when there are many indexable join
       clauses for the same index (Tom Lane)
     * Improve planner's ability to prove exclusion constraints from
       equivalence classes (Tom Lane)
     * Fix partial-row matching in hashed subplans to handle cross-type
       cases correctly (Tom Lane)
       This affects multicolumn NOT IN subplans, such as WHERE (a, b) NOT
       IN (SELECT x, y FROM ...) when for instance b and y are int4 and
       int8 respectively. This mistake led to wrong answers or crashes
       depending on the specific datatypes involved.
     * Fix btree mark/restore functions to handle array keys (Tom Lane)
       This oversight could result in wrong answers from merge joins whose
       inner side is an index scan using an indexed_column = ANY(array)
       condition.
     * Revert patch for taking fewer snapshots (Tom Lane)
       The 9.2 change to reduce the number of snapshots taken during query
       execution led to some anomalous behaviors not seen in previous
       releases, because execution would proceed with a snapshot acquired
       before locking the tables used by the query. Thus, for example, a
       query would not be guaranteed to see updates committed by a
       preceding transaction even if that transaction had exclusive lock.
       We'll probably revisit this in future releases, but meanwhile put
       it back the way it was before 9.2.
     * Acquire buffer lock when re-fetching the old tuple for an AFTER ROW
       UPDATE/DELETE trigger (Andres Freund)
       In very unusual circumstances, this oversight could result in
       passing incorrect data to a trigger WHEN condition, or to the
       precheck logic for a foreign-key enforcement trigger. That could
       result in a crash, or in an incorrect decision about whether to
       fire the trigger.
     * Fix "ALTER COLUMN TYPE" to handle inherited check constraints
       properly (Pavan Deolasee)
       This worked correctly in pre-8.4 releases, and now works correctly
       in 8.4 and later.
     * Fix "ALTER EXTENSION SET SCHEMA"'s failure to move some subsidiary
       objects into the new schema (Alvaro Herrera, Dimitri Fontaine)
     * Handle "CREATE TABLE AS EXECUTE" correctly in extended query
       protocol (Tom Lane)
     * Don't modify the input parse tree in "DROP RULE IF NOT EXISTS" and
       "DROP TRIGGER IF NOT EXISTS" (Tom Lane)
       This mistake would cause errors if a cached statement of one of
       these types was re-executed.
     * Fix "REASSIGN OWNED" to handle grants on tablespaces (Alvaro
       Herrera)
     * Ignore incorrect pg_attribute entries for system columns for views
       (Tom Lane)
       Views do not have any system columns. However, we forgot to remove
       such entries when converting a table to a view. That's fixed
       properly for 9.3 and later, but in previous branches we need to
       defend against existing mis-converted views.
     * Fix rule printing to dump INSERT INTO table DEFAULT VALUES
       correctly (Tom Lane)
     * Guard against stack overflow when there are too many
       UNION/INTERSECT/EXCEPT clauses in a query (Tom Lane)
     * Prevent platform-dependent failures when dividing the minimum
       possible integer value by -1 (Xi Wang, Tom Lane)
     * Fix possible access past end of string in date parsing (Hitoshi
       Harada)
     * Fix failure to advance XID epoch if XID wraparound happens during a
       checkpoint and wal_level is hot_standby (Tom Lane, Andres Freund)
       While this mistake had no particular impact on PostgreSQL itself,
       it was bad for applications that rely on txid_current() and related
       functions: the TXID value would appear to go backwards.
     * Fix pg_terminate_backend() and pg_cancel_backend() to not throw
       error for a non-existent target process (Josh Kupershmidt)
       This case already worked as intended when called by a superuser,
       but not so much when called by ordinary users.
     * Fix display of pg_stat_replication.sync_state at a page boundary
       (Kyotaro Horiguchi)
     * Produce an understandable error message if the length of the path
       name for a Unix-domain socket exceeds the platform-specific limit
       (Tom Lane, Andrew Dunstan)
       Formerly, this would result in something quite unhelpful, such as
       "Non-recoverable failure in name resolution".
     * Fix memory leaks when sending composite column values to the client
       (Tom Lane)
     * Save some cycles by not searching for subtransaction locks at
       commit (Simon Riggs)
       In a transaction holding many exclusive locks, this useless
       activity could be quite costly.
     * Make pg_ctl more robust about reading the "postmaster.pid" file
       (Heikki Linnakangas)
       This fixes race conditions and possible file descriptor leakage.
     * Fix possible crash in psql if incorrectly-encoded data is presented
       and the client_encoding setting is a client-only encoding, such as
       SJIS (Jiang Guiqing)
     * Make pg_dump dump SEQUENCE SET items in the data not pre-data
       section of the archive (Tom Lane)
       This fixes an undesirable inconsistency between the meanings of
       "--data-only" and "--section=data", and also fixes dumping of
       sequences that are marked as extension configuration tables.
     * Fix pg_dump's handling of "DROP DATABASE" commands in "--clean"
       mode (Guillaume Lelarge)
       Beginning in 9.2.0, pg_dump --clean would issue a "DROP DATABASE"
       command, which was either useless or dangerous depending on the
       usage scenario. It no longer does that. This change also fixes the
       combination of "--clean" and "--create" to work sensibly, i.e.,
       emit "DROP DATABASE" then "CREATE DATABASE" before reconnecting to
       the target database.
     * Fix pg_dump for views with circular dependencies and no relation
       options (Tom Lane)
       The previous fix to dump relation options when a view is involved
       in a circular dependency didn't work right for the case that the
       view has no options; it emitted ALTER VIEW foo SET () which is
       invalid syntax.
     * Fix bugs in the "restore.sql" script emitted by pg_dump in tar
       output format (Tom Lane)
       The script would fail outright on tables whose names include
       upper-case characters. Also, make the script capable of restoring
       data in "--inserts" mode as well as the regular COPY mode.
     * Fix pg_restore to accept POSIX-conformant tar files (Brian Weaver,
       Tom Lane)
       The original coding of pg_dump's tar output mode produced files
       that are not fully conformant with the POSIX standard. This has
       been corrected for version 9.3. This patch updates previous
       branches so that they will accept both the incorrect and the
       corrected formats, in hopes of avoiding compatibility problems when
       9.3 comes out.
     * Fix tar files emitted by pg_basebackup to be POSIX conformant
       (Brian Weaver, Tom Lane)
     * Fix pg_resetxlog to locate "postmaster.pid" correctly when given a
       relative path to the data directory (Tom Lane)
       This mistake could lead to pg_resetxlog not noticing that there is
       an active postmaster using the data directory.
     * Fix libpq's lo_import() and lo_export() functions to report file
       I/O errors properly (Tom Lane)
     * Fix ecpg's processing of nested structure pointer variables
       (Muhammad Usama)
     * Fix ecpg's ecpg_get_data function to handle arrays properly
       (Michael Meskes)
     * Prevent pg_upgrade from trying to process TOAST tables for system
       catalogs (Bruce Momjian)
       This fixes an error seen when the information_schema has been
       dropped and recreated. Other failures were also possible.
     * Improve pg_upgrade performance by setting synchronous_commit to off
       in the new cluster (Bruce Momjian)
     * Make "contrib/pageinspect"'s btree page inspection functions take
       buffer locks while examining pages (Tom Lane)
     * Work around unportable behavior of malloc(0) and realloc(NULL, 0)
       (Tom Lane)
       On platforms where these calls return NULL, some code mistakenly
       thought that meant out-of-memory. This is known to have broken
       pg_dump for databases containing no user-defined aggregates. There
       might be other cases as well.
     * Ensure that make install for an extension creates the "extension"
       installation directory (Cedric Villemain)
       Previously, this step was missed if MODULEDIR was set in the
       extension's Makefile.
     * Fix pgxs support for building loadable modules on AIX (Tom Lane)
       Building modules outside the original source tree didn't work on
       AIX.
     * Update time zone data files to tzdata release 2012j for DST law
       changes in Cuba, Israel, Jordan, Libya, Palestine, Western Samoa,
       and portions of Brazil.
     __________________________________________________________________

                                Release 9.2.1

     Release Date: 2012-09-24

   This release contains a variety of fixes from 9.2.0. For information
   about new features in the 9.2 major release, see the Section called
   Release 9.2.
     __________________________________________________________________

Migration to Version 9.2.1

   A dump/restore is not required for those running 9.2.X.

   However, you may need to perform "REINDEX" and/or "VACUUM" operations
   to recover from the effects of the data corruption bug described in the
   first changelog item below.
     __________________________________________________________________

Changes

     * Fix persistence marking of shared buffers during WAL replay (Jeff
       Davis)
       This mistake can result in buffers not being written out during
       checkpoints, resulting in data corruption if the server later
       crashes without ever having written those buffers. Corruption can
       occur on any server following crash recovery, but it is
       significantly more likely to occur on standby slave servers since
       those perform much more WAL replay. There is a low probability of
       corruption of btree and GIN indexes. There is a much higher
       probability of corruption of table "visibility maps", which might
       lead to wrong answers from index-only scans. Table data proper
       cannot be corrupted by this bug.
       While no index corruption due to this bug is known to have occurred
       in the field, as a precautionary measure it is recommended that
       production installations "REINDEX" all btree and GIN indexes at a
       convenient time after upgrading to 9.2.1.
       Also, it is recommended to perform a "VACUUM" of all tables while
       having vacuum_freeze_table_age set to zero. This will fix any
       incorrect visibility map data. vacuum_cost_delay can be adjusted to
       reduce the performance impact of vacuuming, while causing it to
       take longer to finish.
     * Fix possible incorrect sorting of output from queries involving
       WHERE indexed_column IN (list_of_values) (Tom Lane)
     * Fix planner failure for queries involving GROUP BY expressions
       along with window functions and aggregates (Tom Lane)
     * Fix planner's assignment of executor parameters (Tom Lane)
       This error could result in wrong answers from queries that scan the
       same WITH subquery multiple times.
     * Improve planner's handling of join conditions in index scans (Tom
       Lane)
     * Improve selectivity estimation for text search queries involving
       prefixes, i.e. "word":* patterns (Tom Lane)
     * Fix delayed recognition of permissions changes (Tom Lane)
       A command that needed no locks other than ones its transaction
       already had might fail to notice a concurrent "GRANT" or "REVOKE"
       that committed since the start of its transaction.
     * Fix "ANALYZE" to not fail when a column is a domain over an array
       type (Tom Lane)
     * Prevent PL/Perl from crashing if a recursive PL/Perl function is
       redefined while being executed (Tom Lane)
     * Work around possible misoptimization in PL/Perl (Tom Lane)
       Some Linux distributions contain an incorrect version of
       "pthread.h" that results in incorrect compiled code in PL/Perl,
       leading to crashes if a PL/Perl function calls another one that
       throws an error.
     * Remove unnecessary dependency on pg_config from pg_upgrade (Peter
       Eisentraut)
     * Update time zone data files to tzdata release 2012f for DST law
       changes in Fiji
     __________________________________________________________________

                                 Release 9.2

     Release Date: 2012-09-10
     __________________________________________________________________

Overview

   This release has been largely focused on performance improvements,
   though new SQL features are not lacking. Work also continues in the
   area of replication support. Major enhancements include:

     * Allow queries to retrieve data only from indexes, avoiding heap
       access (index-only scans)
     * Allow the planner to generate custom plans for specific parameter
       values even when using prepared statements
     * Improve the planner's ability to use nested loops with inner index
       scans
     * Allow streaming replication slaves to forward data to other slaves
       (cascading replication)
     * Allow pg_basebackup to make base backups from standby servers
     * Add a pg_receivexlog tool to archive WAL file changes as they are
       written
     * Add the SP-GiST (Space-Partitioned GiST) index access method
     * Add support for range data types
     * Add a JSON data type
     * Add a security_barrier option for views
     * Allow libpq connection strings to have the format of a URI
     * Add a single-row processing mode to libpq for better handling of
       large result sets

   The above items are explained in more detail in the sections below.
     __________________________________________________________________

Migration to Version 9.2

   A dump/restore using pg_dump, or use of pg_upgrade, is required for
   those wishing to migrate data from any previous release.

   Version 9.2 contains a number of changes that may affect compatibility
   with previous releases. Observe the following incompatibilities:
     __________________________________________________________________

System Catalogs

     * Remove the spclocation field from pg_tablespace (Magnus Hagander)
       This field was duplicative of the symbolic links that actually
       define tablespace locations, and thus risked errors of omission
       when moving a tablespace. This change allows tablespace directories
       to be moved while the server is down, by manually adjusting the
       symbolic links. To replace this field, we have added
       pg_tablespace_location() to allow querying of the symbolic links.
     * Move tsvector most-common-element statistics to new pg_stats
       columns (Alexander Korotkov)
       Consult most_common_elems and most_common_elem_freqs for the data
       formerly available in most_common_vals and most_common_freqs for a
       tsvector column.
     __________________________________________________________________

Functions

     * Remove hstore's => operator (Robert Haas)
       Users should now use hstore(text, text). Since PostgreSQL 9.0, a
       warning message has been emitted when an operator named => is
       created because the SQL standard reserves that token for another
       use.
     * Ensure that xpath() escapes special characters in string values
       (Florian Pflug)
       Without this it is possible for the result not to be valid XML.
     * Make pg_relation_size() and friends return NULL if the object does
       not exist (Phil Sorber)
       This prevents queries that call these functions from returning
       errors immediately after a concurrent "DROP".
     * Make EXTRACT(EPOCH FROM timestamp without time zone) measure the
       epoch from local midnight, not UTC midnight (Tom Lane)
       This change reverts an ill-considered change made in release 7.3.
       Measuring from UTC midnight was inconsistent because it made the
       result dependent on the timezone setting, which computations for
       timestamp without time zone should not be. The previous behavior
       remains available by casting the input value to timestamp with time
       zone.
     * Properly parse time strings with trailing yesterday, today, and
       tomorrow (Dean Rasheed)
       Previously, SELECT '04:00:00 yesterday'::timestamp returned
       yesterday's date at midnight.
     * Fix to_date() and to_timestamp() to wrap incomplete dates toward
       2020 (Bruce Momjian)
       Previously, supplied years and year masks of less than four digits
       wrapped inconsistently.
     __________________________________________________________________

Object Modification

     * Prevent "ALTER DOMAIN" from working on non-domain types (Peter
       Eisentraut)
       Owner and schema changes were previously possible on non-domain
       types.
     * No longer forcibly lowercase procedural language names in "CREATE
       FUNCTION" (Robert Haas)
       While unquoted language identifiers are still lowercased, strings
       and quoted identifiers are no longer forcibly down-cased. Thus for
       example CREATE FUNCTION ... LANGUAGE 'C' will no longer work; it
       must be spelled 'c', or better omit the quotes.
     * Change system-generated names of foreign key enforcement triggers
       (Tom Lane)
       This change ensures that the triggers fire in the correct order in
       some corner cases involving self-referential foreign key
       constraints.
     __________________________________________________________________

Command-Line Tools

     * Provide consistent backquote, variable expansion, and quoted
       substring behavior in psql meta-command arguments (Tom Lane)
       Previously, such references were treated oddly when not separated
       by whitespace from adjacent text. For example 'FOO'BAR was output
       as FOO BAR (unexpected insertion of a space) and FOO'BAR'BAZ was
       output unchanged (not removing the quotes as most would expect).
     * No longer treat clusterdb table names as double-quoted; no longer
       treat reindexdb table and index names as double-quoted (Bruce
       Momjian)
       Users must now include double-quotes in the command arguments if
       quoting is wanted.
     * createuser no longer prompts for option settings by default (Peter
       Eisentraut)
       Use "--interactive" to obtain the old behavior.
     * Disable prompting for the user name in dropuser unless
       "--interactive" is specified (Peter Eisentraut)
     __________________________________________________________________

Server Settings

     * Add server parameters for specifying the locations of server-side
       SSL files (Peter Eisentraut)
       This allows changing the names and locations of the files that were
       previously hard-coded as "server.crt", "server.key", "root.crt",
       and "root.crl" in the data directory. *The server will no longer
       examine root.crt or root.crl by default*; to load these files, the
       associated parameters must be set to non-default values.
     * Remove the silent_mode parameter (Heikki Linnakangas)
       Similar behavior can be obtained with "pg_ctl start -l
       postmaster.log".
     * Remove the wal_sender_delay parameter, as it is no longer needed
       (Tom Lane)
     * Remove the custom_variable_classes parameter (Tom Lane)
       The checking provided by this setting was dubious. Now any setting
       can be prefixed by any class name.
     __________________________________________________________________

Monitoring

     * Rename pg_stat_activity.procpid to pid, to match other system
       tables (Magnus Hagander)
     * Create a separate pg_stat_activity column to report process state
       (Scott Mead, Magnus Hagander)
       The previous query and query_start values now remain available for
       an idle session, allowing enhanced analysis.
     * Rename pg_stat_activity.current_query to query because it is not
       cleared when the query completes (Magnus Hagander)
     * Change all SQL-level statistics timing values to be float8 columns
       measured in milliseconds (Tom Lane)
       This change eliminates the designed-in assumption that the values
       are accurate to microseconds and no more (since the float8 values
       can be fractional). The columns affected are
       pg_stat_user_functions.total_time,
       pg_stat_user_functions.self_time,
       pg_stat_xact_user_functions.total_time, and
       pg_stat_xact_user_functions.self_time. The statistics functions
       underlying these columns now also return float8 milliseconds,
       rather than bigint microseconds. "contrib/pg_stat_statements"'
       total_time column is now also measured in milliseconds.
     __________________________________________________________________

Changes

   Below you will find a detailed account of the changes between
   PostgreSQL 9.2 and the previous major release.
     __________________________________________________________________

Server

Performance

     * Allow queries to retrieve data only from indexes, avoiding heap
       access (Robert Haas, Ibrar Ahmed, Heikki Linnakangas, Tom Lane)
       This feature is often called index-only scans. Heap access can be
       skipped for heap pages containing only tuples that are visible to
       all sessions, as reported by the visibility map; so the benefit
       applies mainly to mostly-static data. The visibility map was made
       crash-safe as a necessary part of implementing this feature.
     * Add the SP-GiST (Space-Partitioned GiST) index access method
       (Teodor Sigaev, Oleg Bartunov, Tom Lane)
       SP-GiST is comparable to GiST in flexibility, but supports
       unbalanced partitioned search structures rather than balanced
       trees. For suitable problems, SP-GiST can be faster than GiST in
       both index build time and search time.
     * Allow group commit to work effectively under heavy load (Peter
       Geoghegan, Simon Riggs, Heikki Linnakangas)
       Previously, batching of commits became ineffective as the write
       workload increased, because of internal lock contention.
     * Allow uncontended locks to be managed using a new fast-path lock
       mechanism (Robert Haas)
     * Reduce overhead of creating virtual transaction ID locks (Robert
       Haas)
     * Reduce the overhead of serializable isolation level locks (Dan
       Ports)
     * Improve PowerPC and Itanium spinlock performance (Manabu Ori,
       Robert Haas, Tom Lane)
     * Reduce overhead for shared invalidation cache messages (Robert
       Haas)
     * Move the frequently accessed members of the PGPROC shared memory
       array to a separate array (Pavan Deolasee, Heikki Linnakangas,
       Robert Haas)
     * Improve "COPY" performance by adding tuples to the heap in batches
       (Heikki Linnakangas)
     * Improve GiST index performance for geometric data types by
       producing better trees with less memory allocation overhead
       (Alexander Korotkov)
     * Improve GiST index build times (Alexander Korotkov, Heikki
       Linnakangas)
     * Allow hint bits to be set sooner for temporary and unlogged tables
       (Robert Haas)
     * Allow sorting to be performed by inlined, non-SQL-callable
       comparison functions (Peter Geoghegan, Robert Haas, Tom Lane)
     * Make the number of CLOG buffers scale based on shared_buffers
       (Robert Haas, Simon Riggs, Tom Lane)
     * Improve performance of buffer pool scans that occur when tables or
       databases are dropped (Jeff Janes, Simon Riggs)
     * Improve performance of checkpointer's fsync-request queue when many
       tables are being dropped or truncated (Tom Lane)
     * Pass the safe number of file descriptors to child processes on
       Windows (Heikki Linnakangas)
       This allows Windows sessions to use more open file descriptors than
       before.
     __________________________________________________________________

Process Management

     * Create a dedicated background process to perform checkpoints (Simon
       Riggs)
       Formerly the background writer did both dirty-page writing and
       checkpointing. Separating this into two processes allows each goal
       to be accomplished more predictably.
     * Improve asynchronous commit behavior by waking the walwriter sooner
       (Simon Riggs)
       Previously, only wal_writer_delay triggered WAL flushing to disk;
       now filling a WAL buffer also triggers WAL writes.
     * Allow the bgwriter, walwriter, checkpointer, statistics collector,
       log collector, and archiver background processes to sleep more
       efficiently during periods of inactivity (Peter Geoghegan, Tom
       Lane)
       This series of changes reduces the frequency of process wake-ups
       when there is nothing to do, dramatically reducing power
       consumption on idle servers.
     __________________________________________________________________

Optimizer

     * Allow the planner to generate custom plans for specific parameter
       values even when using prepared statements (Tom Lane)
       In the past, a prepared statement always had a single "generic"
       plan that was used for all parameter values, which was frequently
       much inferior to the plans used for non-prepared statements
       containing explicit constant values. Now, the planner attempts to
       generate custom plans for specific parameter values. A generic plan
       will only be used after custom plans have repeatedly proven to
       provide no benefit. This change should eliminate the performance
       penalties formerly seen from use of prepared statements (including
       non-dynamic statements in PL/pgSQL).
     * Improve the planner's ability to use nested loops with inner index
       scans (Tom Lane)
       The new "parameterized path" mechanism allows inner index scans to
       use values from relations that are more than one join level up from
       the scan. This can greatly improve performance in situations where
       semantic restrictions (such as outer joins) limit the allowed join
       orderings.
     * Improve the planning API for foreign data wrappers (Etsuro Fujita,
       Shigeru Hanada, Tom Lane)
       Wrappers can now provide multiple access "paths" for their tables,
       allowing more flexibility in join planning.
     * Recognize self-contradictory restriction clauses for non-table
       relations (Tom Lane)
       This check is only performed when constraint_exclusion is on.
     * Allow indexed_col op ANY(ARRAY[...]) conditions to be used in plain
       index scans and index-only scans (Tom Lane)
       Formerly such conditions could only be used in bitmap index scans.
     * Support MIN/MAX index optimizations on boolean columns (Marti
       Raudsepp)
     * Account for set-returning functions in "SELECT" target lists when
       setting row count estimates (Tom Lane)
     * Fix planner to handle indexes with duplicated columns more reliably
       (Tom Lane)
     * Collect and use element-frequency statistics for arrays (Alexander
       Korotkov, Tom Lane)
       This change improves selectivity estimation for the array <@, &&,
       and @> operators (array containment and overlaps).
     * Allow statistics to be collected for foreign tables (Etsuro Fujita)
     * Improve cost estimates for use of partial indexes (Tom Lane)
     * Improve the planner's ability to use statistics for columns
       referenced in subqueries (Tom Lane)
     * Improve statistical estimates for subqueries using DISTINCT (Tom
       Lane)
     __________________________________________________________________

Authentication

     * Do not treat role names and samerole specified in "pg_hba.conf" as
       automatically including superusers (Andrew Dunstan)
       This makes it easier to use reject lines with group roles.
     * Adjust "pg_hba.conf" processing to handle token parsing more
       consistently (Brendan Jurd, Alvaro Herrera)
     * Disallow empty "pg_hba.conf" files (Tom Lane)
       This was done to more quickly detect misconfiguration.
     * Make superuser privilege imply replication privilege (Noah Misch)
       This avoids the need to explicitly assign such privileges.
     __________________________________________________________________

Monitoring

     * Attempt to log the current query string during a backend crash
       (Marti Raudsepp)
     * Make logging of autovacuum I/O activity more verbose (Greg Smith,
       Noah Misch)
       This logging is triggered by log_autovacuum_min_duration.
     * Make WAL replay report failures sooner (Fujii Masao)
       There were some cases where failures were only reported once the
       server went into master mode.
     * Add pg_xlog_location_diff() to simplify WAL location comparisons
       (Euler Taveira de Oliveira)
       This is useful for computing replication lag.
     * Support configurable event log application names on Windows
       (MauMau, Magnus Hagander)
       This allows different instances to use the event log with different
       identifiers, by setting the event_source server parameter, which is
       similar to how syslog_ident works.
     * Change "unexpected EOF" messages to DEBUG1 level, except when there
       is an open transaction (Magnus Hagander)
       This change reduces log chatter caused by applications that close
       database connections ungracefully.
     __________________________________________________________________

Statistical Views

     * Track temporary file sizes and file counts in the pg_stat_database
       system view (Tomas Vondra)
     * Add a deadlock counter to the pg_stat_database system view (Magnus
       Hagander)
     * Add a server parameter track_io_timing to track I/O timings (Ants
       Aasma, Robert Haas)
     * Report checkpoint timing information in pg_stat_bgwriter (Greg
       Smith, Peter Geoghegan)
     __________________________________________________________________

Server Settings

     * Silently ignore nonexistent schemas specified in search_path (Tom
       Lane)
       This makes it more convenient to use generic path settings, which
       might include some schemas that don't exist in all databases.
     * Allow superusers to set deadlock_timeout per-session, not just
       per-cluster (Noah Misch)
       This allows deadlock_timeout to be reduced for transactions that
       are likely to be involved in a deadlock, thus detecting the failure
       more quickly. Alternatively, increasing the value can be used to
       reduce the chances of a session being chosen for cancellation due
       to a deadlock.
     * Add a server parameter temp_file_limit to constrain temporary file
       space usage per session (Mark Kirkwood)
     * Allow a superuser to "SET" an extension's superuser-only custom
       variable before loading the associated extension (Tom Lane)
       The system now remembers whether a "SET" was performed by a
       superuser, so that proper privilege checking can be done when the
       extension is loaded.
     * Add postmaster "-C" option to query configuration parameters (Bruce
       Momjian)
       This allows pg_ctl to better handle cases where PGDATA or "-D"
       points to a configuration-only directory.
     * Replace an empty locale name with the implied value in "CREATE
       DATABASE" (Tom Lane)
       This prevents cases where pg_database.datcollate or datctype could
       be interpreted differently after a server restart.
     __________________________________________________________________

postgresql.conf

     * Allow multiple errors in "postgresql.conf" to be reported, rather
       than just the first one (Alexey Klyukin, Tom Lane)
     * Allow a reload of "postgresql.conf" to be processed by all
       sessions, even if there are some settings that are invalid for
       particular sessions (Alexey Klyukin)
       Previously, such not-valid-within-session values would cause all
       setting changes to be ignored by that session.
     * Add an include_if_exists facility for configuration files (Greg
       Smith)
       This works the same as include, except that an error is not thrown
       if the file is missing.
     * Identify the server time zone during initdb, and set
       "postgresql.conf" entries timezone and log_timezone accordingly
       (Tom Lane)
       This avoids expensive time zone probes during server start.
     * Fix pg_settings to report "postgresql.conf" line numbers on Windows
       (Tom Lane)
     __________________________________________________________________

Replication and Recovery

     * Allow streaming replication slaves to forward data to other slaves
       (cascading replication) (Fujii Masao)
       Previously, only the master server could supply streaming
       replication log files to standby servers.
     * Add new synchronous_commit mode remote_write (Fujii Masao, Simon
       Riggs)
       This mode waits for the standby server to write transaction data to
       its own operating system, but does not wait for the data to be
       flushed to the standby's disk.
     * Add a pg_receivexlog tool to archive WAL file changes as they are
       written, rather than waiting for completed WAL files (Magnus
       Hagander)
     * Allow pg_basebackup to make base backups from standby servers (Jun
       Ishizuka, Fujii Masao)
       This feature lets the work of making new base backups be off-loaded
       from the primary server.
     * Allow streaming of WAL files while pg_basebackup is performing a
       backup (Magnus Hagander)
       This allows passing of WAL files to the standby before they are
       discarded on the primary.
     __________________________________________________________________

Queries

     * Cancel the running query if the client gets disconnected (Florian
       Pflug)
       If the backend detects loss of client connection during a query, it
       will now cancel the query rather than attempting to finish it.
     * Retain column names at run time for row expressions (Andrew
       Dunstan, Tom Lane)
       This change allows better results when a row value is converted to
       hstore or json type: the fields of the resulting value will now
       have the expected names.
     * Improve column labels used for sub-"SELECT" results (Marti
       Raudsepp)
       Previously, the generic label ?column? was used.
     * Improve heuristics for determining the types of unknown values (Tom
       Lane)
       The longstanding rule that an unknown constant might have the same
       type as the value on the other side of the operator using it is now
       applied when considering polymorphic operators, not only for simple
       operator matches.
     * Warn about creating casts to or from domain types (Robert Haas)
       Such casts have no effect.
     * When a row fails a CHECK or NOT NULL constraint, show the row's
       contents as error detail (Jan Kundrat)
       This should make it easier to identify which row is problematic
       when an insert or update is processing many rows.
     __________________________________________________________________

Object Manipulation

     * Provide more reliable operation during concurrent DDL (Robert Haas,
       Noah Misch)
       This change adds locking that should eliminate "cache lookup
       failed" errors in many scenarios. Also, it is no longer possible to
       add relations to a schema that is being concurrently dropped, a
       scenario that formerly led to inconsistent system catalog contents.
     * Add CONCURRENTLY option to "DROP INDEX" (Simon Riggs)
       This allows index removal without blocking other sessions.
     * Allow foreign data wrappers to have per-column options (Shigeru
       Hanada)
     * Improve pretty-printing of view definitions (Andrew Dunstan)
     __________________________________________________________________

Constraints

     * Allow CHECK constraints to be declared NOT VALID (Alvaro Herrera)
       Adding a NOT VALID constraint does not cause the table to be
       scanned to verify that existing rows meet the constraint.
       Subsequently, newly added or updated rows are checked. Such
       constraints are ignored by the planner when considering
       constraint_exclusion, since it is not certain that all rows meet
       the constraint.
       The new "ALTER TABLE VALIDATE" command allows NOT VALID constraints
       to be checked for existing rows, after which they are converted
       into ordinary constraints.
     * Allow CHECK constraints to be declared NO INHERIT (Nikhil Sontakke,
       Alex Hunsaker, Alvaro Herrera)
       This makes them enforceable only on the parent table, not on child
       tables.
     * Add the ability to rename constraints (Peter Eisentraut)
     __________________________________________________________________

ALTER

     * Reduce need to rebuild tables and indexes for certain "ALTER TABLE"
       ... ALTER COLUMN TYPE operations (Noah Misch)
       Increasing the length limit for a varchar or varbit column, or
       removing the limit altogether, no longer requires a table rewrite.
       Similarly, increasing the allowable precision of a numeric column,
       or changing a column from constrained numeric to unconstrained
       numeric, no longer requires a table rewrite. Table rewrites are
       also avoided in similar cases involving the interval, timestamp,
       and timestamptz types.
     * Avoid having "ALTER TABLE" revalidate foreign key constraints in
       some cases where it is not necessary (Noah Misch)
     * Add IF EXISTS options to some "ALTER" commands (Pavel Stehule)
       For example, "ALTER FOREIGN TABLE IF EXISTS foo RENAME TO bar".
     * Add "ALTER FOREIGN DATA WRAPPER" ... RENAME and "ALTER SERVER" ...
       RENAME (Peter Eisentraut)
     * Add "ALTER DOMAIN" ... RENAME (Peter Eisentraut)
       You could already rename domains using "ALTER TYPE".
     * Throw an error for "ALTER DOMAIN" ... DROP CONSTRAINT on a
       nonexistent constraint (Peter Eisentraut)
       An IF EXISTS option has been added to provide the previous
       behavior.
     __________________________________________________________________

CREATE TABLE

     * Allow "CREATE TABLE (LIKE ...)" from foreign tables, views, and
       composite types (Peter Eisentraut)
       For example, this allows a table to be created whose schema matches
       a view.
     * Fix "CREATE TABLE (LIKE ...)" to avoid index name conflicts when
       copying index comments (Tom Lane)
     * Fix "CREATE TABLE" ... AS EXECUTE to handle WITH NO DATA and column
       name specifications (Tom Lane)
     __________________________________________________________________

Object Permissions

     * Add a security_barrier option for views (KaiGai Kohei, Robert Haas)
       This option prevents optimizations that might allow view-protected
       data to be exposed to users, for example pushing a clause involving
       an insecure function into the WHERE clause of the view. Such views
       can be expected to perform more poorly than ordinary views.
     * Add a new LEAKPROOF function attribute to mark functions that can
       safely be pushed down into security_barrier views (KaiGai Kohei)
     * Add support for privileges on data types (Peter Eisentraut)
       This adds support for the SQL-conforming USAGE privilege on types
       and domains. The intent is to be able to restrict which users can
       create dependencies on types, since such dependencies limit the
       owner's ability to alter the type.
     * Check for "INSERT" privileges in "SELECT INTO" / "CREATE TABLE AS"
       (KaiGai Kohei)
       Because the object is being created by "SELECT INTO" or "CREATE
       TABLE AS", the creator would ordinarily have insert permissions;
       but there are corner cases where this is not true, such as when
       ALTER DEFAULT PRIVILEGES has removed such permissions.
     __________________________________________________________________

Utility Operations

     * Allow "VACUUM" to more easily skip pages that cannot be locked
       (Simon Riggs, Robert Haas)
       This change should greatly reduce the incidence of "VACUUM" getting
       "stuck" waiting for other sessions.
     * Make "EXPLAIN" (BUFFERS) count blocks dirtied and written (Robert
       Haas)
     * Make "EXPLAIN ANALYZE" report the number of rows rejected by filter
       steps (Marko Tiikkaja)
     * Allow "EXPLAIN ANALYZE" to avoid timing overhead when time values
       are not wanted (Tomas Vondra)
       This is accomplished by setting the new TIMING option to FALSE.
     __________________________________________________________________

Data Types

     * Add support for range data types (Jeff Davis, Tom Lane, Alexander
       Korotkov)
       A range data type stores a lower and upper bound belonging to its
       base data type. It supports operations like contains, overlaps, and
       intersection.
     * Add a JSON data type (Robert Haas)
       This type stores JSON (JavaScript Object Notation) data with proper
       validation.
     * Add array_to_json() and row_to_json() (Andrew Dunstan)
     * Add a SMALLSERIAL data type (Mike Pultz)
       This is like SERIAL, except it stores the sequence in a two-byte
       integer column (int2).
     * Allow domains to be declared NOT VALID (Alvaro Herrera)
       This option can be set at domain creation time, or via "ALTER
       DOMAIN" ... ADD CONSTRAINT ... NOT VALID. "ALTER DOMAIN" ...
       VALIDATE CONSTRAINT fully validates the constraint.
     * Support more locale-specific formatting options for the money data
       type (Tom Lane)
       Specifically, honor all the POSIX options for ordering of the
       value, sign, and currency symbol in monetary output. Also, make
       sure that the thousands separator is only inserted to the left of
       the decimal point, as required by POSIX.
     * Add bitwise "and", "or", and "not" operators for the macaddr data
       type (Brendan Jurd)
     * Allow xpath() to return a single-element XML array when supplied a
       scalar value (Florian Pflug)
       Previously, it returned an empty array. This change will also cause
       xpath_exists() to return true, not false, for such expressions.
     * Improve XML error handling to be more robust (Florian Pflug)
     __________________________________________________________________

Functions

     * Allow non-superusers to use pg_cancel_backend() and
       pg_terminate_backend() on other sessions belonging to the same user
       (Magnus Hagander, Josh Kupershmidt, Dan Farina)
       Previously only superusers were allowed to use these functions.
     * Allow importing and exporting of transaction snapshots (Joachim
       Wieland, Tom Lane)
       This allows multiple transactions to share identical views of the
       database state. Snapshots are exported via pg_export_snapshot() and
       imported via "SET TRANSACTION SNAPSHOT". Only snapshots from
       currently-running transactions can be imported.
     * Support COLLATION FOR on expressions (Peter Eisentraut)
       This returns a string representing the collation of the expression.
     * Add pg_opfamily_is_visible() (Josh Kupershmidt)
     * Add a numeric variant of pg_size_pretty() for use with
       pg_xlog_location_diff() (Fujii Masao)
     * Add a pg_trigger_depth() function (Kevin Grittner)
       This reports the current trigger call depth.
     * Allow string_agg() to process bytea values (Pavel Stehule)
     * Fix regular expressions in which a back-reference occurs within a
       larger quantified subexpression (Tom Lane)
       For example, ^(\w+)( \1)+$. Previous releases did not check that
       the back-reference actually matched the first occurrence.
     __________________________________________________________________

Information Schema

     * Add information schema views role_udt_grants, udt_privileges, and
       user_defined_types (Peter Eisentraut)
     * Add composite-type attributes to the information schema
       element_types view (Peter Eisentraut)
     * Implement interval_type columns in the information schema (Peter
       Eisentraut)
       Formerly these columns read as nulls.
     * Implement collation-related columns in the information schema
       attributes, columns, domains, and element_types views (Peter
       Eisentraut)
     * Implement the with_hierarchy column in the information schema
       table_privileges view (Peter Eisentraut)
     * Add display of sequence USAGE privileges to information schema
       (Peter Eisentraut)
     * Make the information schema show default privileges (Peter
       Eisentraut)
       Previously, non-empty default permissions were not represented in
       the views.
     __________________________________________________________________

Server-Side Languages

PL/pgSQL Server-Side Language

     * Allow the PL/pgSQL "OPEN" cursor command to supply parameters by
       name (Yeb Havinga)
     * Add a "GET STACKED DIAGNOSTICS" PL/pgSQL command to retrieve
       exception info (Pavel Stehule)
     * Speed up PL/pgSQL array assignment by caching type information
       (Pavel Stehule)
     * Improve performance and memory consumption for long chains of ELSIF
       clauses (Tom Lane)
     * Output the function signature, not just the name, in PL/pgSQL error
       messages (Pavel Stehule)
     __________________________________________________________________

PL/Python Server-Side Language

     * Add PL/Python SPI cursor support (Jan Urbanski)
       This allows PL/Python to read partial result sets.
     * Add result metadata functions to PL/Python (Peter Eisentraut)
       Specifically, this adds result object functions .colnames,
       .coltypes, and .coltypmods.
     * Remove support for Python 2.2 (Peter Eisentraut)
     __________________________________________________________________

SQL Server-Side Language

     * Allow SQL-language functions to reference parameters by name
       (Matthew Draper)
       To use this, simply name the function arguments and then reference
       the argument names in the SQL function body.
     __________________________________________________________________

Client Applications

     * Add initdb options "--auth-local" and "--auth-host" (Peter
       Eisentraut)
       This allows separate control of local and host "pg_hba.conf"
       authentication settings. "--auth" still controls both.
     * Add "--replication"/"--no-replication" flags to createuser to
       control replication permission (Fujii Masao)
     * Add the "--if-exists" option to dropdb and dropuser (Josh
       Kupershmidt)
     * Give command-line tools the ability to specify the name of the
       database to connect to, and fall back to template1 if a postgres
       database connection fails (Robert Haas)
     __________________________________________________________________

psql

     * Add a display mode to auto-expand output based on the display width
       (Peter Eisentraut)
       This adds the auto option to the "\x" command, which switches to
       the expanded mode when the normal output would be wider than the
       screen.
     * Allow inclusion of a script file that is named relative to the
       directory of the file from which it was invoked (Gurjeet Singh)
       This is done with a new command "\ir".
     * Add support for non-ASCII characters in psql variable names (Tom
       Lane)
     * Add support for major-version-specific ".psqlrc" files (Bruce
       Momjian)
       psql already supported minor-version-specific ".psqlrc" files.
     * Provide environment variable overrides for psql history and startup
       file locations (Andrew Dunstan)
       PSQL_HISTORY and PSQLRC now determine these file names if set.
     * Add a "\setenv" command to modify the environment variables passed
       to child processes (Andrew Dunstan)
     * Name psql's temporary editor files with a ".sql" extension (Peter
       Eisentraut)
       This allows extension-sensitive editors to select the right mode.
     * Allow psql to use zero-byte field and record separators (Peter
       Eisentraut)
       Various shell tools use zero-byte (NUL) separators, e.g. find.
     * Make the "\timing" option report times for failed queries (Magnus
       Hagander)
       Previously times were reported only for successful queries.
     * Unify and tighten psql's treatment of "\copy" and SQL "COPY" (Noah
       Misch)
       This fix makes failure behavior more predictable and honors "\set
       ON_ERROR_ROLLBACK".
     __________________________________________________________________

Informational Commands

     * Make "\d" on a sequence show the table/column name owning it
       (Magnus Hagander)
     * Show statistics target for columns in "\d+" (Magnus Hagander)
     * Show role password expiration dates in "\du" (Fabrizio de Royes
       Mello)
     * Display comments for casts, conversions, domains, and languages
       (Josh Kupershmidt)
       These are included in the output of "\dC+", "\dc+", "\dD+", and
       "\dL" respectively.
     * Display comments for SQL/MED objects (Josh Kupershmidt)
       These are included in the output of "\des+", "\det+", and "\dew+"
       for foreign servers, foreign tables, and foreign data wrappers
       respectively.
     * Change "\dd" to display comments only for object types without
       their own backslash command (Josh Kupershmidt)
     __________________________________________________________________

Tab Completion

     * In psql tab completion, complete SQL keywords in either upper or
       lower case according to the new COMP_KEYWORD_CASE setting (Peter
       Eisentraut)
     * Add tab completion support for "EXECUTE" (Andreas Karlsson)
     * Allow tab completion of role references in "GRANT"/"REVOKE" (Peter
       Eisentraut)
     * Allow tab completion of file names to supply quotes, when necessary
       (Noah Misch)
     * Change tab completion support for "TABLE" to also include views
       (Magnus Hagander)
     __________________________________________________________________

pg_dump

     * Add an "--exclude-table-data" option to pg_dump (Andrew Dunstan)
       This allows dumping of a table's definition but not its data, on a
       per-table basis.
     * Add a "--section" option to pg_dump and pg_restore (Andrew Dunstan)
       Valid values are pre-data, data, and post-data. The option can be
       given more than once to select two or more sections.
     * Make pg_dumpall dump all roles first, then all configuration
       settings on roles (Phil Sorber)
       This allows a role's configuration settings to mention other roles
       without generating an error.
     * Allow pg_dumpall to avoid errors if the postgres database is
       missing in the new cluster (Robert Haas)
     * Dump foreign server user mappings in user name order (Peter
       Eisentraut)
       This helps produce deterministic dump files.
     * Dump operators in a predictable order (Peter Eisentraut)
     * Tighten rules for when extension configuration tables are dumped by
       pg_dump (Tom Lane)
     * Make pg_dump emit more useful dependency information (Tom Lane)
       The dependency links included in archive-format dumps were formerly
       of very limited use, because they frequently referenced objects
       that appeared nowhere in the dump. Now they represent actual
       dependencies (possibly indirect) among the dumped objects.
     * Improve pg_dump's performance when dumping many database objects
       (Tom Lane)
     __________________________________________________________________

libpq

     * Allow libpq connection strings to have the format of a URI
       (Alexander Shulgin)
       The syntax begins with postgres://. This can allow applications to
       avoid implementing their own parser for URIs representing database
       connections.
     * Add a connection option to disable SSL compression (Laurenz Albe)
       This can be used to remove the overhead of SSL compression on fast
       networks.
     * Add a single-row processing mode for better handling of large
       result sets (Kyotaro Horiguchi, Marko Kreen)
       Previously, libpq always collected the entire query result in
       memory before passing it back to the application.
     * Add const qualifiers to the declarations of the functions
       PQconnectdbParams, PQconnectStartParams, and PQpingParams (Lionel
       Elie Mamane)
     * Allow the ".pgpass" file to include escaped characters in the
       password field (Robert Haas)
     * Make library functions use abort() instead of exit() when it is
       necessary to terminate the process (Peter Eisentraut)
       This choice does not interfere with the normal exit codes used by
       the program, and generates a signal that can be caught by the
       caller.
     __________________________________________________________________

Source Code

     * Remove dead ports (Peter Eisentraut)
       The following platforms are no longer supported: dgux, nextstep,
       sunos4, svr4, ultrix4, univel, bsdi.
     * Add support for building with MS Visual Studio 2010 (Brar Piening)
     * Enable compiling with the MinGW-w64 32-bit compiler (Lars Kanis)
     * Install "plpgsql.h" into "include/server" during installation
       (Heikki Linnakangas)
     * Improve the latch facility to include detection of postmaster death
       (Peter Geoghegan, Heikki Linnakangas, Tom Lane)
       This eliminates one of the main reasons that background processes
       formerly had to wake up to poll for events.
     * Use C flexible array members, where supported (Peter Eisentraut)
     * Improve the concurrent transaction regression tests
       (isolationtester) (Noah Misch)
     * Modify thread_test to create its test files in the current
       directory, rather than "/tmp" (Bruce Momjian)
     * Improve flex and bison warning and error reporting (Tom Lane)
     * Add memory barrier support (Robert Haas)
       This is currently unused.
     * Modify pgindent to use a typedef file (Bruce Momjian)
     * Add a hook for processing messages due to be sent to the server log
       (Martin Pihlak)
     * Add object access hooks for "DROP" commands (KaiGai Kohei)
     * Centralize "DROP" handling for some object types (KaiGai Kohei)
     * Add a pg_upgrade test suite (Peter Eisentraut)
     * Sync regular expression code with TCL 8.5.11 and improve internal
       processing (Tom Lane)
     * Move CRC tables to libpgport, and provide them in a separate
       include file (Daniel Farina)
     * Add options to git_changelog for use in major release note creation
       (Bruce Momjian)
     * Support Linux's "/proc/self/oom_score_adj" API (Tom Lane)
     __________________________________________________________________

Additional Modules

     * Improve efficiency of dblink by using libpq's new single-row
       processing mode (Kyotaro Horiguchi, Marko Kreen)
       This improvement does not apply to
       dblink_send_query()/dblink_get_result().
     * Support force_not_null option in file_fdw (Shigeru Hanada)
     * Implement dry-run mode for pg_archivecleanup (Gabriele Bartolini)
       This only outputs the names of files to be deleted.
     * Add new pgbench switches "--unlogged-tables", "--tablespace", and
       "--index-tablespace" (Robert Haas)
     * Change pg_test_fsync to test for a fixed amount of time, rather
       than a fixed number of cycles (Bruce Momjian)
       The "-o"/cycles option was removed, and "-s"/seconds added.
     * Add a pg_test_timing utility to measure clock monotonicity and
       timing overhead (Ants Aasma, Greg Smith)
     * Add a tcn (triggered change notification) module to generate
       "NOTIFY" events on table changes (Kevin Grittner)
     __________________________________________________________________

pg_upgrade

     * Adjust pg_upgrade environment variables (Bruce Momjian)
       Rename data, bin, and port environment variables to begin with PG,
       and support PGPORTOLD/PGPORTNEW, to replace PGPORT.
     * Overhaul pg_upgrade logging and failure reporting (Bruce Momjian)
       Create four append-only log files, and delete them on success. Add
       "-r"/"--retain" option to unconditionally retain these files. Also
       remove pg_upgrade options "-g"/"-G"/"-l" options as unnecessary,
       and tighten log file permissions.
     * Make pg_upgrade create a script to incrementally generate more
       accurate optimizer statistics (Bruce Momjian)
       This reduces the time needed to generate minimal cluster statistics
       after an upgrade.
     * Allow pg_upgrade to upgrade an old cluster that does not have a
       postgres database (Bruce Momjian)
     * Allow pg_upgrade to handle cases where some old or new databases
       are missing, as long as they are empty (Bruce Momjian)
     * Allow pg_upgrade to handle configuration-only directory
       installations (Bruce Momjian)
     * In pg_upgrade, add "-o"/"-O" options to pass parameters to the
       servers (Bruce Momjian)
       This is useful for configuration-only directory installs.
     * Change pg_upgrade to use port 50432 by default (Bruce Momjian)
       This helps avoid unintended client connections during the upgrade.
     * Reduce cluster locking in pg_upgrade (Bruce Momjian)
       Specifically, only lock the old cluster if link mode is used, and
       do it right after the schema is restored.
     __________________________________________________________________

pg_stat_statements

     * Allow pg_stat_statements to aggregate similar queries via SQL text
       normalization (Peter Geoghegan, Tom Lane)
       Users with applications that use non-parameterized SQL will now be
       able to monitor query performance without detailed log analysis.
     * Add dirtied and written block counts and read/write times to
       pg_stat_statements (Robert Haas, Ants Aasma)
     * Prevent pg_stat_statements from double-counting "PREPARE" and
       "EXECUTE" commands (Tom Lane)
     __________________________________________________________________

sepgsql

     * Support SECURITY LABEL on global objects (KaiGai Kohei, Robert
       Haas)
       Specifically, add security labels to databases, tablespaces, and
       roles.
     * Allow sepgsql to honor database labels (KaiGai Kohei)
     * Perform sepgsql permission checks during the creation of various
       objects (KaiGai Kohei)
     * Add sepgsql_setcon() and related functions to control the sepgsql
       security domain (KaiGai Kohei)
     * Add a user space access cache to sepgsql to improve performance
       (KaiGai Kohei)
     __________________________________________________________________

Documentation

     * Add a rule to optionally build HTML documentation using the
       stylesheet from the website (Magnus Hagander)
       Use "gmake STYLE=website draft".
     * Improve "EXPLAIN" documentation (Tom Lane)
     * Document that user/database names are preserved with double-quoting
       by command-line tools like vacuumdb (Bruce Momjian)
     * Document the actual string returned by the client for MD5
       authentication (Cyan Ogilvie)
     * Deprecate use of GLOBAL and LOCAL in "CREATE TEMP TABLE" (Noah
       Misch)
       PostgreSQL has long treated these keyword as no-ops, and continues
       to do so; but in future they might mean what the SQL standard says
       they mean, so applications should avoid using them.
     __________________________________________________________________

                               Release 9.1.11

     Release Date: 2013-12-05

   This release contains a variety of fixes from 9.1.10. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.11

   A dump/restore is not required for those running 9.1.X.

   However, this release corrects a number of potential data corruption
   issues. See the first two changelog entries below to find out whether
   your installation has been affected and what steps you can take if so.

   Also, if you are upgrading from a version earlier than 9.1.9, see the
   release notes for 9.1.9.
     __________________________________________________________________

Changes

     * Fix "VACUUM"'s tests to see whether it can update relfrozenxid
       (Andres Freund)
       In some cases "VACUUM" (either manual or autovacuum) could
       incorrectly advance a table's relfrozenxid value, allowing tuples
       to escape freezing, causing those rows to become invisible once
       2^31 transactions have elapsed. The probability of data loss is
       fairly low since multiple incorrect advancements would need to
       happen before actual loss occurs, but it's not zero. Users
       upgrading from releases 9.0.4 or 8.4.8 or earlier are not affected,
       but all later versions contain the bug.
       The issue can be ameliorated by, after upgrading, vacuuming all
       tables in all databases while having vacuum_freeze_table_age set to
       zero. This will fix any latent corruption but will not be able to
       fix all pre-existing data errors. However, an installation can be
       presumed safe after performing this vacuuming if it has executed
       fewer than 2^31 update transactions in its lifetime (check this
       with SELECT txid_current() < 2^31).
     * Fix initialization of "pg_clog" and "pg_subtrans" during hot
       standby startup (Andres Freund, Heikki Linnakangas)
       This bug can cause data loss on standby servers at the moment they
       start to accept hot-standby queries, by marking committed
       transactions as uncommitted. The likelihood of such corruption is
       small unless, at the time of standby startup, the primary server
       has executed many updating transactions since its last checkpoint.
       Symptoms include missing rows, rows that should have been deleted
       being still visible, and obsolete versions of updated rows being
       still visible alongside their newer versions.
       This bug was introduced in versions 9.3.0, 9.2.5, 9.1.10, and
       9.0.14. Standby servers that have only been running earlier
       releases are not at risk. It's recommended that standby servers
       that have ever run any of the buggy releases be re-cloned from the
       primary (e.g., with a new base backup) after upgrading.
     * Truncate "pg_multixact" contents during WAL replay (Andres Freund)
       This avoids ever-increasing disk space consumption in standby
       servers.
     * Fix race condition in GIN index posting tree page deletion (Heikki
       Linnakangas)
       This could lead to transient wrong answers or query failures.
     * Avoid flattening a subquery whose SELECT list contains a volatile
       function wrapped inside a sub-SELECT (Tom Lane)
       This avoids unexpected results due to extra evaluations of the
       volatile function.
     * Fix planner's processing of non-simple-variable subquery outputs
       nested within outer joins (Tom Lane)
       This error could lead to incorrect plans for queries involving
       multiple levels of subqueries within JOIN syntax.
     * Fix incorrect generation of optimized MIN()/MAX() plans for
       inheritance trees (Tom Lane)
       The planner could fail in cases where the MIN()/MAX() argument was
       an expression rather than a simple variable.
     * Fix premature deletion of temporary files (Andres Freund)
     * Fix possible read past end of memory in rule printing (Peter
       Eisentraut)
     * Fix array slicing of int2vector and oidvector values (Tom Lane)
       Expressions of this kind are now implicitly promoted to regular
       int2 or oid arrays.
     * Fix incorrect behaviors when using a SQL-standard, simple GMT
       offset timezone (Tom Lane)
       In some cases, the system would use the simple GMT offset value
       when it should have used the regular timezone setting that had
       prevailed before the simple offset was selected. This change also
       causes the timeofday function to honor the simple GMT offset zone.
     * Prevent possible misbehavior when logging translations of Windows
       error codes (Tom Lane)
     * Properly quote generated command lines in pg_ctl (Naoya Anzai and
       Tom Lane)
       This fix applies only to Windows.
     * Fix pg_dumpall to work when a source database sets
       default_transaction_read_only via "ALTER DATABASE SET" (Kevin
       Grittner)
       Previously, the generated script would fail during restore.
     * Make ecpg search for quoted cursor names case-sensitively (Zoltan
       Boszormenyi)
     * Fix ecpg's processing of lists of variables declared varchar
       (Zoltan Boszormenyi)
     * Make "contrib/lo" defend against incorrect trigger definitions
       (Marc Cousin)
     * Update time zone data files to tzdata release 2013h for DST law
       changes in Argentina, Brazil, Jordan, Libya, Liechtenstein,
       Morocco, and Palestine. Also, new timezone abbreviations WIB, WIT,
       WITA for Indonesia.
     __________________________________________________________________

                               Release 9.1.10

     Release Date: 2013-10-10

   This release contains a variety of fixes from 9.1.9. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.10

   A dump/restore is not required for those running 9.1.X.

   However, if you are upgrading from a version earlier than 9.1.9, see
   the release notes for 9.1.9.
     __________________________________________________________________

Changes

     * Prevent corruption of multi-byte characters when attempting to
       case-fold identifiers (Andrew Dunstan)
       PostgreSQL case-folds non-ASCII characters only when using a
       single-byte server encoding.
     * Fix checkpoint memory leak in background writer when wal_level =
       hot_standby (Naoya Anzai)
     * Fix memory leak caused by lo_open() failure (Heikki Linnakangas)
     * Fix memory overcommit bug when work_mem is using more than 24GB of
       memory (Stephen Frost)
     * Serializable snapshot fixes (Kevin Grittner, Heikki Linnakangas)
     * Fix deadlock bug in libpq when using SSL (Stephen Frost)
     * Fix possible SSL state corruption in threaded libpq applications
       (Nick Phillips, Stephen Frost)
     * Properly compute row estimates for boolean columns containing many
       NULL values (Andrew Gierth)
       Previously tests like col IS NOT TRUE and col IS NOT FALSE did not
       properly factor in NULL values when estimating plan costs.
     * Prevent pushing down WHERE clauses into unsafe UNION/INTERSECT
       subqueries (Tom Lane)
       Subqueries of a UNION or INTERSECT that contain set-returning
       functions or volatile functions in their SELECT lists could be
       improperly optimized, leading to run-time errors or incorrect query
       results.
     * Fix rare case of "failed to locate grouping columns" planner
       failure (Tom Lane)
     * Fix pg_dump of foreign tables with dropped columns (Andrew Dunstan)
       Previously such cases could cause a pg_upgrade error.
     * Reorder pg_dump processing of extension-related rules and event
       triggers (Joe Conway)
     * Force dumping of extension tables if specified by "pg_dump -t" or
       -n (Joe Conway)
     * Improve view dumping code's handling of dropped columns in
       referenced tables (Tom Lane)
     * Fix "pg_restore -l" with the directory archive to display the
       correct format name (Fujii Masao)
     * Properly record index comments created using UNIQUE and PRIMARY KEY
       syntax (Andres Freund)
       This fixes a parallel pg_restore failure.
     * Properly guarantee transmission of WAL files before clean
       switchover (Fujii Masao)
       Previously, the streaming replication connection might close before
       all WAL files had been replayed on the standby.
     * Fix WAL segment timeline handling during recovery (Mitsumasa Kondo,
       Heikki Linnakangas)
       WAL file recycling during standby recovery could lead to premature
       recovery completion, resulting in data loss.
     * Fix "REINDEX TABLE" and "REINDEX DATABASE" to properly revalidate
       constraints and mark invalidated indexes as valid (Noah Misch)
       "REINDEX INDEX" has always worked properly.
     * Fix possible deadlock during concurrent "CREATE INDEX CONCURRENTLY"
       operations (Tom Lane)
     * Fix regexp_matches() handling of zero-length matches (Jeevan
       Chalke)
       Previously, zero-length matches like '^' could return too many
       matches.
     * Fix crash for overly-complex regular expressions (Heikki
       Linnakangas)
     * Fix regular expression match failures for back references combined
       with non-greedy quantifiers (Jeevan Chalke)
     * Prevent "CREATE FUNCTION" from checking "SET" variables unless
       function body checking is enabled (Tom Lane)
     * Allow "ALTER DEFAULT PRIVILEGES" to operate on schemas without
       requiring CREATE permission (Tom Lane)
     * Loosen restriction on keywords used in queries (Tom Lane)
       Specifically, lessen keyword restrictions for role names, language
       names, "EXPLAIN" and "COPY" options, and "SET" values. This allows
       COPY ... (FORMAT BINARY) to work as expected; previously BINARY
       needed to be quoted.
     * Fix pgp_pub_decrypt() so it works for secret keys with passwords
       (Marko Kreen)
     * Make pg_upgrade use pg_dump --quote-all-identifiers to avoid
       problems with keyword changes between releases (Tom Lane)
     * Remove rare inaccurate warning during vacuum of index-less tables
       (Heikki Linnakangas)
     * Ensure that "VACUUM ANALYZE" still runs the ANALYZE phase if its
       attempt to truncate the file is cancelled due to lock conflicts
       (Kevin Grittner)
     * Avoid possible failure when performing transaction control commands
       (e.g "ROLLBACK") in prepared queries (Tom Lane)
     * Ensure that floating-point data input accepts standard spellings of
       "infinity" on all platforms (Tom Lane)
       The C99 standard says that allowable spellings are inf, +inf, -inf,
       infinity, +infinity, and -infinity. Make sure we recognize these
       even if the platform's strtod function doesn't.
     * Expand ability to compare rows to records and arrays (Rafal
       Rzepecki, Tom Lane)
     * Update time zone data files to tzdata release 2013d for DST law
       changes in Israel, Morocco, Palestine, and Paraguay. Also,
       historical zone data corrections for Macquarie Island.
     __________________________________________________________________

                                Release 9.1.9

     Release Date: 2013-04-04

   This release contains a variety of fixes from 9.1.8. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.9

   A dump/restore is not required for those running 9.1.X.

   However, this release corrects several errors in management of GiST
   indexes. After installing this update, it is advisable to "REINDEX" any
   GiST indexes that meet one or more of the conditions described below.

   Also, if you are upgrading from a version earlier than 9.1.6, see the
   release notes for 9.1.6.
     __________________________________________________________________

Changes

     * Fix insecure parsing of server command-line switches (Mitsumasa
       Kondo, Kyotaro Horiguchi)
       A connection request containing a database name that begins with
       "-" could be crafted to damage or destroy files within the server's
       data directory, even if the request is eventually rejected.
       (CVE-2013-1899)
     * Reset OpenSSL randomness state in each postmaster child process
       (Marko Kreen)
       This avoids a scenario wherein random numbers generated by
       "contrib/pgcrypto" functions might be relatively easy for another
       database user to guess. The risk is only significant when the
       postmaster is configured with ssl = on but most connections don't
       use SSL encryption. (CVE-2013-1900)
     * Make REPLICATION privilege checks test current user not
       authenticated user (Noah Misch)
       An unprivileged database user could exploit this mistake to call
       pg_start_backup() or pg_stop_backup(), thus possibly interfering
       with creation of routine backups. (CVE-2013-1901)
     * Fix GiST indexes to not use "fuzzy" geometric comparisons when it's
       not appropriate to do so (Alexander Korotkov)
       The core geometric types perform comparisons using "fuzzy"
       equality, but gist_box_same must do exact comparisons, else GiST
       indexes using it might become inconsistent. After installing this
       update, users should "REINDEX" any GiST indexes on box, polygon,
       circle, or point columns, since all of these use gist_box_same.
     * Fix erroneous range-union and penalty logic in GiST indexes that
       use "contrib/btree_gist" for variable-width data types, that is
       text, bytea, bit, and numeric columns (Tom Lane)
       These errors could result in inconsistent indexes in which some
       keys that are present would not be found by searches, and also in
       useless index bloat. Users are advised to "REINDEX" such indexes
       after installing this update.
     * Fix bugs in GiST page splitting code for multi-column indexes (Tom
       Lane)
       These errors could result in inconsistent indexes in which some
       keys that are present would not be found by searches, and also in
       indexes that are unnecessarily inefficient to search. Users are
       advised to "REINDEX" multi-column GiST indexes after installing
       this update.
     * Fix gist_point_consistent to handle fuzziness consistently
       (Alexander Korotkov)
       Index scans on GiST indexes on point columns would sometimes yield
       results different from a sequential scan, because
       gist_point_consistent disagreed with the underlying operator code
       about whether to do comparisons exactly or fuzzily.
     * Fix buffer leak in WAL replay (Heikki Linnakangas)
       This bug could result in "incorrect local pin count" errors during
       replay, making recovery impossible.
     * Fix race condition in "DELETE RETURNING" (Tom Lane)
       Under the right circumstances, "DELETE RETURNING" could attempt to
       fetch data from a shared buffer that the current process no longer
       has any pin on. If some other process changed the buffer meanwhile,
       this would lead to garbage RETURNING output, or even a crash.
     * Fix infinite-loop risk in regular expression compilation (Tom Lane,
       Don Porter)
     * Fix potential null-pointer dereference in regular expression
       compilation (Tom Lane)
     * Fix to_char() to use ASCII-only case-folding rules where
       appropriate (Tom Lane)
       This fixes misbehavior of some template patterns that should be
       locale-independent, but mishandled "I" and "i" in Turkish locales.
     * Fix unwanted rejection of timestamp 1999-12-31 24:00:00 (Tom Lane)
     * Fix logic error when a single transaction does "UNLISTEN" then
       "LISTEN" (Tom Lane)
       The session wound up not listening for notify events at all, though
       it surely should listen in this case.
     * Fix possible planner crash after columns have been added to a view
       that's depended on by another view (Tom Lane)
     * Remove useless "picksplit doesn't support secondary split" log
       messages (Josh Hansen, Tom Lane)
       This message seems to have been added in expectation of code that
       was never written, and probably never will be, since GiST's default
       handling of secondary splits is actually pretty good. So stop
       nagging end users about it.
     * Fix possible failure to send a session's last few transaction
       commit/abort counts to the statistics collector (Tom Lane)
     * Eliminate memory leaks in PL/Perl's spi_prepare() function (Alex
       Hunsaker, Tom Lane)
     * Fix pg_dumpall to handle database names containing "=" correctly
       (Heikki Linnakangas)
     * Avoid crash in pg_dump when an incorrect connection string is given
       (Heikki Linnakangas)
     * Ignore invalid indexes in pg_dump and pg_upgrade (Michael Paquier,
       Bruce Momjian)
       Dumping invalid indexes can cause problems at restore time, for
       example if the reason the index creation failed was because it
       tried to enforce a uniqueness condition not satisfied by the
       table's data. Also, if the index creation is in fact still in
       progress, it seems reasonable to consider it to be an uncommitted
       DDL change, which pg_dump wouldn't be expected to dump anyway.
       pg_upgrade now also skips invalid indexes rather than failing.
     * In pg_basebackup, include only the current server version's
       subdirectory when backing up a tablespace (Heikki Linnakangas)
     * Add a server version check in pg_basebackup and pg_receivexlog, so
       they fail cleanly with version combinations that won't work (Heikki
       Linnakangas)
     * Fix "contrib/pg_trgm"'s similarity() function to return zero for
       trigram-less strings (Tom Lane)
       Previously it returned NaN due to internal division by zero.
     * Update time zone data files to tzdata release 2013b for DST law
       changes in Chile, Haiti, Morocco, Paraguay, and some Russian areas.
       Also, historical zone data corrections for numerous places.
       Also, update the time zone abbreviation files for recent changes in
       Russia and elsewhere: CHOT, GET, IRKT, KGT, KRAT, MAGT, MAWT, MSK,
       NOVT, OMST, TKT, VLAT, WST, YAKT, YEKT now follow their current
       meanings, and VOLT (Europe/Volgograd) and MIST
       (Antarctica/Macquarie) are added to the default abbreviations list.
     __________________________________________________________________

                                Release 9.1.8

     Release Date: 2013-02-07

   This release contains a variety of fixes from 9.1.7. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.8

   A dump/restore is not required for those running 9.1.X.

   However, if you are upgrading from a version earlier than 9.1.6, see
   the release notes for 9.1.6.
     __________________________________________________________________

Changes

     * Prevent execution of enum_recv from SQL (Tom Lane)
       The function was misdeclared, allowing a simple SQL command to
       crash the server. In principle an attacker might be able to use it
       to examine the contents of server memory. Our thanks to Sumit Soni
       (via Secunia SVCRP) for reporting this issue. (CVE-2013-0255)
     * Fix multiple problems in detection of when a consistent database
       state has been reached during WAL replay (Fujii Masao, Heikki
       Linnakangas, Simon Riggs, Andres Freund)
     * Update minimum recovery point when truncating a relation file
       (Heikki Linnakangas)
       Once data has been discarded, it's no longer safe to stop recovery
       at an earlier point in the timeline.
     * Fix recycling of WAL segments after changing recovery target
       timeline (Heikki Linnakangas)
     * Fix missing cancellations in hot standby mode (Noah Misch, Simon
       Riggs)
       The need to cancel conflicting hot-standby queries would sometimes
       be missed, allowing those queries to see inconsistent data.
     * Prevent recovery pause feature from pausing before users can
       connect (Tom Lane)
     * Fix SQL grammar to allow subscripting or field selection from a
       sub-SELECT result (Tom Lane)
     * Fix performance problems with autovacuum truncation in busy
       workloads (Jan Wieck)
       Truncation of empty pages at the end of a table requires exclusive
       lock, but autovacuum was coded to fail (and release the table lock)
       when there are conflicting lock requests. Under load, it is easily
       possible that truncation would never occur, resulting in table
       bloat. Fix by performing a partial truncation, releasing the lock,
       then attempting to re-acquire the lock and continue. This fix also
       greatly reduces the average time before autovacuum releases the
       lock after a conflicting request arrives.
     * Protect against race conditions when scanning pg_tablespace
       (Stephen Frost, Tom Lane)
       "CREATE DATABASE" and "DROP DATABASE" could misbehave if there were
       concurrent updates of pg_tablespace entries.
     * Prevent "DROP OWNED" from trying to drop whole databases or
       tablespaces (Alvaro Herrera)
       For safety, ownership of these objects must be reassigned, not
       dropped.
     * Fix error in vacuum_freeze_table_age implementation (Andres Freund)
       In installations that have existed for more than
       vacuum_freeze_min_age transactions, this mistake prevented
       autovacuum from using partial-table scans, so that a full-table
       scan would always happen instead.
     * Prevent misbehavior when a RowExpr or XmlExpr is parse-analyzed
       twice (Andres Freund, Tom Lane)
       This mistake could be user-visible in contexts such as CREATE TABLE
       LIKE INCLUDING INDEXES.
     * Improve defenses against integer overflow in hashtable sizing
       calculations (Jeff Davis)
     * Fix failure to ignore leftover temporary tables after a server
       crash (Tom Lane)
     * Reject out-of-range dates in to_date() (Hitoshi Harada)
     * Fix pg_extension_config_dump() to handle extension-update cases
       properly (Tom Lane)
       This function will now replace any existing entry for the target
       table, making it usable in extension update scripts.
     * Fix PL/Python's handling of functions used as triggers on multiple
       tables (Andres Freund)
     * Ensure that non-ASCII prompt strings are translated to the correct
       code page on Windows (Alexander Law, Noah Misch)
       This bug affected psql and some other client programs.
     * Fix possible crash in psql's "\?" command when not connected to a
       database (Meng Qingzhong)
     * Fix possible error if a relation file is removed while
       pg_basebackup is running (Heikki Linnakangas)
     * Make pg_dump exclude data of unlogged tables when running on a
       hot-standby server (Magnus Hagander)
       This would fail anyway because the data is not available on the
       standby server, so it seems most convenient to assume
       "--no-unlogged-table-data" automatically.
     * Fix pg_upgrade to deal with invalid indexes safely (Bruce Momjian)
     * Fix one-byte buffer overrun in libpq's PQprintTuples (Xi Wang)
       This ancient function is not used anywhere by PostgreSQL itself,
       but it might still be used by some client code.
     * Make ecpglib use translated messages properly (Chen Huajun)
     * Properly install ecpg_compat and pgtypes libraries on MSVC (Jiang
       Guiqing)
     * Include our version of isinf() in libecpg if it's not provided by
       the system (Jiang Guiqing)
     * Rearrange configure's tests for supplied functions so it is not
       fooled by bogus exports from libedit/libreadline (Christoph Berg)
     * Ensure Windows build number increases over time (Magnus Hagander)
     * Make pgxs build executables with the right .exe suffix when
       cross-compiling for Windows (Zoltan Boszormenyi)
     * Add new timezone abbreviation FET (Tom Lane)
       This is now used in some eastern-European time zones.
     __________________________________________________________________

                                Release 9.1.7

     Release Date: 2012-12-06

   This release contains a variety of fixes from 9.1.6. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.7

   A dump/restore is not required for those running 9.1.X.

   However, if you are upgrading from a version earlier than 9.1.6, see
   the release notes for 9.1.6.
     __________________________________________________________________

Changes

     * Fix multiple bugs associated with "CREATE INDEX CONCURRENTLY"
       (Andres Freund, Tom Lane)
       Fix "CREATE INDEX CONCURRENTLY" to use in-place updates when
       changing the state of an index's pg_index row. This prevents race
       conditions that could cause concurrent sessions to miss updating
       the target index, thus resulting in corrupt concurrently-created
       indexes.
       Also, fix various other operations to ensure that they ignore
       invalid indexes resulting from a failed "CREATE INDEX CONCURRENTLY"
       command. The most important of these is "VACUUM", because an
       auto-vacuum could easily be launched on the table before corrective
       action can be taken to fix or remove the invalid index.
     * Fix buffer locking during WAL replay (Tom Lane)
       The WAL replay code was insufficiently careful about locking
       buffers when replaying WAL records that affect more than one page.
       This could result in hot standby queries transiently seeing
       inconsistent states, resulting in wrong answers or unexpected
       failures.
     * Fix an error in WAL generation logic for GIN indexes (Tom Lane)
       This could result in index corruption, if a torn-page failure
       occurred.
     * Properly remove startup process's virtual XID lock when promoting a
       hot standby server to normal running (Simon Riggs)
       This oversight could prevent subsequent execution of certain
       operations such as "CREATE INDEX CONCURRENTLY".
     * Avoid bogus "out-of-sequence timeline ID" errors in standby mode
       (Heikki Linnakangas)
     * Prevent the postmaster from launching new child processes after
       it's received a shutdown signal (Tom Lane)
       This mistake could result in shutdown taking longer than it should,
       or even never completing at all without additional user action.
     * Avoid corruption of internal hash tables when out of memory
       (Hitoshi Harada)
     * Prevent file descriptors for dropped tables from being held open
       past transaction end (Tom Lane)
       This should reduce problems with long-since-dropped tables
       continuing to occupy disk space.
     * Prevent database-wide crash and restart when a new child process is
       unable to create a pipe for its latch (Tom Lane)
       Although the new process must fail, there is no good reason to
       force a database-wide restart, so avoid that. This improves
       robustness when the kernel is nearly out of file descriptors.
     * Fix planning of non-strict equivalence clauses above outer joins
       (Tom Lane)
       The planner could derive incorrect constraints from a clause
       equating a non-strict construct to something else, for example
       WHERE COALESCE(foo, 0) = 0 when foo is coming from the nullable
       side of an outer join.
     * Fix "SELECT DISTINCT" with index-optimized MIN/MAX on an
       inheritance tree (Tom Lane)
       The planner would fail with "failed to re-find MinMaxAggInfo
       record" given this combination of factors.
     * Improve planner's ability to prove exclusion constraints from
       equivalence classes (Tom Lane)
     * Fix partial-row matching in hashed subplans to handle cross-type
       cases correctly (Tom Lane)
       This affects multicolumn NOT IN subplans, such as WHERE (a, b) NOT
       IN (SELECT x, y FROM ...) when for instance b and y are int4 and
       int8 respectively. This mistake led to wrong answers or crashes
       depending on the specific datatypes involved.
     * Acquire buffer lock when re-fetching the old tuple for an AFTER ROW
       UPDATE/DELETE trigger (Andres Freund)
       In very unusual circumstances, this oversight could result in
       passing incorrect data to a trigger WHEN condition, or to the
       precheck logic for a foreign-key enforcement trigger. That could
       result in a crash, or in an incorrect decision about whether to
       fire the trigger.
     * Fix "ALTER COLUMN TYPE" to handle inherited check constraints
       properly (Pavan Deolasee)
       This worked correctly in pre-8.4 releases, and now works correctly
       in 8.4 and later.
     * Fix "ALTER EXTENSION SET SCHEMA"'s failure to move some subsidiary
       objects into the new schema (Alvaro Herrera, Dimitri Fontaine)
     * Fix "REASSIGN OWNED" to handle grants on tablespaces (Alvaro
       Herrera)
     * Ignore incorrect pg_attribute entries for system columns for views
       (Tom Lane)
       Views do not have any system columns. However, we forgot to remove
       such entries when converting a table to a view. That's fixed
       properly for 9.3 and later, but in previous branches we need to
       defend against existing mis-converted views.
     * Fix rule printing to dump INSERT INTO table DEFAULT VALUES
       correctly (Tom Lane)
     * Guard against stack overflow when there are too many
       UNION/INTERSECT/EXCEPT clauses in a query (Tom Lane)
     * Prevent platform-dependent failures when dividing the minimum
       possible integer value by -1 (Xi Wang, Tom Lane)
     * Fix possible access past end of string in date parsing (Hitoshi
       Harada)
     * Fix failure to advance XID epoch if XID wraparound happens during a
       checkpoint and wal_level is hot_standby (Tom Lane, Andres Freund)
       While this mistake had no particular impact on PostgreSQL itself,
       it was bad for applications that rely on txid_current() and related
       functions: the TXID value would appear to go backwards.
     * Fix display of pg_stat_replication.sync_state at a page boundary
       (Kyotaro Horiguchi)
     * Produce an understandable error message if the length of the path
       name for a Unix-domain socket exceeds the platform-specific limit
       (Tom Lane, Andrew Dunstan)
       Formerly, this would result in something quite unhelpful, such as
       "Non-recoverable failure in name resolution".
     * Fix memory leaks when sending composite column values to the client
       (Tom Lane)
     * Make pg_ctl more robust about reading the "postmaster.pid" file
       (Heikki Linnakangas)
       Fix race conditions and possible file descriptor leakage.
     * Fix possible crash in psql if incorrectly-encoded data is presented
       and the client_encoding setting is a client-only encoding, such as
       SJIS (Jiang Guiqing)
     * Make pg_dump dump SEQUENCE SET items in the data not pre-data
       section of the archive (Tom Lane)
       This change fixes dumping of sequences that are marked as extension
       configuration tables.
     * Fix bugs in the "restore.sql" script emitted by pg_dump in tar
       output format (Tom Lane)
       The script would fail outright on tables whose names include
       upper-case characters. Also, make the script capable of restoring
       data in "--inserts" mode as well as the regular COPY mode.
     * Fix pg_restore to accept POSIX-conformant tar files (Brian Weaver,
       Tom Lane)
       The original coding of pg_dump's tar output mode produced files
       that are not fully conformant with the POSIX standard. This has
       been corrected for version 9.3. This patch updates previous
       branches so that they will accept both the incorrect and the
       corrected formats, in hopes of avoiding compatibility problems when
       9.3 comes out.
     * Fix tar files emitted by pg_basebackup to be POSIX conformant
       (Brian Weaver, Tom Lane)
     * Fix pg_resetxlog to locate "postmaster.pid" correctly when given a
       relative path to the data directory (Tom Lane)
       This mistake could lead to pg_resetxlog not noticing that there is
       an active postmaster using the data directory.
     * Fix libpq's lo_import() and lo_export() functions to report file
       I/O errors properly (Tom Lane)
     * Fix ecpg's processing of nested structure pointer variables
       (Muhammad Usama)
     * Fix ecpg's ecpg_get_data function to handle arrays properly
       (Michael Meskes)
     * Make "contrib/pageinspect"'s btree page inspection functions take
       buffer locks while examining pages (Tom Lane)
     * Ensure that make install for an extension creates the "extension"
       installation directory (Cedric Villemain)
       Previously, this step was missed if MODULEDIR was set in the
       extension's Makefile.
     * Fix pgxs support for building loadable modules on AIX (Tom Lane)
       Building modules outside the original source tree didn't work on
       AIX.
     * Update time zone data files to tzdata release 2012j for DST law
       changes in Cuba, Israel, Jordan, Libya, Palestine, Western Samoa,
       and portions of Brazil.
     __________________________________________________________________

                                Release 9.1.6

     Release Date: 2012-09-24

   This release contains a variety of fixes from 9.1.5. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.6

   A dump/restore is not required for those running 9.1.X.

   However, you may need to perform "REINDEX" operations to recover from
   the effects of the data corruption bug described in the first changelog
   item below.

   Also, if you are upgrading from a version earlier than 9.1.4, see the
   release notes for 9.1.4.
     __________________________________________________________________

Changes

     * Fix persistence marking of shared buffers during WAL replay (Jeff
       Davis)
       This mistake can result in buffers not being written out during
       checkpoints, resulting in data corruption if the server later
       crashes without ever having written those buffers. Corruption can
       occur on any server following crash recovery, but it is
       significantly more likely to occur on standby slave servers since
       those perform much more WAL replay. There is a low probability of
       corruption of btree and GIN indexes. There is a much higher
       probability of corruption of table "visibility maps". Fortunately,
       visibility maps are non-critical data in 9.1, so the worst
       consequence of such corruption in 9.1 installations is transient
       inefficiency of vacuuming. Table data proper cannot be corrupted by
       this bug.
       While no index corruption due to this bug is known to have occurred
       in the field, as a precautionary measure it is recommended that
       production installations "REINDEX" all btree and GIN indexes at a
       convenient time after upgrading to 9.1.6.
       Also, if you intend to do an in-place upgrade to 9.2.X, before
       doing so it is recommended to perform a "VACUUM" of all tables
       while having vacuum_freeze_table_age set to zero. This will ensure
       that any lingering wrong data in the visibility maps is corrected
       before 9.2.X can depend on it. vacuum_cost_delay can be adjusted to
       reduce the performance impact of vacuuming, while causing it to
       take longer to finish.
     * Fix planner's assignment of executor parameters, and fix executor's
       rescan logic for CTE plan nodes (Tom Lane)
       These errors could result in wrong answers from queries that scan
       the same WITH subquery multiple times.
     * Fix misbehavior when default_transaction_isolation is set to
       serializable (Kevin Grittner, Tom Lane, Heikki Linnakangas)
       Symptoms include crashes at process start on Windows, and crashes
       in hot standby operation.
     * Improve selectivity estimation for text search queries involving
       prefixes, i.e. "word":* patterns (Tom Lane)
     * Improve page-splitting decisions in GiST indexes (Alexander
       Korotkov, Robert Haas, Tom Lane)
       Multi-column GiST indexes might suffer unexpected bloat due to this
       error.
     * Fix cascading privilege revoke to stop if privileges are still held
       (Tom Lane)
       If we revoke a grant option from some role "X", but "X" still holds
       that option via a grant from someone else, we should not
       recursively revoke the corresponding privilege from role(s) "Y"
       that "X" had granted it to.
     * Disallow extensions from containing the schema they are assigned to
       (Thom Brown)
       This situation creates circular dependencies that confuse pg_dump
       and probably other things. It's confusing for humans too, so
       disallow it.
     * Improve error messages for Hot Standby misconfiguration errors
       (Gurjeet Singh)
     * Make configure probe for mbstowcs_l (Tom Lane)
       This fixes build failures on some versions of AIX.
     * Fix handling of SIGFPE when PL/Perl is in use (Andres Freund)
       Perl resets the process's SIGFPE handler to SIG_IGN, which could
       result in crashes later on. Restore the normal Postgres signal
       handler after initializing PL/Perl.
     * Prevent PL/Perl from crashing if a recursive PL/Perl function is
       redefined while being executed (Tom Lane)
     * Work around possible misoptimization in PL/Perl (Tom Lane)
       Some Linux distributions contain an incorrect version of
       "pthread.h" that results in incorrect compiled code in PL/Perl,
       leading to crashes if a PL/Perl function calls another one that
       throws an error.
     * Fix bugs in "contrib/pg_trgm"'s LIKE pattern analysis code (Fujii
       Masao)
       LIKE queries using a trigram index could produce wrong results if
       the pattern contained LIKE escape characters.
     * Fix pg_upgrade's handling of line endings on Windows (Andrew
       Dunstan)
       Previously, pg_upgrade might add or remove carriage returns in
       places such as function bodies.
     * On Windows, make pg_upgrade use backslash path separators in the
       scripts it emits (Andrew Dunstan)
     * Remove unnecessary dependency on pg_config from pg_upgrade (Peter
       Eisentraut)
     * Update time zone data files to tzdata release 2012f for DST law
       changes in Fiji
     __________________________________________________________________

                                Release 9.1.5

     Release Date: 2012-08-17

   This release contains a variety of fixes from 9.1.4. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.5

   A dump/restore is not required for those running 9.1.X.

   However, if you are upgrading from a version earlier than 9.1.4, see
   the release notes for 9.1.4.
     __________________________________________________________________

Changes

     * Prevent access to external files/URLs via XML entity references
       (Noah Misch, Tom Lane)
       xml_parse() would attempt to fetch external files or URLs as needed
       to resolve DTD and entity references in an XML value, thus allowing
       unprivileged database users to attempt to fetch data with the
       privileges of the database server. While the external data wouldn't
       get returned directly to the user, portions of it could be exposed
       in error messages if the data didn't parse as valid XML; and in any
       case the mere ability to check existence of a file might be useful
       to an attacker. (CVE-2012-3489)
     * Prevent access to external files/URLs via "contrib/xml2"'s
       xslt_process() (Peter Eisentraut)
       libxslt offers the ability to read and write both files and URLs
       through stylesheet commands, thus allowing unprivileged database
       users to both read and write data with the privileges of the
       database server. Disable that through proper use of libxslt's
       security options. (CVE-2012-3488)
       Also, remove xslt_process()'s ability to fetch documents and
       stylesheets from external files/URLs. While this was a documented
       "feature", it was long regarded as a bad idea. The fix for
       CVE-2012-3489 broke that capability, and rather than expend effort
       on trying to fix it, we're just going to summarily remove it.
     * Prevent too-early recycling of btree index pages (Noah Misch)
       When we allowed read-only transactions to skip assigning XIDs, we
       introduced the possibility that a deleted btree page could be
       recycled while a read-only transaction was still in flight to it.
       This would result in incorrect index search results. The
       probability of such an error occurring in the field seems very low
       because of the timing requirements, but nonetheless it should be
       fixed.
     * Fix crash-safety bug with newly-created-or-reset sequences (Tom
       Lane)
       If "ALTER SEQUENCE" was executed on a freshly created or reset
       sequence, and then precisely one nextval() call was made on it, and
       then the server crashed, WAL replay would restore the sequence to a
       state in which it appeared that no nextval() had been done, thus
       allowing the first sequence value to be returned again by the next
       nextval() call. In particular this could manifest for serial
       columns, since creation of a serial column's sequence includes an
       "ALTER SEQUENCE OWNED BY" step.
     * Fix race condition in enum-type value comparisons (Robert Haas, Tom
       Lane)
       Comparisons could fail when encountering an enum value added since
       the current query started.
     * Fix txid_current() to report the correct epoch when not in hot
       standby (Heikki Linnakangas)
       This fixes a regression introduced in the previous minor release.
     * Prevent selection of unsuitable replication connections as the
       synchronous standby (Fujii Masao)
       The master might improperly choose pseudo-servers such as
       pg_receivexlog or pg_basebackup as the synchronous standby, and
       then wait indefinitely for them.
     * Fix bug in startup of Hot Standby when a master transaction has
       many subtransactions (Andres Freund)
       This mistake led to failures reported as "out-of-order XID
       insertion in KnownAssignedXids".
     * Ensure the "backup_label" file is fsync'd after pg_start_backup()
       (Dave Kerr)
     * Fix timeout handling in walsender processes (Tom Lane)
       WAL sender background processes neglected to establish a SIGALRM
       handler, meaning they would wait forever in some corner cases where
       a timeout ought to happen.
     * Wake walsenders after each background flush by walwriter (Andres
       Freund, Simon Riggs)
       This greatly reduces replication delay when the workload contains
       only asynchronously-committed transactions.
     * Fix LISTEN/NOTIFY to cope better with I/O problems, such as out of
       disk space (Tom Lane)
       After a write failure, all subsequent attempts to send more NOTIFY
       messages would fail with messages like "Could not read from file
       "pg_notify/nnnn" at offset nnnnn: Success".
     * Only allow autovacuum to be auto-canceled by a directly blocked
       process (Tom Lane)
       The original coding could allow inconsistent behavior in some
       cases; in particular, an autovacuum could get canceled after less
       than deadlock_timeout grace period.
     * Improve logging of autovacuum cancels (Robert Haas)
     * Fix log collector so that log_truncate_on_rotation works during the
       very first log rotation after server start (Tom Lane)
     * Fix WITH attached to a nested set operation
       (UNION/INTERSECT/EXCEPT) (Tom Lane)
     * Ensure that a whole-row reference to a subquery doesn't include any
       extra GROUP BY or ORDER BY columns (Tom Lane)
     * Fix dependencies generated during ALTER TABLE ... ADD CONSTRAINT
       USING INDEX (Tom Lane)
       This command left behind a redundant pg_depend entry for the index,
       which could confuse later operations, notably ALTER TABLE ... ALTER
       COLUMN TYPE on one of the indexed columns.
     * Fix "REASSIGN OWNED" to work on extensions (Alvaro Herrera)
     * Disallow copying whole-row references in CHECK constraints and
       index definitions during "CREATE TABLE" (Tom Lane)
       This situation can arise in "CREATE TABLE" with LIKE or INHERITS.
       The copied whole-row variable was incorrectly labeled with the row
       type of the original table not the new one. Rejecting the case
       seems reasonable for LIKE, since the row types might well diverge
       later. For INHERITS we should ideally allow it, with an implicit
       coercion to the parent table's row type; but that will require more
       work than seems safe to back-patch.
     * Fix memory leak in ARRAY(SELECT ...) subqueries (Heikki
       Linnakangas, Tom Lane)
     * Fix planner to pass correct collation to operator selectivity
       estimators (Tom Lane)
       This was not previously required by any core selectivity estimation
       function, but third-party code might need it.
     * Fix extraction of common prefixes from regular expressions (Tom
       Lane)
       The code could get confused by quantified parenthesized
       subexpressions, such as ^(foo)?bar. This would lead to incorrect
       index optimization of searches for such patterns.
     * Fix bugs with parsing signed "hh":"mm" and "hh":"mm":"ss" fields in
       interval constants (Amit Kapila, Tom Lane)
     * Fix pg_dump to better handle views containing partial GROUP BY
       lists (Tom Lane)
       A view that lists only a primary key column in GROUP BY, but uses
       other table columns as if they were grouped, gets marked as
       depending on the primary key. Improper handling of such primary key
       dependencies in pg_dump resulted in poorly-ordered dumps, which at
       best would be inefficient to restore and at worst could result in
       outright failure of a parallel pg_restore run.
     * In PL/Perl, avoid setting UTF8 flag when in SQL_ASCII encoding
       (Alex Hunsaker, Kyotaro Horiguchi, Alvaro Herrera)
     * Use Postgres' encoding conversion functions, not Python's, when
       converting a Python Unicode string to the server encoding in
       PL/Python (Jan Urbanski)
       This avoids some corner-case problems, notably that Python doesn't
       support all the encodings Postgres does. A notable functional
       change is that if the server encoding is SQL_ASCII, you will get
       the UTF-8 representation of the string; formerly, any non-ASCII
       characters in the string would result in an error.
     * Fix mapping of PostgreSQL encodings to Python encodings in
       PL/Python (Jan Urbanski)
     * Report errors properly in "contrib/xml2"'s xslt_process() (Tom
       Lane)
     * Update time zone data files to tzdata release 2012e for DST law
       changes in Morocco and Tokelau
     __________________________________________________________________

                                Release 9.1.4

     Release Date: 2012-06-04

   This release contains a variety of fixes from 9.1.3. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.4

   A dump/restore is not required for those running 9.1.X.

   However, if you use the citext data type, and you upgraded from a
   previous major release by running pg_upgrade, you should run CREATE
   EXTENSION citext FROM unpackaged to avoid collation-related failures in
   citext operations. The same is necessary if you restore a dump from a
   pre-9.1 database that contains an instance of the citext data type. If
   you've already run the "CREATE EXTENSION" command before upgrading to
   9.1.4, you will instead need to do manual catalog updates as explained
   in the third changelog item below.

   Also, if you are upgrading from a version earlier than 9.1.2, see the
   release notes for 9.1.2.
     __________________________________________________________________

Changes

     * Fix incorrect password transformation in "contrib/pgcrypto"'s DES
       crypt() function (Solar Designer)
       If a password string contained the byte value 0x80, the remainder
       of the password was ignored, causing the password to be much weaker
       than it appeared. With this fix, the rest of the string is properly
       included in the DES hash. Any stored password values that are
       affected by this bug will thus no longer match, so the stored
       values may need to be updated. (CVE-2012-2143)
     * Ignore SECURITY DEFINER and SET attributes for a procedural
       language's call handler (Tom Lane)
       Applying such attributes to a call handler could crash the server.
       (CVE-2012-2655)
     * Make "contrib/citext"'s upgrade script fix collations of citext
       arrays and domains over citext (Tom Lane)
       Release 9.1.2 provided a fix for collations of citext columns and
       indexes in databases upgraded or reloaded from pre-9.1
       installations, but that fix was incomplete: it neglected to handle
       arrays and domains over citext. This release extends the module's
       upgrade script to handle these cases. As before, if you have
       already run the upgrade script, you'll need to run the collation
       update commands by hand instead. See the 9.1.2 release notes for
       more information about doing this.
     * Allow numeric timezone offsets in timestamp input to be up to 16
       hours away from UTC (Tom Lane)
       Some historical time zones have offsets larger than 15 hours, the
       previous limit. This could result in dumped data values being
       rejected during reload.
     * Fix timestamp conversion to cope when the given time is exactly the
       last DST transition time for the current timezone (Tom Lane)
       This oversight has been there a long time, but was not noticed
       previously because most DST-using zones are presumed to have an
       indefinite sequence of future DST transitions.
     * Fix text to name and char to name casts to perform string
       truncation correctly in multibyte encodings (Karl Schnaitter)
     * Fix memory copying bug in to_tsquery() (Heikki Linnakangas)
     * Ensure txid_current() reports the correct epoch when executed in
       hot standby (Simon Riggs)
     * Fix planner's handling of outer PlaceHolderVars within subqueries
       (Tom Lane)
       This bug concerns sub-SELECTs that reference variables coming from
       the nullable side of an outer join of the surrounding query. In
       9.1, queries affected by this bug would fail with "ERROR:
       Upper-level PlaceHolderVar found where not expected". But in 9.0
       and 8.4, you'd silently get possibly-wrong answers, since the value
       transmitted into the subquery wouldn't go to null when it should.
     * Fix planning of UNION ALL subqueries with output columns that are
       not simple variables (Tom Lane)
       Planning of such cases got noticeably worse in 9.1 as a result of a
       misguided fix for "MergeAppend child's targetlist doesn't match
       MergeAppend" errors. Revert that fix and do it another way.
     * Fix slow session startup when pg_attribute is very large (Tom Lane)
       If pg_attribute exceeds one-fourth of shared_buffers, cache
       rebuilding code that is sometimes needed during session start would
       trigger the synchronized-scan logic, causing it to take many times
       longer than normal. The problem was particularly acute if many new
       sessions were starting at once.
     * Ensure sequential scans check for query cancel reasonably often
       (Merlin Moncure)
       A scan encountering many consecutive pages that contain no live
       tuples would not respond to interrupts meanwhile.
     * Ensure the Windows implementation of PGSemaphoreLock() clears
       ImmediateInterruptOK before returning (Tom Lane)
       This oversight meant that a query-cancel interrupt received later
       in the same query could be accepted at an unsafe time, with
       unpredictable but not good consequences.
     * Show whole-row variables safely when printing views or rules (Abbas
       Butt, Tom Lane)
       Corner cases involving ambiguous names (that is, the name could be
       either a table or column name of the query) were printed in an
       ambiguous way, risking that the view or rule would be interpreted
       differently after dump and reload. Avoid the ambiguous case by
       attaching a no-op cast.
     * Fix "COPY FROM" to properly handle null marker strings that
       correspond to invalid encoding (Tom Lane)
       A null marker string such as E'\\0' should work, and did work in
       the past, but the case got broken in 8.4.
     * Fix "EXPLAIN VERBOSE" for writable CTEs containing RETURNING
       clauses (Tom Lane)
     * Fix "PREPARE TRANSACTION" to work correctly in the presence of
       advisory locks (Tom Lane)
       Historically, "PREPARE TRANSACTION" has simply ignored any
       session-level advisory locks the session holds, but this case was
       accidentally broken in 9.1.
     * Fix truncation of unlogged tables (Robert Haas)
     * Ignore missing schemas during non-interactive assignments of
       search_path (Tom Lane)
       This re-aligns 9.1's behavior with that of older branches.
       Previously 9.1 would throw an error for nonexistent schemas
       mentioned in search_path settings obtained from places such as
       "ALTER DATABASE SET".
     * Fix bugs with temporary or transient tables used in extension
       scripts (Tom Lane)
       This includes cases such as a rewriting "ALTER TABLE" within an
       extension update script, since that uses a transient table behind
       the scenes.
     * Ensure autovacuum worker processes perform stack depth checking
       properly (Heikki Linnakangas)
       Previously, infinite recursion in a function invoked by
       auto-"ANALYZE" could crash worker processes.
     * Fix logging collector to not lose log coherency under high load
       (Andrew Dunstan)
       The collector previously could fail to reassemble large messages if
       it got too busy.
     * Fix logging collector to ensure it will restart file rotation after
       receiving SIGHUP (Tom Lane)
     * Fix "too many LWLocks taken" failure in GiST indexes (Heikki
       Linnakangas)
     * Fix WAL replay logic for GIN indexes to not fail if the index was
       subsequently dropped (Tom Lane)
     * Correctly detect SSI conflicts of prepared transactions after a
       crash (Dan Ports)
     * Avoid synchronous replication delay when committing a transaction
       that only modified temporary tables (Heikki Linnakangas)
       In such a case the transaction's commit record need not be flushed
       to standby servers, but some of the code didn't know that and
       waited for it to happen anyway.
     * Fix error handling in pg_basebackup (Thomas Ogrisegg, Fujii Masao)
     * Fix walsender to not go into a busy loop if connection is
       terminated (Fujii Masao)
     * Fix memory leak in PL/pgSQL's "RETURN NEXT" command (Joe Conway)
     * Fix PL/pgSQL's "GET DIAGNOSTICS" command when the target is the
       function's first variable (Tom Lane)
     * Ensure that PL/Perl package-qualifies the _TD variable (Alex
       Hunsaker)
       This bug caused trigger invocations to fail when they are nested
       within a function invocation that changes the current package.
     * Fix PL/Python functions returning composite types to accept a
       string for their result value (Jan Urbanski)
       This case was accidentally broken by the 9.1 additions to allow a
       composite result value to be supplied in other formats, such as
       dictionaries.
     * Fix potential access off the end of memory in psql's expanded
       display ("\x") mode (Peter Eisentraut)
     * Fix several performance problems in pg_dump when the database
       contains many objects (Jeff Janes, Tom Lane)
       pg_dump could get very slow if the database contained many schemas,
       or if many objects are in dependency loops, or if there are many
       owned sequences.
     * Fix memory and file descriptor leaks in pg_restore when reading a
       directory-format archive (Peter Eisentraut)
     * Fix pg_upgrade for the case that a database stored in a non-default
       tablespace contains a table in the cluster's default tablespace
       (Bruce Momjian)
     * In ecpg, fix rare memory leaks and possible overwrite of one byte
       after the sqlca_t structure (Peter Eisentraut)
     * Fix "contrib/dblink"'s dblink_exec() to not leak temporary database
       connections upon error (Tom Lane)
     * Fix "contrib/dblink" to report the correct connection name in error
       messages (Kyotaro Horiguchi)
     * Fix "contrib/vacuumlo" to use multiple transactions when dropping
       many large objects (Tim Lewis, Robert Haas, Tom Lane)
       This change avoids exceeding max_locks_per_transaction when many
       objects need to be dropped. The behavior can be adjusted with the
       new -l (limit) option.
     * Update time zone data files to tzdata release 2012c for DST law
       changes in Antarctica, Armenia, Chile, Cuba, Falkland Islands,
       Gaza, Haiti, Hebron, Morocco, Syria, and Tokelau Islands; also
       historical corrections for Canada.
     __________________________________________________________________

                                Release 9.1.3

     Release Date: 2012-02-27

   This release contains a variety of fixes from 9.1.2. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.3

   A dump/restore is not required for those running 9.1.X.

   However, if you are upgrading from a version earlier than 9.1.2, see
   the release notes for 9.1.2.
     __________________________________________________________________

Changes

     * Require execute permission on the trigger function for "CREATE
       TRIGGER" (Robert Haas)
       This missing check could allow another user to execute a trigger
       function with forged input data, by installing it on a table he
       owns. This is only of significance for trigger functions marked
       SECURITY DEFINER, since otherwise trigger functions run as the
       table owner anyway. (CVE-2012-0866)
     * Remove arbitrary limitation on length of common name in SSL
       certificates (Heikki Linnakangas)
       Both libpq and the server truncated the common name extracted from
       an SSL certificate at 32 bytes. Normally this would cause nothing
       worse than an unexpected verification failure, but there are some
       rather-implausible scenarios in which it might allow one
       certificate holder to impersonate another. The victim would have to
       have a common name exactly 32 bytes long, and the attacker would
       have to persuade a trusted CA to issue a certificate in which the
       common name has that string as a prefix. Impersonating a server
       would also require some additional exploit to redirect client
       connections. (CVE-2012-0867)
     * Convert newlines to spaces in names written in pg_dump comments
       (Robert Haas)
       pg_dump was incautious about sanitizing object names that are
       emitted within SQL comments in its output script. A name containing
       a newline would at least render the script syntactically incorrect.
       Maliciously crafted object names could present a SQL injection risk
       when the script is reloaded. (CVE-2012-0868)
     * Fix btree index corruption from insertions concurrent with
       vacuuming (Tom Lane)
       An index page split caused by an insertion could sometimes cause a
       concurrently-running "VACUUM" to miss removing index entries that
       it should remove. After the corresponding table rows are removed,
       the dangling index entries would cause errors (such as "could not
       read block N in file ...") or worse, silently wrong query results
       after unrelated rows are re-inserted at the now-free table
       locations. This bug has been present since release 8.2, but occurs
       so infrequently that it was not diagnosed until now. If you have
       reason to suspect that it has happened in your database, reindexing
       the affected index will fix things.
     * Fix transient zeroing of shared buffers during WAL replay (Tom
       Lane)
       The replay logic would sometimes zero and refill a shared buffer,
       so that the contents were transiently invalid. In hot standby mode
       this can result in a query that's executing in parallel seeing
       garbage data. Various symptoms could result from that, but the most
       common one seems to be "invalid memory alloc request size".
     * Fix handling of data-modifying WITH subplans in READ COMMITTED
       rechecking (Tom Lane)
       A WITH clause containing "INSERT"/"UPDATE"/"DELETE" would crash if
       the parent "UPDATE" or "DELETE" command needed to be re-evaluated
       at one or more rows due to concurrent updates in READ COMMITTED
       mode.
     * Fix corner case in SSI transaction cleanup (Dan Ports)
       When finishing up a read-write serializable transaction, a crash
       could occur if all remaining active serializable transactions are
       read-only.
     * Fix postmaster to attempt restart after a hot-standby crash (Tom
       Lane)
       A logic error caused the postmaster to terminate, rather than
       attempt to restart the cluster, if any backend process crashed
       while operating in hot standby mode.
     * Fix "CLUSTER"/"VACUUM FULL" handling of toast values owned by
       recently-updated rows (Tom Lane)
       This oversight could lead to "duplicate key value violates unique
       constraint" errors being reported against the toast table's index
       during one of these commands.
     * Update per-column permissions, not only per-table permissions, when
       changing table owner (Tom Lane)
       Failure to do this meant that any previously granted column
       permissions were still shown as having been granted by the old
       owner. This meant that neither the new owner nor a superuser could
       revoke the now-untraceable-to-table-owner permissions.
     * Support foreign data wrappers and foreign servers in "REASSIGN
       OWNED" (Alvaro Herrera)
       This command failed with "unexpected classid" errors if it needed
       to change the ownership of any such objects.
     * Allow non-existent values for some settings in "ALTER USER/DATABASE
       SET" (Heikki Linnakangas)
       Allow default_text_search_config, default_tablespace, and
       temp_tablespaces to be set to names that are not known. This is
       because they might be known in another database where the setting
       is intended to be used, or for the tablespace cases because the
       tablespace might not be created yet. The same issue was previously
       recognized for search_path, and these settings now act like that
       one.
     * Fix "unsupported node type" error caused by COLLATE in an "INSERT"
       expression (Tom Lane)
     * Avoid crashing when we have problems deleting table files
       post-commit (Tom Lane)
       Dropping a table should lead to deleting the underlying disk files
       only after the transaction commits. In event of failure then (for
       instance, because of wrong file permissions) the code is supposed
       to just emit a warning message and go on, since it's too late to
       abort the transaction. This logic got broken as of release 8.4,
       causing such situations to result in a PANIC and an unrestartable
       database.
     * Recover from errors occurring during WAL replay of "DROP
       TABLESPACE" (Tom Lane)
       Replay will attempt to remove the tablespace's directories, but
       there are various reasons why this might fail (for example,
       incorrect ownership or permissions on those directories). Formerly
       the replay code would panic, rendering the database unrestartable
       without manual intervention. It seems better to log the problem and
       continue, since the only consequence of failure to remove the
       directories is some wasted disk space.
     * Fix race condition in logging AccessExclusiveLocks for hot standby
       (Simon Riggs)
       Sometimes a lock would be logged as being held by "transaction
       zero". This is at least known to produce assertion failures on
       slave servers, and might be the cause of more serious problems.
     * Track the OID counter correctly during WAL replay, even when it
       wraps around (Tom Lane)
       Previously the OID counter would remain stuck at a high value until
       the system exited replay mode. The practical consequences of that
       are usually nil, but there are scenarios wherein a standby server
       that's been promoted to master might take a long time to advance
       the OID counter to a reasonable value once values are needed.
     * Prevent emitting misleading "consistent recovery state reached" log
       message at the beginning of crash recovery (Heikki Linnakangas)
     * Fix initial value of pg_stat_replication.replay_location (Fujii
       Masao)
       Previously, the value shown would be wrong until at least one WAL
       record had been replayed.
     * Fix regular expression back-references with * attached (Tom Lane)
       Rather than enforcing an exact string match, the code would
       effectively accept any string that satisfies the pattern
       sub-expression referenced by the back-reference symbol.
       A similar problem still afflicts back-references that are embedded
       in a larger quantified expression, rather than being the immediate
       subject of the quantifier. This will be addressed in a future
       PostgreSQL release.
     * Fix recently-introduced memory leak in processing of inet/cidr
       values (Heikki Linnakangas)
       A patch in the December 2011 releases of PostgreSQL caused memory
       leakage in these operations, which could be significant in
       scenarios such as building a btree index on such a column.
     * Fix planner's ability to push down index-expression restrictions
       through UNION ALL (Tom Lane)
       This type of optimization was inadvertently disabled by a fix for
       another problem in 9.1.2.
     * Fix planning of WITH clauses referenced in "UPDATE"/"DELETE" on an
       inherited table (Tom Lane)
       This bug led to "could not find plan for CTE" failures.
     * Fix GIN cost estimation to handle column IN (...) index conditions
       (Marti Raudsepp)
       This oversight would usually lead to crashes if such a condition
       could be used with a GIN index.
     * Prevent assertion failure when exiting a session with an open,
       failed transaction (Tom Lane)
       This bug has no impact on normal builds with asserts not enabled.
     * Fix dangling pointer after "CREATE TABLE AS"/"SELECT INTO" in a
       SQL-language function (Tom Lane)
       In most cases this only led to an assertion failure in
       assert-enabled builds, but worse consequences seem possible.
     * Avoid double close of file handle in syslogger on Windows (MauMau)
       Ordinarily this error was invisible, but it would cause an
       exception when running on a debug version of Windows.
     * Fix I/O-conversion-related memory leaks in plpgsql (Andres Freund,
       Jan Urbanski, Tom Lane)
       Certain operations would leak memory until the end of the current
       function.
     * Work around bug in perl's SvPVutf8() function (Andrew Dunstan)
       This function crashes when handed a typeglob or certain read-only
       objects such as $^V. Make plperl avoid passing those to it.
     * In pg_dump, don't dump contents of an extension's configuration
       tables if the extension itself is not being dumped (Tom Lane)
     * Improve pg_dump's handling of inherited table columns (Tom Lane)
       pg_dump mishandled situations where a child column has a different
       default expression than its parent column. If the default is
       textually identical to the parent's default, but not actually the
       same (for instance, because of schema search path differences) it
       would not be recognized as different, so that after dump and
       restore the child would be allowed to inherit the parent's default.
       Child columns that are NOT NULL where their parent is not could
       also be restored subtly incorrectly.
     * Fix pg_restore's direct-to-database mode for INSERT-style table
       data (Tom Lane)
       Direct-to-database restores from archive files made with
       "--inserts" or "--column-inserts" options fail when using
       pg_restore from a release dated September or December 2011, as a
       result of an oversight in a fix for another problem. The archive
       file itself is not at fault, and text-mode output is okay.
     * Teach pg_upgrade to handle renaming of plpython's shared library
       (Bruce Momjian)
       Upgrading a pre-9.1 database that included plpython would fail
       because of this oversight.
     * Allow pg_upgrade to process tables containing regclass columns
       (Bruce Momjian)
       Since pg_upgrade now takes care to preserve pg_class OIDs, there
       was no longer any reason for this restriction.
     * Make libpq ignore ENOTDIR errors when looking for an SSL client
       certificate file (Magnus Hagander)
       This allows SSL connections to be established, though without a
       certificate, even when the user's home directory is set to
       something like /dev/null.
     * Fix some more field alignment issues in ecpg's SQLDA area (Zoltan
       Boszormenyi)
     * Allow AT option in ecpg DEALLOCATE statements (Michael Meskes)
       The infrastructure to support this has been there for awhile, but
       through an oversight there was still an error check rejecting the
       case.
     * Do not use the variable name when defining a varchar structure in
       ecpg (Michael Meskes)
     * Fix "contrib/auto_explain"'s JSON output mode to produce valid JSON
       (Andrew Dunstan)
       The output used brackets at the top level, when it should have used
       braces.
     * Fix error in "contrib/intarray"'s int[] & int[] operator (Guillaume
       Lelarge)
       If the smallest integer the two input arrays have in common is 1,
       and there are smaller values in either array, then 1 would be
       incorrectly omitted from the result.
     * Fix error detection in "contrib/pgcrypto"'s encrypt_iv() and
       decrypt_iv() (Marko Kreen)
       These functions failed to report certain types of invalid-input
       errors, and would instead return random garbage values for
       incorrect input.
     * Fix one-byte buffer overrun in "contrib/test_parser" (Paul Guyot)
       The code would try to read one more byte than it should, which
       would crash in corner cases. Since "contrib/test_parser" is only
       example code, this is not a security issue in itself, but bad
       example code is still bad.
     * Use __sync_lock_test_and_set() for spinlocks on ARM, if available
       (Martin Pitt)
       This function replaces our previous use of the SWPB instruction,
       which is deprecated and not available on ARMv6 and later. Reports
       suggest that the old code doesn't fail in an obvious way on recent
       ARM boards, but simply doesn't interlock concurrent accesses,
       leading to bizarre failures in multiprocess operation.
     * Use "-fexcess-precision=standard" option when building with gcc
       versions that accept it (Andrew Dunstan)
       This prevents assorted scenarios wherein recent versions of gcc
       will produce creative results.
     * Allow use of threaded Python on FreeBSD (Chris Rees)
       Our configure script previously believed that this combination
       wouldn't work; but FreeBSD fixed the problem, so remove that error
       check.
     * Allow MinGW builds to use standardly-named OpenSSL libraries
       (Tomasz Ostrowski)
     __________________________________________________________________

                                Release 9.1.2

     Release Date: 2011-12-05

   This release contains a variety of fixes from 9.1.1. For information
   about new features in the 9.1 major release, see the Section called
   Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.2

   A dump/restore is not required for those running 9.1.X.

   However, a longstanding error was discovered in the definition of the
   information_schema.referential_constraints view. If you rely on correct
   results from that view, you should replace its definition as explained
   in the first changelog item below.

   Also, if you use the citext data type, and you upgraded from a previous
   major release by running pg_upgrade, you should run CREATE EXTENSION
   citext FROM unpackaged to avoid collation-related failures in citext
   operations. The same is necessary if you restore a dump from a pre-9.1
   database that contains an instance of the citext data type. If you've
   already run the "CREATE EXTENSION" command before upgrading to 9.1.2,
   you will instead need to do manual catalog updates as explained in the
   second changelog item.
     __________________________________________________________________

Changes

     * Fix bugs in information_schema.referential_constraints view (Tom
       Lane)
       This view was being insufficiently careful about matching the
       foreign-key constraint to the depended-on primary or unique key
       constraint. That could result in failure to show a foreign key
       constraint at all, or showing it multiple times, or claiming that
       it depends on a different constraint than the one it really does.
       Since the view definition is installed by initdb, merely upgrading
       will not fix the problem. If you need to fix this in an existing
       installation, you can (as a superuser) drop the information_schema
       schema then re-create it by sourcing
       "SHAREDIR/information_schema.sql". (Run pg_config --sharedir if
       you're uncertain where "SHAREDIR" is.) This must be repeated in
       each database to be fixed.
     * Make "contrib/citext"'s upgrade script fix collations of citext
       columns and indexes (Tom Lane)
       Existing citext columns and indexes aren't correctly marked as
       being of a collatable data type during pg_upgrade from a pre-9.1
       server, or when a pre-9.1 dump containing the citext type is loaded
       into a 9.1 server. That leads to operations on these columns
       failing with errors such as "could not determine which collation to
       use for string comparison". This change allows them to be fixed by
       the same script that upgrades the citext module into a proper 9.1
       extension during CREATE EXTENSION citext FROM unpackaged.
       If you have a previously-upgraded database that is suffering from
       this problem, and you already ran the "CREATE EXTENSION" command,
       you can manually run (as superuser) the "UPDATE" commands found at
       the end of "SHAREDIR/extension/citext--unpackaged--1.0.sql". (Run
       pg_config --sharedir if you're uncertain where "SHAREDIR" is.)
       There is no harm in doing this again if unsure.
     * Fix possible crash during "UPDATE" or "DELETE" that joins to the
       output of a scalar-returning function (Tom Lane)
       A crash could only occur if the target row had been concurrently
       updated, so this problem surfaced only intermittently.
     * Fix incorrect replay of WAL records for GIN index updates (Tom
       Lane)
       This could result in transiently failing to find index entries
       after a crash, or on a hot-standby server. The problem would be
       repaired by the next "VACUUM" of the index, however.
     * Fix TOAST-related data corruption during CREATE TABLE dest AS
       SELECT * FROM src or INSERT INTO dest SELECT * FROM src (Tom Lane)
       If a table has been modified by "ALTER TABLE ADD COLUMN", attempts
       to copy its data verbatim to another table could produce corrupt
       results in certain corner cases. The problem can only manifest in
       this precise form in 8.4 and later, but we patched earlier versions
       as well in case there are other code paths that could trigger the
       same bug.
     * Fix possible failures during hot standby startup (Simon Riggs)
     * Start hot standby faster when initial snapshot is incomplete (Simon
       Riggs)
     * Fix race condition during toast table access from stale syscache
       entries (Tom Lane)
       The typical symptom was transient errors like "missing chunk number
       0 for toast value NNNNN in pg_toast_2619", where the cited toast
       table would always belong to a system catalog.
     * Track dependencies of functions on items used in parameter default
       expressions (Tom Lane)
       Previously, a referenced object could be dropped without having
       dropped or modified the function, leading to misbehavior when the
       function was used. Note that merely installing this update will not
       fix the missing dependency entries; to do that, you'd need to
       "CREATE OR REPLACE" each such function afterwards. If you have
       functions whose defaults depend on non-built-in objects, doing so
       is recommended.
     * Fix incorrect management of placeholder variables in nestloop joins
       (Tom Lane)
       This bug is known to lead to "variable not found in subplan target
       list" planner errors, and could possibly result in wrong query
       output when outer joins are involved.
     * Fix window functions that sort by expressions involving aggregates
       (Tom Lane)
       Previously these could fail with "could not find pathkey item to
       sort" planner errors.
     * Fix "MergeAppend child's targetlist doesn't match MergeAppend"
       planner errors (Tom Lane)
     * Fix index matching for operators with both collatable and
       noncollatable inputs (Tom Lane)
       In 9.1.0, an indexable operator that has a non-collatable left-hand
       input type and a collatable right-hand input type would not be
       recognized as matching the left-hand column's index. An example is
       the hstore ? text operator.
     * Allow inlining of set-returning SQL functions with multiple OUT
       parameters (Tom Lane)
     * Don't trust deferred-unique indexes for join removal (Tom Lane and
       Marti Raudsepp)
       A deferred uniqueness constraint might not hold intra-transaction,
       so assuming that it does could give incorrect query results.
     * Make DatumGetInetP() unpack inet datums that have a 1-byte header,
       and add a new macro, DatumGetInetPP(), that does not (Heikki
       Linnakangas)
       This change affects no core code, but might prevent crashes in
       add-on code that expects DatumGetInetP() to produce an unpacked
       datum as per usual convention.
     * Improve locale support in money type's input and output (Tom Lane)
       Aside from not supporting all standard lc_monetary formatting
       options, the input and output functions were inconsistent, meaning
       there were locales in which dumped money values could not be
       re-read.
     * Don't let transform_null_equals affect CASE foo WHEN NULL ...
       constructs (Heikki Linnakangas)
       transform_null_equals is only supposed to affect foo = NULL
       expressions written directly by the user, not equality checks
       generated internally by this form of CASE.
     * Change foreign-key trigger creation order to better support
       self-referential foreign keys (Tom Lane)
       For a cascading foreign key that references its own table, a row
       update will fire both the ON UPDATE trigger and the CHECK trigger
       as one event. The ON UPDATE trigger must execute first, else the
       CHECK will check a non-final state of the row and possibly throw an
       inappropriate error. However, the firing order of these triggers is
       determined by their names, which generally sort in creation order
       since the triggers have auto-generated names following the
       convention "RI_ConstraintTrigger_NNNN". A proper fix would require
       modifying that convention, which we will do in 9.2, but it seems
       risky to change it in existing releases. So this patch just changes
       the creation order of the triggers. Users encountering this type of
       error should drop and re-create the foreign key constraint to get
       its triggers into the right order.
     * Fix IF EXISTS to work correctly in "DROP OPERATOR FAMILY" (Robert
       Haas)
     * Disallow dropping of an extension from within its own script (Tom
       Lane)
       This prevents odd behavior in case of incorrect management of
       extension dependencies.
     * Don't mark auto-generated types as extension members (Robert Haas)
       Relation rowtypes and automatically-generated array types do not
       need to have their own extension membership entries in pg_depend,
       and creating such entries complicates matters for extension
       upgrades.
     * Cope with invalid pre-existing search_path settings during "CREATE
       EXTENSION" (Tom Lane)
     * Avoid floating-point underflow while tracking buffer allocation
       rate (Greg Matthews)
       While harmless in itself, on certain platforms this would result in
       annoying kernel log messages.
     * Prevent autovacuum transactions from running in serializable mode
       (Tom Lane)
       Autovacuum formerly used the cluster-wide default transaction
       isolation level, but there is no need for it to use anything higher
       than READ COMMITTED, and using SERIALIZABLE could result in
       unnecessary delays for other processes.
     * Ensure walsender processes respond promptly to SIGTERM (Magnus
       Hagander)
     * Exclude "postmaster.opts" from base backups (Magnus Hagander)
     * Preserve configuration file name and line number values when
       starting child processes under Windows (Tom Lane)
       Formerly, these would not be displayed correctly in the pg_settings
       view.
     * Fix incorrect field alignment in ecpg's SQLDA area (Zoltan
       Boszormenyi)
     * Preserve blank lines within commands in psql's command history
       (Robert Haas)
       The former behavior could cause problems if an empty line was
       removed from within a string literal, for example.
     * Avoid platform-specific infinite loop in pg_dump (Steve Singer)
     * Fix compression of plain-text output format in pg_dump (Adrian
       Klaver and Tom Lane)
       pg_dump has historically understood -Z with no -F switch to mean
       that it should emit a gzip-compressed version of its plain text
       output. Restore that behavior.
     * Fix pg_dump to dump user-defined casts between auto-generated
       types, such as table rowtypes (Tom Lane)
     * Fix missed quoting of foreign server names in pg_dump (Tom Lane)
     * Assorted fixes for pg_upgrade (Bruce Momjian)
       Handle exclusion constraints correctly, avoid failures on Windows,
       don't complain about mismatched toast table names in 8.4 databases.
     * In PL/pgSQL, allow foreign tables to define row types (Alexander
       Soudakov)
     * Fix up conversions of PL/Perl functions' results (Alex Hunsaker and
       Tom Lane)
       Restore the pre-9.1 behavior that PL/Perl functions returning void
       ignore the result value of their last Perl statement; 9.1.0 would
       throw an error if that statement returned a reference. Also, make
       sure it works to return a string value for a composite type, so
       long as the string meets the type's input format. In addition,
       throw errors for attempts to return Perl arrays or hashes when the
       function's declared result type is not an array or composite type,
       respectively. (Pre-9.1 versions rather uselessly returned strings
       like ARRAY(0x221a9a0) or HASH(0x221aa90) in such cases.)
     * Ensure PL/Perl strings are always correctly UTF8-encoded (Amit
       Khandekar and Alex Hunsaker)
     * Use the preferred version of xsubpp to build PL/Perl, not
       necessarily the operating system's main copy (David Wheeler and
       Alex Hunsaker)
     * Correctly propagate SQLSTATE in PL/Python exceptions (Mika Eloranta
       and Jan Urbanski)
     * Do not install PL/Python extension files for Python major versions
       other than the one built against (Peter Eisentraut)
     * Change all the "contrib" extension script files to report a useful
       error message if they are fed to psql (Andrew Dunstan and Tom Lane)
       This should help teach people about the new method of using "CREATE
       EXTENSION" to load these files. In most cases, sourcing the scripts
       directly would fail anyway, but with harder-to-interpret messages.
     * Fix incorrect coding in "contrib/dict_int" and "contrib/dict_xsyn"
       (Tom Lane)
       Some functions incorrectly assumed that memory returned by palloc()
       is guaranteed zeroed.
     * Remove "contrib/sepgsql" tests from the regular regression test
       mechanism (Tom Lane)
       Since these tests require root privileges for setup, they're
       impractical to run automatically. Switch over to a manual approach
       instead, and provide a testing script to help with that.
     * Fix assorted errors in "contrib/unaccent"'s configuration file
       parsing (Tom Lane)
     * Honor query cancel interrupts promptly in pgstatindex() (Robert
       Haas)
     * Fix incorrect quoting of log file name in Mac OS X start script
       (Sidar Lopez)
     * Revert unintentional enabling of WAL_DEBUG (Robert Haas)
       Fortunately, as debugging tools go, this one is pretty cheap; but
       it's not intended to be enabled by default, so revert.
     * Ensure VPATH builds properly install all server header files (Peter
       Eisentraut)
     * Shorten file names reported in verbose error messages (Peter
       Eisentraut)
       Regular builds have always reported just the name of the C file
       containing the error message call, but VPATH builds formerly
       reported an absolute path name.
     * Fix interpretation of Windows timezone names for Central America
       (Tom Lane)
       Map "Central America Standard Time" to CST6, not CST6CDT, because
       DST is generally not observed anywhere in Central America.
     * Update time zone data files to tzdata release 2011n for DST law
       changes in Brazil, Cuba, Fiji, Palestine, Russia, and Samoa; also
       historical corrections for Alaska and British East Africa.
     __________________________________________________________________

                                Release 9.1.1

     Release Date: 2011-09-26

   This release contains a small number of fixes from 9.1.0. For
   information about new features in the 9.1 major release, see the
   Section called Release 9.1.
     __________________________________________________________________

Migration to Version 9.1.1

   A dump/restore is not required for those running 9.1.X.
     __________________________________________________________________

Changes

     * Make pg_options_to_table return NULL for an option with no value
       (Tom Lane)
       Previously such cases would result in a server crash.
     * Fix memory leak at end of a GiST index scan (Tom Lane)
       Commands that perform many separate GiST index scans, such as
       verification of a new GiST-based exclusion constraint on a table
       already containing many rows, could transiently require large
       amounts of memory due to this leak.
     * Fix explicit reference to pg_temp schema in "CREATE TEMPORARY
       TABLE" (Robert Haas)
       This used to be allowed, but failed in 9.1.0.
     __________________________________________________________________

                                 Release 9.1

     Release Date: 2011-09-12
     __________________________________________________________________

Overview

   This release shows PostgreSQL moving beyond the traditional
   relational-database feature set with new, ground-breaking functionality
   that is unique to PostgreSQL. The streaming replication feature
   introduced in release 9.0 is significantly enhanced by adding a
   synchronous-replication option, streaming backups, and monitoring
   improvements. Major enhancements include:

     * Allow synchronous replication
     * Add support for foreign tables
     * Add per-column collation support
     * Add extensions which simplify packaging of additions to PostgreSQL
     * Add a true serializable isolation level
     * Support unlogged tables using the UNLOGGED option in "CREATE TABLE"
     * Allow data-modification commands ("INSERT"/"UPDATE"/"DELETE") in
       WITH clauses
     * Add nearest-neighbor (order-by-operator) searching to GiST indexes
     * Add a "SECURITY LABEL" command and support for SELinux permissions
       control
     * Update the PL/Python server-side language

   The above items are explained in more detail in the sections below.
     __________________________________________________________________

Migration to Version 9.1

   A dump/restore using pg_dump, or use of pg_upgrade, is required for
   those wishing to migrate data from any previous release.

   Version 9.1 contains a number of changes that may affect compatibility
   with previous releases. Observe the following incompatibilities:
     __________________________________________________________________

Strings

     * Change the default value of standard_conforming_strings to on
       (Robert Haas)
       By default, backslashes are now ordinary characters in string
       literals, not escape characters. This change removes a
       long-standing incompatibility with the SQL standard.
       escape_string_warning has produced warnings about this usage for
       years. E'' strings are the proper way to embed backslash escapes in
       strings and are unaffected by this change.

                                       Warning
       This change can break applications that are not expecting it and do
       their own string escaping according to the old rules. The consequences
       could be as severe as introducing SQL-injection security holes. Be sure
       to test applications that are exposed to untrusted input, to ensure
       that they correctly handle single quotes and backslashes in text
       strings.
     __________________________________________________________________

Casting

     * Disallow function-style and attribute-style data type casts for
       composite types (Tom Lane)
       For example, disallow composite_value.text and
       text(composite_value). Unintentional uses of this syntax have
       frequently resulted in bug reports; although it was not a bug, it
       seems better to go back to rejecting such expressions. The CAST and
       :: syntaxes are still available for use when a cast of an entire
       composite value is actually intended.
     * Tighten casting checks for domains based on arrays (Tom Lane)
       When a domain is based on an array type, it is allowed to "look
       through" the domain type to access the array elements, including
       subscripting the domain value to fetch or assign an element.
       Assignment to an element of such a domain value, for instance via
       UPDATE ... SET domaincol[5] = ..., will now result in rechecking
       the domain type's constraints, whereas before the checks were
       skipped.
     __________________________________________________________________

Arrays

     * Change string_to_array() to return an empty array for a zero-length
       string (Pavel Stehule)
       Previously this returned a null value.
     * Change string_to_array() so a NULL separator splits the string into
       characters (Pavel Stehule)
       Previously this returned a null value.
     __________________________________________________________________

Object Modification

     * Fix improper checks for before/after triggers (Tom Lane)
       Triggers can now be fired in three cases: BEFORE, AFTER, or INSTEAD
       OF some action. Trigger function authors should verify that their
       logic behaves sanely in all three cases.
     * Require superuser or CREATEROLE permissions in order to set
       comments on roles (Tom Lane)
     __________________________________________________________________

Server Settings

     * Change pg_last_xlog_receive_location() so it never moves backwards
       (Fujii Masao)
       Previously, the value of pg_last_xlog_receive_location() could move
       backward when streaming replication is restarted.
     * Have logging of replication connections honor log_connections
       (Magnus Hagander)
       Previously, replication connections were always logged.
     __________________________________________________________________

PL/pgSQL Server-Side Language

     * Change PL/pgSQL's RAISE command without parameters to be catchable
       by the attached exception block (Piyush Newe)
       Previously RAISE in a code block was always scoped to an attached
       exception block, so it was uncatchable at the same scope.
     * Adjust PL/pgSQL's error line numbering code to be consistent with
       other PLs (Pavel Stehule)
       Previously, PL/pgSQL would ignore (not count) an empty line at the
       start of the function body. Since this was inconsistent with all
       other languages, the special case was removed.
     * Make PL/pgSQL complain about conflicting IN and OUT parameter names
       (Tom Lane)
       Formerly, the collision was not detected, and the name would just
       silently refer to only the OUT parameter.
     * Type modifiers of PL/pgSQL variables are now visible to the SQL
       parser (Tom Lane)
       A type modifier (such as a varchar length limit) attached to a
       PL/pgSQL variable was formerly enforced during assignments, but was
       ignored for all other purposes. Such variables will now behave more
       like table columns declared with the same modifier. This is not
       expected to make any visible difference in most cases, but it could
       result in subtle changes for some SQL commands issued by PL/pgSQL
       functions.
     __________________________________________________________________

Contrib

     * All contrib modules are now installed with "CREATE EXTENSION"
       rather than by manually invoking their SQL scripts (Dimitri
       Fontaine, Tom Lane)
       To update an existing database containing the 9.0 version of a
       contrib module, use CREATE EXTENSION ... FROM unpackaged to wrap
       the existing contrib module's objects into an extension. When
       updating from a pre-9.0 version, drop the contrib module's objects
       using its old uninstall script, then use CREATE EXTENSION.
     __________________________________________________________________

Other Incompatibilities

     * Make pg_stat_reset() reset all database-level statistics (Tomas
       Vondra)
       Some pg_stat_database counters were not being reset.
     * Fix some information_schema.triggers column names to match the new
       SQL-standard names (Dean Rasheed)
     * Treat ECPG cursor names as case-insensitive (Zoltan Boszormenyi)
     __________________________________________________________________

Changes

   Below you will find a detailed account of the changes between
   PostgreSQL 9.1 and the previous major release.
     __________________________________________________________________

Server

Performance

     * Support unlogged tables using the UNLOGGED option in "CREATE TABLE"
       (Robert Haas)
       Such tables provide better update performance than regular tables,
       but are not crash-safe: their contents are automatically cleared in
       case of a server crash. Their contents do not propagate to
       replication slaves, either.
     * Allow FULL OUTER JOIN to be implemented as a hash join, and allow
       either side of a LEFT OUTER JOIN or RIGHT OUTER JOIN to be hashed
       (Tom Lane)
       Previously FULL OUTER JOIN could only be implemented as a merge
       join, and LEFT OUTER JOIN and RIGHT OUTER JOIN could hash only the
       nullable side of the join. These changes provide additional query
       optimization possibilities.
     * Merge duplicate fsync requests (Robert Haas, Greg Smith)
       This greatly improves performance under heavy write loads.
     * Improve performance of commit_siblings (Greg Smith)
       This allows the use of commit_siblings with less overhead.
     * Reduce the memory requirement for large ispell dictionaries (Pavel
       Stehule, Tom Lane)
     * Avoid leaving data files open after "blind writes" (Alvaro Herrera)
       This fixes scenarios in which backends might hold files open long
       after they were deleted, preventing the kernel from reclaiming disk
       space.
     __________________________________________________________________

Optimizer

     * Allow inheritance table scans to return meaningfully-sorted results
       (Greg Stark, Hans-Jurgen Schonig, Robert Haas, Tom Lane)
       This allows better optimization of queries that use ORDER BY,
       LIMIT, or MIN/MAX with inherited tables.
     * Improve GIN index scan cost estimation (Teodor Sigaev)
     * Improve cost estimation for aggregates and window functions (Tom
       Lane)
     __________________________________________________________________

Authentication

     * Support host names and host suffixes (e.g. .example.com) in
       "pg_hba.conf" (Peter Eisentraut)
       Previously only host IP addresses and CIDR values were supported.
     * Support the key word all in the host column of "pg_hba.conf" (Peter
       Eisentraut)
       Previously people used 0.0.0.0/0 or ::/0 for this.
     * Reject local lines in "pg_hba.conf" on platforms that don't support
       Unix-socket connections (Magnus Hagander)
       Formerly, such lines were silently ignored, which could be
       surprising. This makes the behavior more like other unsupported
       cases.
     * Allow GSSAPI to be used to authenticate to servers via SSPI
       (Christian Ullrich)
       Specifically this allows Unix-based GSSAPI clients to do SSPI
       authentication with Windows servers.
     * ident authentication over local sockets is now known as peer
       (Magnus Hagander)
       The old term is still accepted for backward compatibility, but
       since the two methods are fundamentally different, it seemed better
       to adopt different names for them.
     * Rewrite peer authentication to avoid use of credential control
       messages (Tom Lane)
       This change makes the peer authentication code simpler and
       better-performing. However, it requires the platform to provide the
       getpeereid function or an equivalent socket operation. So far as is
       known, the only platform for which peer authentication worked
       before and now will not is pre-5.0 NetBSD.
     __________________________________________________________________

Monitoring

     * Add details to the logging of restartpoints and checkpoints, which
       is controlled by log_checkpoints (Fujii Masao, Greg Smith)
       New details include WAL file and sync activity.
     * Add log_file_mode which controls the permissions on log files
       created by the logging collector (Martin Pihlak)
     * Reduce the default maximum line length for syslog logging to 900
       bytes plus prefixes (Noah Misch)
       This avoids truncation of long log lines on syslog implementations
       that have a 1KB length limit, rather than the more common 2KB.
     __________________________________________________________________

Statistical Views

     * Add client_hostname column to pg_stat_activity (Peter Eisentraut)
       Previously only the client address was reported.
     * Add pg_stat_xact_* statistics functions and views (Joel Jacobson)
       These are like the database-wide statistics counter views, but
       reflect counts for only the current transaction.
     * Add time of last reset in database-level and background writer
       statistics views (Tomas Vondra)
     * Add columns showing the number of vacuum and analyze operations in
       pg_stat_*_tables views (Magnus Hagander)
     * Add buffers_backend_fsync column to pg_stat_bgwriter (Greg Smith)
       This new column counts the number of times a backend fsyncs a
       buffer.
     __________________________________________________________________

Server Settings

     * Provide auto-tuning of wal_buffers (Greg Smith)
       By default, the value of wal_buffers is now chosen automatically
       based on the value of shared_buffers.
     * Increase the maximum values for deadlock_timeout,
       log_min_duration_statement, and log_autovacuum_min_duration (Peter
       Eisentraut)
       The maximum value for each of these parameters was previously only
       about 35 minutes. Much larger values are now allowed.
     __________________________________________________________________

Replication and Recovery

Streaming Replication and Continuous Archiving

     * Allow synchronous replication (Simon Riggs, Fujii Masao)
       This allows the primary server to wait for a standby to write a
       transaction's information to disk before acknowledging the commit.
       One standby at a time can take the role of the synchronous standby,
       as controlled by the synchronous_standby_names setting. Synchronous
       replication can be enabled or disabled on a per-transaction basis
       using the synchronous_commit setting.
     * Add protocol support for sending file system backups to standby
       servers using the streaming replication network connection (Magnus
       Hagander, Heikki Linnakangas)
       This avoids the requirement of manually transferring a file system
       backup when setting up a standby server.
     * Add replication_timeout setting (Fujii Masao, Heikki Linnakangas)
       Replication connections that are idle for more than the
       replication_timeout interval will be terminated automatically.
       Formerly, a failed connection was typically not detected until the
       TCP timeout elapsed, which is inconveniently long in many
       situations.
     * Add command-line tool pg_basebackup for creating a new standby
       server or database backup (Magnus Hagander)
     * Add a replication permission for roles (Magnus Hagander)
       This is a read-only permission used for streaming replication. It
       allows a non-superuser role to be used for replication connections.
       Previously only superusers could initiate replication connections;
       superusers still have this permission by default.
     __________________________________________________________________

Replication Monitoring

     * Add system view pg_stat_replication which displays activity of WAL
       sender processes (Itagaki Takahiro, Simon Riggs)
       This reports the status of all connected standby servers.
     * Add monitoring function pg_last_xact_replay_timestamp() (Fujii
       Masao)
       This returns the time at which the primary generated the most
       recent commit or abort record applied on the standby.
     __________________________________________________________________

Hot Standby

     * Add configuration parameter hot_standby_feedback to enable standbys
       to postpone cleanup of old row versions on the primary (Simon
       Riggs)
       This helps avoid canceling long-running queries on the standby.
     * Add the pg_stat_database_conflicts system view to show queries that
       have been canceled and the reason (Magnus Hagander)
       Cancellations can occur because of dropped tablespaces, lock
       timeouts, old snapshots, pinned buffers, and deadlocks.
     * Add a conflicts count to pg_stat_database (Magnus Hagander)
       This is the number of conflicts that occurred in the database.
     * Increase the maximum values for max_standby_archive_delay and
       max_standby_streaming_delay
       The maximum value for each of these parameters was previously only
       about 35 minutes. Much larger values are now allowed.
     * Add ERRCODE_T_R_DATABASE_DROPPED error code to report recovery
       conflicts due to dropped databases (Tatsuo Ishii)
       This is useful for connection pooling software.
     __________________________________________________________________

Recovery Control

     * Add functions to control streaming replication replay (Simon Riggs)
       The new functions are pg_xlog_replay_pause(),
       pg_xlog_replay_resume(), and the status function
       pg_is_xlog_replay_paused().
     * Add "recovery.conf" setting pause_at_recovery_target to pause
       recovery at target (Simon Riggs)
       This allows a recovery server to be queried to check whether the
       recovery point is the one desired.
     * Add the ability to create named restore points using
       pg_create_restore_point() (Jaime Casanova)
       These named restore points can be specified as recovery targets
       using the new "recovery.conf" setting recovery_target_name.
     * Allow standby recovery to switch to a new timeline automatically
       (Heikki Linnakangas)
       Now standby servers scan the archive directory for new timelines
       periodically.
     * Add restart_after_crash setting which disables automatic server
       restart after a backend crash (Robert Haas)
       This allows external cluster management software to control whether
       the database server restarts or not.
     * Allow "recovery.conf" to use the same quoting behavior as
       "postgresql.conf" (Dimitri Fontaine)
       Previously all values had to be quoted.
     __________________________________________________________________

Queries

     * Add a true serializable isolation level (Kevin Grittner, Dan Ports)
       Previously, asking for serializable isolation guaranteed only that
       a single MVCC snapshot would be used for the entire transaction,
       which allowed certain documented anomalies. The old snapshot
       isolation behavior is still available by requesting the REPEATABLE
       READ isolation level.
     * Allow data-modification commands ("INSERT"/"UPDATE"/"DELETE") in
       WITH clauses (Marko Tiikkaja, Hitoshi Harada)
       These commands can use RETURNING to pass data up to the containing
       query.
     * Allow WITH clauses to be attached to "INSERT", "UPDATE", "DELETE"
       statements (Marko Tiikkaja, Hitoshi Harada)
     * Allow non-GROUP BY columns in the query target list when the
       primary key is specified in the GROUP BY clause (Peter Eisentraut)
       The SQL standard allows this behavior, and because of the primary
       key, the result is unambiguous.
     * Allow use of the key word DISTINCT in UNION/INTERSECT/EXCEPT
       clauses (Tom Lane)
       DISTINCT is the default behavior so use of this key word is
       redundant, but the SQL standard allows it.
     * Fix ordinary queries with rules to use the same snapshot behavior
       as "EXPLAIN ANALYZE" (Marko Tiikkaja)
       Previously "EXPLAIN ANALYZE" used slightly different snapshot
       timing for queries involving rules. The "EXPLAIN ANALYZE" behavior
       was judged to be more logical.
     __________________________________________________________________

Strings

     * Add per-column collation support (Peter Eisentraut, Tom Lane)
       Previously collation (the sort ordering of text strings) could only
       be chosen at database creation. Collation can now be set per
       column, domain, index, or expression, via the SQL-standard COLLATE
       clause.
     __________________________________________________________________

Object Manipulation

     * Add extensions which simplify packaging of additions to PostgreSQL
       (Dimitri Fontaine, Tom Lane)
       Extensions are controlled by the new "CREATE"/"ALTER"/"DROP
       EXTENSION" commands. This replaces ad-hoc methods of grouping
       objects that are added to a PostgreSQL installation.
     * Add support for foreign tables (Shigeru Hanada, Robert Haas, Jan
       Urbanski, Heikki Linnakangas)
       This allows data stored outside the database to be used like native
       PostgreSQL-stored data. Foreign tables are currently read-only,
       however.
     * Allow new values to be added to an existing enum type via "ALTER
       TYPE" (Andrew Dunstan)
     * Add "ALTER TYPE ... ADD/DROP/ALTER/RENAME ATTRIBUTE" (Peter
       Eisentraut)
       This allows modification of composite types.
     __________________________________________________________________

ALTER Object

     * Add RESTRICT/CASCADE to "ALTER TYPE" operations on typed tables
       (Peter Eisentraut)
       This controls ADD/DROP/ALTER/RENAME ATTRIBUTE cascading behavior.
     * Support ALTER TABLE name {OF | NOT OF} type (Noah Misch)
       This syntax allows a standalone table to be made into a typed
       table, or a typed table to be made standalone.
     * Add support for more object types in "ALTER ... SET SCHEMA"
       commands (Dimitri Fontaine)
       This command is now supported for conversions, operators, operator
       classes, operator families, text search configurations, text search
       dictionaries, text search parsers, and text search templates.
     __________________________________________________________________

CREATE/ALTER TABLE

     * Add "ALTER TABLE ... ADD UNIQUE/PRIMARY KEY USING INDEX" (Gurjeet
       Singh)
       This allows a primary key or unique constraint to be defined using
       an existing unique index, including a concurrently created unique
       index.
     * Allow "ALTER TABLE" to add foreign keys without validation (Simon
       Riggs)
       The new option is called NOT VALID. The constraint's state can
       later be modified to VALIDATED and validation checks performed.
       Together these allow you to add a foreign key with minimal impact
       on read and write operations.
     * Allow "ALTER TABLE ... SET DATA TYPE" to avoid table rewrites in
       appropriate cases (Noah Misch, Robert Haas)
       For example, converting a varchar column to text no longer requires
       a rewrite of the table. However, increasing the length constraint
       on a varchar column still requires a table rewrite.
     * Add "CREATE TABLE IF NOT EXISTS" syntax (Robert Haas)
       This allows table creation without causing an error if the table
       already exists.
     * Fix possible "tuple concurrently updated" error when two backends
       attempt to add an inheritance child to the same table at the same
       time (Robert Haas)
       "ALTER TABLE" now takes a stronger lock on the parent table, so
       that the sessions cannot try to update it simultaneously.
     __________________________________________________________________

Object Permissions

     * Add a "SECURITY LABEL" command (KaiGai Kohei)
       This allows security labels to be assigned to objects.
     __________________________________________________________________

Utility Operations

     * Add transaction-level advisory locks (Marko Tiikkaja)
       These are similar to the existing session-level advisory locks, but
       such locks are automatically released at transaction end.
     * Make "TRUNCATE ... RESTART IDENTITY" restart sequences
       transactionally (Steve Singer)
       Previously the counter could have been left out of sync if a
       backend crashed between the on-commit truncation activity and
       commit completion.
     __________________________________________________________________

COPY

     * Add ENCODING option to "COPY TO/FROM" (Hitoshi Harada, Itagaki
       Takahiro)
       This allows the encoding of the "COPY" file to be specified
       separately from client encoding.
     * Add bidirectional "COPY" protocol support (Fujii Masao)
       This is currently only used by streaming replication.
     __________________________________________________________________

EXPLAIN

     * Make "EXPLAIN VERBOSE" show the function call expression in a
       FunctionScan node (Tom Lane)
     __________________________________________________________________

VACUUM

     * Add additional details to the output of "VACUUM FULL VERBOSE" and
       "CLUSTER VERBOSE" (Itagaki Takahiro)
       New information includes the live and dead tuple count and whether
       "CLUSTER" is using an index to rebuild.
     * Prevent autovacuum from waiting if it cannot acquire a table lock
       (Robert Haas)
       It will try to vacuum that table later.
     __________________________________________________________________

CLUSTER

     * Allow "CLUSTER" to sort the table rather than scanning the index
       when it seems likely to be cheaper (Leonardo Francalanci)
     __________________________________________________________________

Indexes

     * Add nearest-neighbor (order-by-operator) searching to GiST indexes
       (Teodor Sigaev, Tom Lane)
       This allows GiST indexes to quickly return the "N" closest values
       in a query with LIMIT. For example
SELECT * FROM places ORDER BY location <-> point '(101,456)' LIMIT 10;
       finds the ten places closest to a given target point.
     * Allow GIN indexes to index null and empty values (Tom Lane)
       This allows full GIN index scans, and fixes various corner cases in
       which GIN scans would fail.
     * Allow GIN indexes to better recognize duplicate search entries (Tom
       Lane)
       This reduces the cost of index scans, especially in cases where it
       avoids unnecessary full index scans.
     * Fix GiST indexes to be fully crash-safe (Heikki Linnakangas)
       Previously there were rare cases where a "REINDEX" would be
       required (you would be informed).
     __________________________________________________________________

Data Types

     * Allow numeric to use a more compact, two-byte header in common
       cases (Robert Haas)
       Previously all numeric values had four-byte headers; this change
       saves on disk storage.
     * Add support for dividing money by money (Andy Balholm)
     * Allow binary I/O on type void (Radoslaw Smogura)
     * Improve hypotenuse calculations for geometric operators (Paul
       Matthews)
       This avoids unnecessary overflows, and may also be more accurate.
     * Support hashing array values (Tom Lane)
       This provides additional query optimization possibilities.
     * Don't treat a composite type as sortable unless all its column
       types are sortable (Tom Lane)
       This avoids possible "could not identify a comparison function"
       failures at runtime, if it is possible to implement the query
       without sorting. Also, "ANALYZE" won't try to use inappropriate
       statistics-gathering methods for columns of such composite types.
     __________________________________________________________________

Casting

     * Add support for casting between money and numeric (Andy Balholm)
     * Add support for casting from int4 and int8 to money (Joey Adams)
     * Allow casting a table's row type to the table's supertype if it's a
       typed table (Peter Eisentraut)
       This is analogous to the existing facility that allows casting a
       row type to a supertable's row type.
     __________________________________________________________________

XML

     * Add XML function XMLEXISTS and xpath_exists() functions (Mike
       Fowler)
       These are used for XPath matching.
     * Add XML functions xml_is_well_formed(),
       xml_is_well_formed_document(), xml_is_well_formed_content() (Mike
       Fowler)
       These check whether the input is properly-formed XML. They provide
       functionality that was previously available only in the deprecated
       "contrib/xml2" module.
     __________________________________________________________________

Functions

     * Add SQL function format(text, ...), which behaves analogously to
       C's printf() (Pavel Stehule, Robert Haas)
       It currently supports formats for strings, SQL literals, and SQL
       identifiers.
     * Add string functions concat(), concat_ws(), left(), right(), and
       reverse() (Pavel Stehule)
       These improve compatibility with other database products.
     * Add function pg_read_binary_file() to read binary files (Dimitri
       Fontaine, Itagaki Takahiro)
     * Add a single-parameter version of function pg_read_file() to read
       an entire file (Dimitri Fontaine, Itagaki Takahiro)
     * Add three-parameter forms of array_to_string() and
       string_to_array() for null value processing control (Pavel Stehule)
     __________________________________________________________________

Object Information Functions

     * Add the pg_describe_object() function (Alvaro Herrera)
       This function is used to obtain a human-readable string describing
       an object, based on the pg_class OID, object OID, and sub-object
       ID. It can be used to help interpret the contents of pg_depend.
     * Update comments for built-in operators and their underlying
       functions (Tom Lane)
       Functions that are meant to be used via an associated operator are
       now commented as such.
     * Add variable quote_all_identifiers to force the quoting of all
       identifiers in "EXPLAIN" and in system catalog functions like
       pg_get_viewdef() (Robert Haas)
       This makes exporting schemas to tools and other databases with
       different quoting rules easier.
     * Add columns to the information_schema.sequences system view (Peter
       Eisentraut)
       Previously, though the view existed, the columns about the sequence
       parameters were unimplemented.
     * Allow public as a pseudo-role name in has_table_privilege() and
       related functions (Alvaro Herrera)
       This allows checking for public permissions.
     __________________________________________________________________

Function and Trigger Creation

     * Support INSTEAD OF triggers on views (Dean Rasheed)
       This feature can be used to implement fully updatable views.
     __________________________________________________________________

Server-Side Languages

PL/pgSQL Server-Side Language

     * Add "FOREACH IN ARRAY" to PL/pgSQL (Pavel Stehule)
       This is more efficient and readable than previous methods of
       iterating through the elements of an array value.
     * Allow "RAISE" without parameters to be caught in the same places
       that could catch a "RAISE ERROR" from the same location (Piyush
       Newe)
       The previous coding threw the error from the block containing the
       active exception handler. The new behavior is more consistent with
       other DBMS products.
     __________________________________________________________________

PL/Perl Server-Side Language

     * Allow generic record arguments to PL/Perl functions (Andrew
       Dunstan)
       PL/Perl functions can now be declared to accept type record. The
       behavior is the same as for any named composite type.
     * Convert PL/Perl array arguments to Perl arrays (Alexey Klyukin,
       Alex Hunsaker)
       String representations are still available.
     * Convert PL/Perl composite-type arguments to Perl hashes (Alexey
       Klyukin, Alex Hunsaker)
       String representations are still available.
     __________________________________________________________________

PL/Python Server-Side Language

     * Add table function support for PL/Python (Jan Urbanski)
       PL/Python can now return multiple OUT parameters and record sets.
     * Add a validator to PL/Python (Jan Urbanski)
       This allows PL/Python functions to be syntax-checked at function
       creation time.
     * Allow exceptions for SQL queries in PL/Python (Jan Urbanski)
       This allows access to SQL-generated exception error codes from
       PL/Python exception blocks.
     * Add explicit subtransactions to PL/Python (Jan Urbanski)
     * Add PL/Python functions for quoting strings (Jan Urbanski)
       These functions are plpy.quote_ident, plpy.quote_literal, and
       plpy.quote_nullable.
     * Add traceback information to PL/Python errors (Jan Urbanski)
     * Report PL/Python errors from iterators with PLy_elog (Jan Urbanski)
     * Fix exception handling with Python 3 (Jan Urbanski)
       Exception classes were previously not available in plpy under
       Python 3.
     __________________________________________________________________

Client Applications

     * Mark createlang and droplang as deprecated now that they just
       invoke extension commands (Tom Lane)
     __________________________________________________________________

psql

     * Add psql command \conninfo to show current connection information
       (David Christensen)
     * Add psql command \sf to show a function's definition (Pavel
       Stehule)
     * Add psql command \dL to list languages (Fernando Ike)
     * Add the "S" ("system") option to psql's \dn (list schemas) command
       (Tom Lane)
       \dn without S now suppresses system schemas.
     * Allow psql's \e and \ef commands to accept a line number to be used
       to position the cursor in the editor (Pavel Stehule)
       This is passed to the editor according to the
       PSQL_EDITOR_LINENUMBER_ARG environment variable.
     * Have psql set the client encoding from the operating system locale
       by default (Heikki Linnakangas)
       This only happens if the PGCLIENTENCODING environment variable is
       not set.
     * Make \d distinguish between unique indexes and unique constraints
       (Josh Kupershmidt)
     * Make \dt+ report pg_table_size instead of pg_relation_size when
       talking to 9.0 or later servers (Bernd Helmle)
       This is a more useful measure of table size, but note that it is
       not identical to what was previously reported in the same display.
     * Additional tab completion support (Itagaki Takahiro, Pavel Stehule,
       Andrey Popp, Christoph Berg, David Fetter, Josh Kupershmidt)
     __________________________________________________________________

pg_dump

     * Add pg_dump and pg_dumpall option "--quote-all-identifiers" to
       force quoting of all identifiers (Robert Haas)
     * Add directory format to pg_dump (Joachim Wieland, Heikki
       Linnakangas)
       This is internally similar to the tar pg_dump format.
     __________________________________________________________________

pg_ctl

     * Fix pg_ctl so it no longer incorrectly reports that the server is
       not running (Bruce Momjian)
       Previously this could happen if the server was running but pg_ctl
       could not authenticate.
     * Improve pg_ctl start's "wait" ("-w") option (Bruce Momjian, Tom
       Lane)
       The wait mode is now significantly more robust. It will not get
       confused by non-default postmaster port numbers, non-default
       Unix-domain socket locations, permission problems, or stale
       postmaster lock files.
     * Add promote option to pg_ctl to switch a standby server to primary
       (Fujii Masao)
     __________________________________________________________________

Development Tools

libpq

     * Add a libpq connection option client_encoding which behaves like
       the PGCLIENTENCODING environment variable (Heikki Linnakangas)
       The value auto sets the client encoding based on the operating
       system locale.
     * Add PQlibVersion() function which returns the libpq library version
       (Magnus Hagander)
       libpq already had PQserverVersion() which returns the server
       version.
     * Allow libpq-using clients to check the user name of the server
       process when connecting via Unix-domain sockets, with the new
       requirepeer connection option (Peter Eisentraut)
       PostgreSQL already allowed servers to check the client user name
       when connecting via Unix-domain sockets.
     * Add PQping() and PQpingParams() to libpq (Bruce Momjian, Tom Lane)
       These functions allow detection of the server's status without
       trying to open a new session.
     __________________________________________________________________

ECPG

     * Allow ECPG to accept dynamic cursor names even in WHERE CURRENT OF
       clauses (Zoltan Boszormenyi)
     * Make ecpglib write double values with a precision of 15 digits, not
       14 as formerly (Akira Kurosawa)
     __________________________________________________________________

Build Options

     * Use +Olibmerrno compile flag with HP-UX C compilers that accept it
       (Ibrar Ahmed)
       This avoids possible misbehavior of math library calls on recent HP
       platforms.
     __________________________________________________________________

Makefiles

     * Improved parallel make support (Peter Eisentraut)
       This allows for faster compiles. Also, make -k now works more
       consistently.
     * Require GNU make 3.80 or newer (Peter Eisentraut)
       This is necessary because of the parallel-make improvements.
     * Add make maintainer-check target (Peter Eisentraut)
       This target performs various source code checks that are not
       appropriate for either the build or the regression tests.
       Currently: duplicate_oids, SGML syntax and tabs check, NLS syntax
       check.
     * Support make check in "contrib" (Peter Eisentraut)
       Formerly only make installcheck worked, but now there is support
       for testing in a temporary installation. The top-level make
       check-world target now includes testing "contrib" this way.
     __________________________________________________________________

Windows

     * On Windows, allow pg_ctl to register the service as auto-start or
       start-on-demand (Quan Zongliang)
     * Add support for collecting crash dumps on Windows (Craig Ringer,
       Magnus Hagander)
       minidumps can now be generated by non-debug Windows binaries and
       analyzed by standard debugging tools.
     * Enable building with the MinGW64 compiler (Andrew Dunstan)
       This allows building 64-bit Windows binaries even on non-Windows
       platforms via cross-compiling.
     __________________________________________________________________

Source Code

     * Revise the API for GUC variable assign hooks (Tom Lane)
       The previous functions of assign hooks are now split between check
       hooks and assign hooks, where the former can fail but the latter
       shouldn't. This change will impact add-on modules that define
       custom GUC parameters.
     * Add latches to the source code to support waiting for events
       (Heikki Linnakangas)
     * Centralize data modification permissions-checking logic (KaiGai
       Kohei)
     * Add missing get_object_oid() functions, for consistency (Robert
       Haas)
     * Improve ability to use C++ compilers for compiling add-on modules
       by removing conflicting key words (Tom Lane)
     * Add support for DragonFly BSD (Rumko)
     * Expose quote_literal_cstr() for backend use (Robert Haas)
     * Run regression tests in the default encoding (Peter Eisentraut)
       Regression tests were previously always run with SQL_ASCII
       encoding.
     * Add src/tools/git_changelog to replace cvs2cl and pgcvslog (Robert
       Haas, Tom Lane)
     * Add git-external-diff script to "src/tools" (Bruce Momjian)
       This is used to generate context diffs from git.
     * Improve support for building with Clang (Peter Eisentraut)
     __________________________________________________________________

Server Hooks

     * Add source code hooks to check permissions (Robert Haas, Stephen
       Frost)
     * Add post-object-creation function hooks for use by security
       frameworks (KaiGai Kohei)
     * Add a client authentication hook (KaiGai Kohei)
     __________________________________________________________________

Contrib

     * Modify "contrib" modules and procedural languages to install via
       the new extension mechanism (Tom Lane, Dimitri Fontaine)
     * Add "contrib/file_fdw" foreign-data wrapper (Shigeru Hanada)
       Foreign tables using this foreign data wrapper can read flat files
       in a manner very similar to "COPY".
     * Add nearest-neighbor search support to "contrib/pg_trgm" and
       "contrib/btree_gist" (Teodor Sigaev)
     * Add "contrib/btree_gist" support for searching on not-equals (Jeff
       Davis)
     * Fix "contrib/fuzzystrmatch"'s levenshtein() function to handle
       multibyte characters (Alexander Korotkov)
     * Add ssl_cipher() and ssl_version() functions to "contrib/sslinfo"
       (Robert Haas)
     * Fix "contrib/intarray" and "contrib/hstore" to give consistent
       results with indexed empty arrays (Tom Lane)
       Previously an empty-array query that used an index might return
       different results from one that used a sequential scan.
     * Allow "contrib/intarray" to work properly on multidimensional
       arrays (Tom Lane)
     * In "contrib/intarray", avoid errors complaining about the presence
       of nulls in cases where no nulls are actually present (Tom Lane)
     * In "contrib/intarray", fix behavior of containment operators with
       respect to empty arrays (Tom Lane)
       Empty arrays are now correctly considered to be contained in any
       other array.
     * Remove "contrib/xml2"'s arbitrary limit on the number of
       "parameter"="value" pairs that can be handled by xslt_process()
       (Pavel Stehule)
       The previous limit was 10.
     * In "contrib/pageinspect", fix heap_page_item to return infomasks as
       32-bit values (Alvaro Herrera)
       This avoids returning negative values, which was confusing. The
       underlying value is a 16-bit unsigned integer.
     __________________________________________________________________

Security

     * Add "contrib/sepgsql" to interface permission checks with SELinux
       (KaiGai Kohei)
       This uses the new "SECURITY LABEL" facility.
     * Add contrib module "auth_delay" (KaiGai Kohei)
       This causes the server to pause before returning authentication
       failure; it is designed to make brute force password attacks more
       difficult.
     * Add "dummy_seclabel" contrib module (KaiGai Kohei)
       This is used for permission regression testing.
     __________________________________________________________________

Performance

     * Add support for LIKE and ILIKE index searches to "contrib/pg_trgm"
       (Alexander Korotkov)
     * Add levenshtein_less_equal() function to "contrib/fuzzystrmatch",
       which is optimized for small distances (Alexander Korotkov)
     * Improve performance of index lookups on "contrib/seg" columns
       (Alexander Korotkov)
     * Improve performance of pg_upgrade for databases with many relations
       (Bruce Momjian)
     * Add flag to "contrib/pgbench" to report per-statement latencies
       (Florian Pflug)
     __________________________________________________________________

Fsync Testing

     * Move "src/tools/test_fsync" to "contrib/pg_test_fsync" (Bruce
       Momjian, Tom Lane)
     * Add O_DIRECT support to "contrib/pg_test_fsync" (Bruce Momjian)
       This matches the use of O_DIRECT by wal_sync_method.
     * Add new tests to "contrib/pg_test_fsync" (Bruce Momjian)
     __________________________________________________________________

Documentation

     * Extensive ECPG documentation improvements (Satoshi Nagayasu)
     * Extensive proofreading and documentation improvements (Thom Brown,
       Josh Kupershmidt, Susanne Ebrecht)
     * Add documentation for exit_on_error (Robert Haas)
       This parameter causes sessions to exit on any error.
     * Add documentation for pg_options_to_table() (Josh Berkus)
       This function shows table storage options in a readable form.
     * Document that it is possible to access all composite type fields
       using (compositeval).* syntax (Peter Eisentraut)
     * Document that translate() removes characters in from that don't
       have a corresponding to character (Josh Kupershmidt)
     * Merge documentation for "CREATE CONSTRAINT TRIGGER" and "CREATE
       TRIGGER" (Alvaro Herrera)
     * Centralize permission and upgrade documentation (Bruce Momjian)
     * Add kernel tuning documentation for Solaris 10 (Josh Berkus)
       Previously only Solaris 9 kernel tuning was documented.
     * Handle non-ASCII characters consistently in "HISTORY" file (Peter
       Eisentraut)
       While the "HISTORY" file is in English, we do have to deal with
       non-ASCII letters in contributor names. These are now
       transliterated so that they are reasonably legible without
       assumptions about character set.
     __________________________________________________________________

                               Release 9.0.15

     Release Date: 2013-12-05

   This release contains a variety of fixes from 9.0.14. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.15

   A dump/restore is not required for those running 9.0.X.

   However, this release corrects a number of potential data corruption
   issues. See the first two changelog entries below to find out whether
   your installation has been affected and what steps you can take if so.

   Also, if you are upgrading from a version earlier than 9.0.13, see the
   release notes for 9.0.13.
     __________________________________________________________________

Changes

     * Fix "VACUUM"'s tests to see whether it can update relfrozenxid
       (Andres Freund)
       In some cases "VACUUM" (either manual or autovacuum) could
       incorrectly advance a table's relfrozenxid value, allowing tuples
       to escape freezing, causing those rows to become invisible once
       2^31 transactions have elapsed. The probability of data loss is
       fairly low since multiple incorrect advancements would need to
       happen before actual loss occurs, but it's not zero. Users
       upgrading from releases 9.0.4 or 8.4.8 or earlier are not affected,
       but all later versions contain the bug.
       The issue can be ameliorated by, after upgrading, vacuuming all
       tables in all databases while having vacuum_freeze_table_age set to
       zero. This will fix any latent corruption but will not be able to
       fix all pre-existing data errors. However, an installation can be
       presumed safe after performing this vacuuming if it has executed
       fewer than 2^31 update transactions in its lifetime (check this
       with SELECT txid_current() < 2^31).
     * Fix initialization of "pg_clog" and "pg_subtrans" during hot
       standby startup (Andres Freund, Heikki Linnakangas)
       This bug can cause data loss on standby servers at the moment they
       start to accept hot-standby queries, by marking committed
       transactions as uncommitted. The likelihood of such corruption is
       small unless, at the time of standby startup, the primary server
       has executed many updating transactions since its last checkpoint.
       Symptoms include missing rows, rows that should have been deleted
       being still visible, and obsolete versions of updated rows being
       still visible alongside their newer versions.
       This bug was introduced in versions 9.3.0, 9.2.5, 9.1.10, and
       9.0.14. Standby servers that have only been running earlier
       releases are not at risk. It's recommended that standby servers
       that have ever run any of the buggy releases be re-cloned from the
       primary (e.g., with a new base backup) after upgrading.
     * Truncate "pg_multixact" contents during WAL replay (Andres Freund)
       This avoids ever-increasing disk space consumption in standby
       servers.
     * Fix race condition in GIN index posting tree page deletion (Heikki
       Linnakangas)
       This could lead to transient wrong answers or query failures.
     * Avoid flattening a subquery whose SELECT list contains a volatile
       function wrapped inside a sub-SELECT (Tom Lane)
       This avoids unexpected results due to extra evaluations of the
       volatile function.
     * Fix planner's processing of non-simple-variable subquery outputs
       nested within outer joins (Tom Lane)
       This error could lead to incorrect plans for queries involving
       multiple levels of subqueries within JOIN syntax.
     * Fix premature deletion of temporary files (Andres Freund)
     * Fix possible read past end of memory in rule printing (Peter
       Eisentraut)
     * Fix array slicing of int2vector and oidvector values (Tom Lane)
       Expressions of this kind are now implicitly promoted to regular
       int2 or oid arrays.
     * Fix incorrect behaviors when using a SQL-standard, simple GMT
       offset timezone (Tom Lane)
       In some cases, the system would use the simple GMT offset value
       when it should have used the regular timezone setting that had
       prevailed before the simple offset was selected. This change also
       causes the timeofday function to honor the simple GMT offset zone.
     * Prevent possible misbehavior when logging translations of Windows
       error codes (Tom Lane)
     * Properly quote generated command lines in pg_ctl (Naoya Anzai and
       Tom Lane)
       This fix applies only to Windows.
     * Fix pg_dumpall to work when a source database sets
       default_transaction_read_only via "ALTER DATABASE SET" (Kevin
       Grittner)
       Previously, the generated script would fail during restore.
     * Fix ecpg's processing of lists of variables declared varchar
       (Zoltan Boszormenyi)
     * Make "contrib/lo" defend against incorrect trigger definitions
       (Marc Cousin)
     * Update time zone data files to tzdata release 2013h for DST law
       changes in Argentina, Brazil, Jordan, Libya, Liechtenstein,
       Morocco, and Palestine. Also, new timezone abbreviations WIB, WIT,
       WITA for Indonesia.
     __________________________________________________________________

                               Release 9.0.14

     Release Date: 2013-10-10

   This release contains a variety of fixes from 9.0.13. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.14

   A dump/restore is not required for those running 9.0.X.

   However, if you are upgrading from a version earlier than 9.0.13, see
   the release notes for 9.0.13.
     __________________________________________________________________

Changes

     * Prevent corruption of multi-byte characters when attempting to
       case-fold identifiers (Andrew Dunstan)
       PostgreSQL case-folds non-ASCII characters only when using a
       single-byte server encoding.
     * Fix checkpoint memory leak in background writer when wal_level =
       hot_standby (Naoya Anzai)
     * Fix memory leak caused by lo_open() failure (Heikki Linnakangas)
     * Fix memory overcommit bug when work_mem is using more than 24GB of
       memory (Stephen Frost)
     * Fix deadlock bug in libpq when using SSL (Stephen Frost)
     * Fix possible SSL state corruption in threaded libpq applications
       (Nick Phillips, Stephen Frost)
     * Properly compute row estimates for boolean columns containing many
       NULL values (Andrew Gierth)
       Previously tests like col IS NOT TRUE and col IS NOT FALSE did not
       properly factor in NULL values when estimating plan costs.
     * Prevent pushing down WHERE clauses into unsafe UNION/INTERSECT
       subqueries (Tom Lane)
       Subqueries of a UNION or INTERSECT that contain set-returning
       functions or volatile functions in their SELECT lists could be
       improperly optimized, leading to run-time errors or incorrect query
       results.
     * Fix rare case of "failed to locate grouping columns" planner
       failure (Tom Lane)
     * Improve view dumping code's handling of dropped columns in
       referenced tables (Tom Lane)
     * Properly record index comments created using UNIQUE and PRIMARY KEY
       syntax (Andres Freund)
       This fixes a parallel pg_restore failure.
     * Fix "REINDEX TABLE" and "REINDEX DATABASE" to properly revalidate
       constraints and mark invalidated indexes as valid (Noah Misch)
       "REINDEX INDEX" has always worked properly.
     * Fix possible deadlock during concurrent "CREATE INDEX CONCURRENTLY"
       operations (Tom Lane)
     * Fix regexp_matches() handling of zero-length matches (Jeevan
       Chalke)
       Previously, zero-length matches like '^' could return too many
       matches.
     * Fix crash for overly-complex regular expressions (Heikki
       Linnakangas)
     * Fix regular expression match failures for back references combined
       with non-greedy quantifiers (Jeevan Chalke)
     * Prevent "CREATE FUNCTION" from checking "SET" variables unless
       function body checking is enabled (Tom Lane)
     * Allow "ALTER DEFAULT PRIVILEGES" to operate on schemas without
       requiring CREATE permission (Tom Lane)
     * Loosen restriction on keywords used in queries (Tom Lane)
       Specifically, lessen keyword restrictions for role names, language
       names, "EXPLAIN" and "COPY" options, and "SET" values. This allows
       COPY ... (FORMAT BINARY) to work as expected; previously BINARY
       needed to be quoted.
     * Fix pgp_pub_decrypt() so it works for secret keys with passwords
       (Marko Kreen)
     * Remove rare inaccurate warning during vacuum of index-less tables
       (Heikki Linnakangas)
     * Ensure that "VACUUM ANALYZE" still runs the ANALYZE phase if its
       attempt to truncate the file is cancelled due to lock conflicts
       (Kevin Grittner)
     * Avoid possible failure when performing transaction control commands
       (e.g ROLLBACK) in prepared queries (Tom Lane)
     * Ensure that floating-point data input accepts standard spellings of
       "infinity" on all platforms (Tom Lane)
       The C99 standard says that allowable spellings are inf, +inf, -inf,
       infinity, +infinity, and -infinity. Make sure we recognize these
       even if the platform's strtod function doesn't.
     * Expand ability to compare rows to records and arrays (Rafal
       Rzepecki, Tom Lane)
     * Update time zone data files to tzdata release 2013d for DST law
       changes in Israel, Morocco, Palestine, and Paraguay. Also,
       historical zone data corrections for Macquarie Island.
     __________________________________________________________________

                               Release 9.0.13

     Release Date: 2013-04-04

   This release contains a variety of fixes from 9.0.12. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.13

   A dump/restore is not required for those running 9.0.X.

   However, this release corrects several errors in management of GiST
   indexes. After installing this update, it is advisable to "REINDEX" any
   GiST indexes that meet one or more of the conditions described below.

   Also, if you are upgrading from a version earlier than 9.0.6, see the
   release notes for 9.0.6.
     __________________________________________________________________

Changes

     * Fix insecure parsing of server command-line switches (Mitsumasa
       Kondo, Kyotaro Horiguchi)
       A connection request containing a database name that begins with
       "-" could be crafted to damage or destroy files within the server's
       data directory, even if the request is eventually rejected.
       (CVE-2013-1899)
     * Reset OpenSSL randomness state in each postmaster child process
       (Marko Kreen)
       This avoids a scenario wherein random numbers generated by
       "contrib/pgcrypto" functions might be relatively easy for another
       database user to guess. The risk is only significant when the
       postmaster is configured with ssl = on but most connections don't
       use SSL encryption. (CVE-2013-1900)
     * Fix GiST indexes to not use "fuzzy" geometric comparisons when it's
       not appropriate to do so (Alexander Korotkov)
       The core geometric types perform comparisons using "fuzzy"
       equality, but gist_box_same must do exact comparisons, else GiST
       indexes using it might become inconsistent. After installing this
       update, users should "REINDEX" any GiST indexes on box, polygon,
       circle, or point columns, since all of these use gist_box_same.
     * Fix erroneous range-union and penalty logic in GiST indexes that
       use "contrib/btree_gist" for variable-width data types, that is
       text, bytea, bit, and numeric columns (Tom Lane)
       These errors could result in inconsistent indexes in which some
       keys that are present would not be found by searches, and also in
       useless index bloat. Users are advised to "REINDEX" such indexes
       after installing this update.
     * Fix bugs in GiST page splitting code for multi-column indexes (Tom
       Lane)
       These errors could result in inconsistent indexes in which some
       keys that are present would not be found by searches, and also in
       indexes that are unnecessarily inefficient to search. Users are
       advised to "REINDEX" multi-column GiST indexes after installing
       this update.
     * Fix gist_point_consistent to handle fuzziness consistently
       (Alexander Korotkov)
       Index scans on GiST indexes on point columns would sometimes yield
       results different from a sequential scan, because
       gist_point_consistent disagreed with the underlying operator code
       about whether to do comparisons exactly or fuzzily.
     * Fix buffer leak in WAL replay (Heikki Linnakangas)
       This bug could result in "incorrect local pin count" errors during
       replay, making recovery impossible.
     * Fix race condition in "DELETE RETURNING" (Tom Lane)
       Under the right circumstances, "DELETE RETURNING" could attempt to
       fetch data from a shared buffer that the current process no longer
       has any pin on. If some other process changed the buffer meanwhile,
       this would lead to garbage RETURNING output, or even a crash.
     * Fix infinite-loop risk in regular expression compilation (Tom Lane,
       Don Porter)
     * Fix potential null-pointer dereference in regular expression
       compilation (Tom Lane)
     * Fix to_char() to use ASCII-only case-folding rules where
       appropriate (Tom Lane)
       This fixes misbehavior of some template patterns that should be
       locale-independent, but mishandled "I" and "i" in Turkish locales.
     * Fix unwanted rejection of timestamp 1999-12-31 24:00:00 (Tom Lane)
     * Fix logic error when a single transaction does "UNLISTEN" then
       "LISTEN" (Tom Lane)
       The session wound up not listening for notify events at all, though
       it surely should listen in this case.
     * Remove useless "picksplit doesn't support secondary split" log
       messages (Josh Hansen, Tom Lane)
       This message seems to have been added in expectation of code that
       was never written, and probably never will be, since GiST's default
       handling of secondary splits is actually pretty good. So stop
       nagging end users about it.
     * Fix possible failure to send a session's last few transaction
       commit/abort counts to the statistics collector (Tom Lane)
     * Eliminate memory leaks in PL/Perl's spi_prepare() function (Alex
       Hunsaker, Tom Lane)
     * Fix pg_dumpall to handle database names containing "=" correctly
       (Heikki Linnakangas)
     * Avoid crash in pg_dump when an incorrect connection string is given
       (Heikki Linnakangas)
     * Ignore invalid indexes in pg_dump and pg_upgrade (Michael Paquier,
       Bruce Momjian)
       Dumping invalid indexes can cause problems at restore time, for
       example if the reason the index creation failed was because it
       tried to enforce a uniqueness condition not satisfied by the
       table's data. Also, if the index creation is in fact still in
       progress, it seems reasonable to consider it to be an uncommitted
       DDL change, which pg_dump wouldn't be expected to dump anyway.
       pg_upgrade now also skips invalid indexes rather than failing.
     * Fix "contrib/pg_trgm"'s similarity() function to return zero for
       trigram-less strings (Tom Lane)
       Previously it returned NaN due to internal division by zero.
     * Update time zone data files to tzdata release 2013b for DST law
       changes in Chile, Haiti, Morocco, Paraguay, and some Russian areas.
       Also, historical zone data corrections for numerous places.
       Also, update the time zone abbreviation files for recent changes in
       Russia and elsewhere: CHOT, GET, IRKT, KGT, KRAT, MAGT, MAWT, MSK,
       NOVT, OMST, TKT, VLAT, WST, YAKT, YEKT now follow their current
       meanings, and VOLT (Europe/Volgograd) and MIST
       (Antarctica/Macquarie) are added to the default abbreviations list.
     __________________________________________________________________

                               Release 9.0.12

     Release Date: 2013-02-07

   This release contains a variety of fixes from 9.0.11. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.12

   A dump/restore is not required for those running 9.0.X.

   However, if you are upgrading from a version earlier than 9.0.6, see
   the release notes for 9.0.6.
     __________________________________________________________________

Changes

     * Prevent execution of enum_recv from SQL (Tom Lane)
       The function was misdeclared, allowing a simple SQL command to
       crash the server. In principle an attacker might be able to use it
       to examine the contents of server memory. Our thanks to Sumit Soni
       (via Secunia SVCRP) for reporting this issue. (CVE-2013-0255)
     * Fix multiple problems in detection of when a consistent database
       state has been reached during WAL replay (Fujii Masao, Heikki
       Linnakangas, Simon Riggs, Andres Freund)
     * Update minimum recovery point when truncating a relation file
       (Heikki Linnakangas)
       Once data has been discarded, it's no longer safe to stop recovery
       at an earlier point in the timeline.
     * Fix missing cancellations in hot standby mode (Noah Misch, Simon
       Riggs)
       The need to cancel conflicting hot-standby queries would sometimes
       be missed, allowing those queries to see inconsistent data.
     * Fix SQL grammar to allow subscripting or field selection from a
       sub-SELECT result (Tom Lane)
     * Fix performance problems with autovacuum truncation in busy
       workloads (Jan Wieck)
       Truncation of empty pages at the end of a table requires exclusive
       lock, but autovacuum was coded to fail (and release the table lock)
       when there are conflicting lock requests. Under load, it is easily
       possible that truncation would never occur, resulting in table
       bloat. Fix by performing a partial truncation, releasing the lock,
       then attempting to re-acquire the lock and continue. This fix also
       greatly reduces the average time before autovacuum releases the
       lock after a conflicting request arrives.
     * Protect against race conditions when scanning pg_tablespace
       (Stephen Frost, Tom Lane)
       "CREATE DATABASE" and "DROP DATABASE" could misbehave if there were
       concurrent updates of pg_tablespace entries.
     * Prevent "DROP OWNED" from trying to drop whole databases or
       tablespaces (Alvaro Herrera)
       For safety, ownership of these objects must be reassigned, not
       dropped.
     * Fix error in vacuum_freeze_table_age implementation (Andres Freund)
       In installations that have existed for more than
       vacuum_freeze_min_age transactions, this mistake prevented
       autovacuum from using partial-table scans, so that a full-table
       scan would always happen instead.
     * Prevent misbehavior when a RowExpr or XmlExpr is parse-analyzed
       twice (Andres Freund, Tom Lane)
       This mistake could be user-visible in contexts such as CREATE TABLE
       LIKE INCLUDING INDEXES.
     * Improve defenses against integer overflow in hashtable sizing
       calculations (Jeff Davis)
     * Reject out-of-range dates in to_date() (Hitoshi Harada)
     * Ensure that non-ASCII prompt strings are translated to the correct
       code page on Windows (Alexander Law, Noah Misch)
       This bug affected psql and some other client programs.
     * Fix possible crash in psql's "\?" command when not connected to a
       database (Meng Qingzhong)
     * Fix pg_upgrade to deal with invalid indexes safely (Bruce Momjian)
     * Fix one-byte buffer overrun in libpq's PQprintTuples (Xi Wang)
       This ancient function is not used anywhere by PostgreSQL itself,
       but it might still be used by some client code.
     * Make ecpglib use translated messages properly (Chen Huajun)
     * Properly install ecpg_compat and pgtypes libraries on MSVC (Jiang
       Guiqing)
     * Include our version of isinf() in libecpg if it's not provided by
       the system (Jiang Guiqing)
     * Rearrange configure's tests for supplied functions so it is not
       fooled by bogus exports from libedit/libreadline (Christoph Berg)
     * Ensure Windows build number increases over time (Magnus Hagander)
     * Make pgxs build executables with the right .exe suffix when
       cross-compiling for Windows (Zoltan Boszormenyi)
     * Add new timezone abbreviation FET (Tom Lane)
       This is now used in some eastern-European time zones.
     __________________________________________________________________

                               Release 9.0.11

     Release Date: 2012-12-06

   This release contains a variety of fixes from 9.0.10. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.11

   A dump/restore is not required for those running 9.0.X.

   However, if you are upgrading from a version earlier than 9.0.6, see
   the release notes for 9.0.6.
     __________________________________________________________________

Changes

     * Fix multiple bugs associated with "CREATE INDEX CONCURRENTLY"
       (Andres Freund, Tom Lane)
       Fix "CREATE INDEX CONCURRENTLY" to use in-place updates when
       changing the state of an index's pg_index row. This prevents race
       conditions that could cause concurrent sessions to miss updating
       the target index, thus resulting in corrupt concurrently-created
       indexes.
       Also, fix various other operations to ensure that they ignore
       invalid indexes resulting from a failed "CREATE INDEX CONCURRENTLY"
       command. The most important of these is "VACUUM", because an
       auto-vacuum could easily be launched on the table before corrective
       action can be taken to fix or remove the invalid index.
     * Fix buffer locking during WAL replay (Tom Lane)
       The WAL replay code was insufficiently careful about locking
       buffers when replaying WAL records that affect more than one page.
       This could result in hot standby queries transiently seeing
       inconsistent states, resulting in wrong answers or unexpected
       failures.
     * Fix an error in WAL generation logic for GIN indexes (Tom Lane)
       This could result in index corruption, if a torn-page failure
       occurred.
     * Properly remove startup process's virtual XID lock when promoting a
       hot standby server to normal running (Simon Riggs)
       This oversight could prevent subsequent execution of certain
       operations such as "CREATE INDEX CONCURRENTLY".
     * Avoid bogus "out-of-sequence timeline ID" errors in standby mode
       (Heikki Linnakangas)
     * Prevent the postmaster from launching new child processes after
       it's received a shutdown signal (Tom Lane)
       This mistake could result in shutdown taking longer than it should,
       or even never completing at all without additional user action.
     * Avoid corruption of internal hash tables when out of memory
       (Hitoshi Harada)
     * Fix planning of non-strict equivalence clauses above outer joins
       (Tom Lane)
       The planner could derive incorrect constraints from a clause
       equating a non-strict construct to something else, for example
       WHERE COALESCE(foo, 0) = 0 when foo is coming from the nullable
       side of an outer join.
     * Improve planner's ability to prove exclusion constraints from
       equivalence classes (Tom Lane)
     * Fix partial-row matching in hashed subplans to handle cross-type
       cases correctly (Tom Lane)
       This affects multicolumn NOT IN subplans, such as WHERE (a, b) NOT
       IN (SELECT x, y FROM ...) when for instance b and y are int4 and
       int8 respectively. This mistake led to wrong answers or crashes
       depending on the specific datatypes involved.
     * Acquire buffer lock when re-fetching the old tuple for an AFTER ROW
       UPDATE/DELETE trigger (Andres Freund)
       In very unusual circumstances, this oversight could result in
       passing incorrect data to the precheck logic for a foreign-key
       enforcement trigger. That could result in a crash, or in an
       incorrect decision about whether to fire the trigger.
     * Fix "ALTER COLUMN TYPE" to handle inherited check constraints
       properly (Pavan Deolasee)
       This worked correctly in pre-8.4 releases, and now works correctly
       in 8.4 and later.
     * Fix "REASSIGN OWNED" to handle grants on tablespaces (Alvaro
       Herrera)
     * Ignore incorrect pg_attribute entries for system columns for views
       (Tom Lane)
       Views do not have any system columns. However, we forgot to remove
       such entries when converting a table to a view. That's fixed
       properly for 9.3 and later, but in previous branches we need to
       defend against existing mis-converted views.
     * Fix rule printing to dump INSERT INTO table DEFAULT VALUES
       correctly (Tom Lane)
     * Guard against stack overflow when there are too many
       UNION/INTERSECT/EXCEPT clauses in a query (Tom Lane)
     * Prevent platform-dependent failures when dividing the minimum
       possible integer value by -1 (Xi Wang, Tom Lane)
     * Fix possible access past end of string in date parsing (Hitoshi
       Harada)
     * Fix failure to advance XID epoch if XID wraparound happens during a
       checkpoint and wal_level is hot_standby (Tom Lane, Andres Freund)
       While this mistake had no particular impact on PostgreSQL itself,
       it was bad for applications that rely on txid_current() and related
       functions: the TXID value would appear to go backwards.
     * Produce an understandable error message if the length of the path
       name for a Unix-domain socket exceeds the platform-specific limit
       (Tom Lane, Andrew Dunstan)
       Formerly, this would result in something quite unhelpful, such as
       "Non-recoverable failure in name resolution".
     * Fix memory leaks when sending composite column values to the client
       (Tom Lane)
     * Make pg_ctl more robust about reading the "postmaster.pid" file
       (Heikki Linnakangas)
       Fix race conditions and possible file descriptor leakage.
     * Fix possible crash in psql if incorrectly-encoded data is presented
       and the client_encoding setting is a client-only encoding, such as
       SJIS (Jiang Guiqing)
     * Fix bugs in the "restore.sql" script emitted by pg_dump in tar
       output format (Tom Lane)
       The script would fail outright on tables whose names include
       upper-case characters. Also, make the script capable of restoring
       data in "--inserts" mode as well as the regular COPY mode.
     * Fix pg_restore to accept POSIX-conformant tar files (Brian Weaver,
       Tom Lane)
       The original coding of pg_dump's tar output mode produced files
       that are not fully conformant with the POSIX standard. This has
       been corrected for version 9.3. This patch updates previous
       branches so that they will accept both the incorrect and the
       corrected formats, in hopes of avoiding compatibility problems when
       9.3 comes out.
     * Fix pg_resetxlog to locate "postmaster.pid" correctly when given a
       relative path to the data directory (Tom Lane)
       This mistake could lead to pg_resetxlog not noticing that there is
       an active postmaster using the data directory.
     * Fix libpq's lo_import() and lo_export() functions to report file
       I/O errors properly (Tom Lane)
     * Fix ecpg's processing of nested structure pointer variables
       (Muhammad Usama)
     * Fix ecpg's ecpg_get_data function to handle arrays properly
       (Michael Meskes)
     * Make "contrib/pageinspect"'s btree page inspection functions take
       buffer locks while examining pages (Tom Lane)
     * Fix pgxs support for building loadable modules on AIX (Tom Lane)
       Building modules outside the original source tree didn't work on
       AIX.
     * Update time zone data files to tzdata release 2012j for DST law
       changes in Cuba, Israel, Jordan, Libya, Palestine, Western Samoa,
       and portions of Brazil.
     __________________________________________________________________

                               Release 9.0.10

     Release Date: 2012-09-24

   This release contains a variety of fixes from 9.0.9. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.10

   A dump/restore is not required for those running 9.0.X.

   However, if you are upgrading from a version earlier than 9.0.6, see
   the release notes for 9.0.6.
     __________________________________________________________________

Changes

     * Fix planner's assignment of executor parameters, and fix executor's
       rescan logic for CTE plan nodes (Tom Lane)
       These errors could result in wrong answers from queries that scan
       the same WITH subquery multiple times.
     * Improve page-splitting decisions in GiST indexes (Alexander
       Korotkov, Robert Haas, Tom Lane)
       Multi-column GiST indexes might suffer unexpected bloat due to this
       error.
     * Fix cascading privilege revoke to stop if privileges are still held
       (Tom Lane)
       If we revoke a grant option from some role "X", but "X" still holds
       that option via a grant from someone else, we should not
       recursively revoke the corresponding privilege from role(s) "Y"
       that "X" had granted it to.
     * Improve error messages for Hot Standby misconfiguration errors
       (Gurjeet Singh)
     * Fix handling of SIGFPE when PL/Perl is in use (Andres Freund)
       Perl resets the process's SIGFPE handler to SIG_IGN, which could
       result in crashes later on. Restore the normal Postgres signal
       handler after initializing PL/Perl.
     * Prevent PL/Perl from crashing if a recursive PL/Perl function is
       redefined while being executed (Tom Lane)
     * Work around possible misoptimization in PL/Perl (Tom Lane)
       Some Linux distributions contain an incorrect version of
       "pthread.h" that results in incorrect compiled code in PL/Perl,
       leading to crashes if a PL/Perl function calls another one that
       throws an error.
     * Fix pg_upgrade's handling of line endings on Windows (Andrew
       Dunstan)
       Previously, pg_upgrade might add or remove carriage returns in
       places such as function bodies.
     * On Windows, make pg_upgrade use backslash path separators in the
       scripts it emits (Andrew Dunstan)
     * Update time zone data files to tzdata release 2012f for DST law
       changes in Fiji
     __________________________________________________________________

                                Release 9.0.9

     Release Date: 2012-08-17

   This release contains a variety of fixes from 9.0.8. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.9

   A dump/restore is not required for those running 9.0.X.

   However, if you are upgrading from a version earlier than 9.0.6, see
   the release notes for 9.0.6.
     __________________________________________________________________

Changes

     * Prevent access to external files/URLs via XML entity references
       (Noah Misch, Tom Lane)
       xml_parse() would attempt to fetch external files or URLs as needed
       to resolve DTD and entity references in an XML value, thus allowing
       unprivileged database users to attempt to fetch data with the
       privileges of the database server. While the external data wouldn't
       get returned directly to the user, portions of it could be exposed
       in error messages if the data didn't parse as valid XML; and in any
       case the mere ability to check existence of a file might be useful
       to an attacker. (CVE-2012-3489)
     * Prevent access to external files/URLs via "contrib/xml2"'s
       xslt_process() (Peter Eisentraut)
       libxslt offers the ability to read and write both files and URLs
       through stylesheet commands, thus allowing unprivileged database
       users to both read and write data with the privileges of the
       database server. Disable that through proper use of libxslt's
       security options. (CVE-2012-3488)
       Also, remove xslt_process()'s ability to fetch documents and
       stylesheets from external files/URLs. While this was a documented
       "feature", it was long regarded as a bad idea. The fix for
       CVE-2012-3489 broke that capability, and rather than expend effort
       on trying to fix it, we're just going to summarily remove it.
     * Prevent too-early recycling of btree index pages (Noah Misch)
       When we allowed read-only transactions to skip assigning XIDs, we
       introduced the possibility that a deleted btree page could be
       recycled while a read-only transaction was still in flight to it.
       This would result in incorrect index search results. The
       probability of such an error occurring in the field seems very low
       because of the timing requirements, but nonetheless it should be
       fixed.
     * Fix crash-safety bug with newly-created-or-reset sequences (Tom
       Lane)
       If "ALTER SEQUENCE" was executed on a freshly created or reset
       sequence, and then precisely one nextval() call was made on it, and
       then the server crashed, WAL replay would restore the sequence to a
       state in which it appeared that no nextval() had been done, thus
       allowing the first sequence value to be returned again by the next
       nextval() call. In particular this could manifest for serial
       columns, since creation of a serial column's sequence includes an
       "ALTER SEQUENCE OWNED BY" step.
     * Fix txid_current() to report the correct epoch when not in hot
       standby (Heikki Linnakangas)
       This fixes a regression introduced in the previous minor release.
     * Fix bug in startup of Hot Standby when a master transaction has
       many subtransactions (Andres Freund)
       This mistake led to failures reported as "out-of-order XID
       insertion in KnownAssignedXids".
     * Ensure the "backup_label" file is fsync'd after pg_start_backup()
       (Dave Kerr)
     * Fix timeout handling in walsender processes (Tom Lane)
       WAL sender background processes neglected to establish a SIGALRM
       handler, meaning they would wait forever in some corner cases where
       a timeout ought to happen.
     * Back-patch 9.1 improvement to compress the fsync request queue
       (Robert Haas)
       This improves performance during checkpoints. The 9.1 change has
       now seen enough field testing to seem safe to back-patch.
     * Fix LISTEN/NOTIFY to cope better with I/O problems, such as out of
       disk space (Tom Lane)
       After a write failure, all subsequent attempts to send more NOTIFY
       messages would fail with messages like "Could not read from file
       "pg_notify/nnnn" at offset nnnnn: Success".
     * Only allow autovacuum to be auto-canceled by a directly blocked
       process (Tom Lane)
       The original coding could allow inconsistent behavior in some
       cases; in particular, an autovacuum could get canceled after less
       than deadlock_timeout grace period.
     * Improve logging of autovacuum cancels (Robert Haas)
     * Fix log collector so that log_truncate_on_rotation works during the
       very first log rotation after server start (Tom Lane)
     * Fix WITH attached to a nested set operation
       (UNION/INTERSECT/EXCEPT) (Tom Lane)
     * Ensure that a whole-row reference to a subquery doesn't include any
       extra GROUP BY or ORDER BY columns (Tom Lane)
     * Disallow copying whole-row references in CHECK constraints and
       index definitions during "CREATE TABLE" (Tom Lane)
       This situation can arise in "CREATE TABLE" with LIKE or INHERITS.
       The copied whole-row variable was incorrectly labeled with the row
       type of the original table not the new one. Rejecting the case
       seems reasonable for LIKE, since the row types might well diverge
       later. For INHERITS we should ideally allow it, with an implicit
       coercion to the parent table's row type; but that will require more
       work than seems safe to back-patch.
     * Fix memory leak in ARRAY(SELECT ...) subqueries (Heikki
       Linnakangas, Tom Lane)
     * Fix extraction of common prefixes from regular expressions (Tom
       Lane)
       The code could get confused by quantified parenthesized
       subexpressions, such as ^(foo)?bar. This would lead to incorrect
       index optimization of searches for such patterns.
     * Fix bugs with parsing signed "hh":"mm" and "hh":"mm":"ss" fields in
       interval constants (Amit Kapila, Tom Lane)
     * Use Postgres' encoding conversion functions, not Python's, when
       converting a Python Unicode string to the server encoding in
       PL/Python (Jan Urbanski)
       This avoids some corner-case problems, notably that Python doesn't
       support all the encodings Postgres does. A notable functional
       change is that if the server encoding is SQL_ASCII, you will get
       the UTF-8 representation of the string; formerly, any non-ASCII
       characters in the string would result in an error.
     * Fix mapping of PostgreSQL encodings to Python encodings in
       PL/Python (Jan Urbanski)
     * Report errors properly in "contrib/xml2"'s xslt_process() (Tom
       Lane)
     * Update time zone data files to tzdata release 2012e for DST law
       changes in Morocco and Tokelau
     __________________________________________________________________

                                Release 9.0.8

     Release Date: 2012-06-04

   This release contains a variety of fixes from 9.0.7. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.8

   A dump/restore is not required for those running 9.0.X.

   However, if you are upgrading from a version earlier than 9.0.6, see
   the release notes for 9.0.6.
     __________________________________________________________________

Changes

     * Fix incorrect password transformation in "contrib/pgcrypto"'s DES
       crypt() function (Solar Designer)
       If a password string contained the byte value 0x80, the remainder
       of the password was ignored, causing the password to be much weaker
       than it appeared. With this fix, the rest of the string is properly
       included in the DES hash. Any stored password values that are
       affected by this bug will thus no longer match, so the stored
       values may need to be updated. (CVE-2012-2143)
     * Ignore SECURITY DEFINER and SET attributes for a procedural
       language's call handler (Tom Lane)
       Applying such attributes to a call handler could crash the server.
       (CVE-2012-2655)
     * Allow numeric timezone offsets in timestamp input to be up to 16
       hours away from UTC (Tom Lane)
       Some historical time zones have offsets larger than 15 hours, the
       previous limit. This could result in dumped data values being
       rejected during reload.
     * Fix timestamp conversion to cope when the given time is exactly the
       last DST transition time for the current timezone (Tom Lane)
       This oversight has been there a long time, but was not noticed
       previously because most DST-using zones are presumed to have an
       indefinite sequence of future DST transitions.
     * Fix text to name and char to name casts to perform string
       truncation correctly in multibyte encodings (Karl Schnaitter)
     * Fix memory copying bug in to_tsquery() (Heikki Linnakangas)
     * Ensure txid_current() reports the correct epoch when executed in
       hot standby (Simon Riggs)
     * Fix planner's handling of outer PlaceHolderVars within subqueries
       (Tom Lane)
       This bug concerns sub-SELECTs that reference variables coming from
       the nullable side of an outer join of the surrounding query. In
       9.1, queries affected by this bug would fail with "ERROR:
       Upper-level PlaceHolderVar found where not expected". But in 9.0
       and 8.4, you'd silently get possibly-wrong answers, since the value
       transmitted into the subquery wouldn't go to null when it should.
     * Fix slow session startup when pg_attribute is very large (Tom Lane)
       If pg_attribute exceeds one-fourth of shared_buffers, cache
       rebuilding code that is sometimes needed during session start would
       trigger the synchronized-scan logic, causing it to take many times
       longer than normal. The problem was particularly acute if many new
       sessions were starting at once.
     * Ensure sequential scans check for query cancel reasonably often
       (Merlin Moncure)
       A scan encountering many consecutive pages that contain no live
       tuples would not respond to interrupts meanwhile.
     * Ensure the Windows implementation of PGSemaphoreLock() clears
       ImmediateInterruptOK before returning (Tom Lane)
       This oversight meant that a query-cancel interrupt received later
       in the same query could be accepted at an unsafe time, with
       unpredictable but not good consequences.
     * Show whole-row variables safely when printing views or rules (Abbas
       Butt, Tom Lane)
       Corner cases involving ambiguous names (that is, the name could be
       either a table or column name of the query) were printed in an
       ambiguous way, risking that the view or rule would be interpreted
       differently after dump and reload. Avoid the ambiguous case by
       attaching a no-op cast.
     * Fix "COPY FROM" to properly handle null marker strings that
       correspond to invalid encoding (Tom Lane)
       A null marker string such as E'\\0' should work, and did work in
       the past, but the case got broken in 8.4.
     * Ensure autovacuum worker processes perform stack depth checking
       properly (Heikki Linnakangas)
       Previously, infinite recursion in a function invoked by
       auto-"ANALYZE" could crash worker processes.
     * Fix logging collector to not lose log coherency under high load
       (Andrew Dunstan)
       The collector previously could fail to reassemble large messages if
       it got too busy.
     * Fix logging collector to ensure it will restart file rotation after
       receiving SIGHUP (Tom Lane)
     * Fix WAL replay logic for GIN indexes to not fail if the index was
       subsequently dropped (Tom Lane)
     * Fix memory leak in PL/pgSQL's "RETURN NEXT" command (Joe Conway)
     * Fix PL/pgSQL's "GET DIAGNOSTICS" command when the target is the
       function's first variable (Tom Lane)
     * Fix potential access off the end of memory in psql's expanded
       display ("\x") mode (Peter Eisentraut)
     * Fix several performance problems in pg_dump when the database
       contains many objects (Jeff Janes, Tom Lane)
       pg_dump could get very slow if the database contained many schemas,
       or if many objects are in dependency loops, or if there are many
       owned sequences.
     * Fix pg_upgrade for the case that a database stored in a non-default
       tablespace contains a table in the cluster's default tablespace
       (Bruce Momjian)
     * In ecpg, fix rare memory leaks and possible overwrite of one byte
       after the sqlca_t structure (Peter Eisentraut)
     * Fix "contrib/dblink"'s dblink_exec() to not leak temporary database
       connections upon error (Tom Lane)
     * Fix "contrib/dblink" to report the correct connection name in error
       messages (Kyotaro Horiguchi)
     * Fix "contrib/vacuumlo" to use multiple transactions when dropping
       many large objects (Tim Lewis, Robert Haas, Tom Lane)
       This change avoids exceeding max_locks_per_transaction when many
       objects need to be dropped. The behavior can be adjusted with the
       new -l (limit) option.
     * Update time zone data files to tzdata release 2012c for DST law
       changes in Antarctica, Armenia, Chile, Cuba, Falkland Islands,
       Gaza, Haiti, Hebron, Morocco, Syria, and Tokelau Islands; also
       historical corrections for Canada.
     __________________________________________________________________

                                Release 9.0.7

     Release Date: 2012-02-27

   This release contains a variety of fixes from 9.0.6. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.7

   A dump/restore is not required for those running 9.0.X.

   However, if you are upgrading from a version earlier than 9.0.6, see
   the release notes for 9.0.6.
     __________________________________________________________________

Changes

     * Require execute permission on the trigger function for "CREATE
       TRIGGER" (Robert Haas)
       This missing check could allow another user to execute a trigger
       function with forged input data, by installing it on a table he
       owns. This is only of significance for trigger functions marked
       SECURITY DEFINER, since otherwise trigger functions run as the
       table owner anyway. (CVE-2012-0866)
     * Remove arbitrary limitation on length of common name in SSL
       certificates (Heikki Linnakangas)
       Both libpq and the server truncated the common name extracted from
       an SSL certificate at 32 bytes. Normally this would cause nothing
       worse than an unexpected verification failure, but there are some
       rather-implausible scenarios in which it might allow one
       certificate holder to impersonate another. The victim would have to
       have a common name exactly 32 bytes long, and the attacker would
       have to persuade a trusted CA to issue a certificate in which the
       common name has that string as a prefix. Impersonating a server
       would also require some additional exploit to redirect client
       connections. (CVE-2012-0867)
     * Convert newlines to spaces in names written in pg_dump comments
       (Robert Haas)
       pg_dump was incautious about sanitizing object names that are
       emitted within SQL comments in its output script. A name containing
       a newline would at least render the script syntactically incorrect.
       Maliciously crafted object names could present a SQL injection risk
       when the script is reloaded. (CVE-2012-0868)
     * Fix btree index corruption from insertions concurrent with
       vacuuming (Tom Lane)
       An index page split caused by an insertion could sometimes cause a
       concurrently-running "VACUUM" to miss removing index entries that
       it should remove. After the corresponding table rows are removed,
       the dangling index entries would cause errors (such as "could not
       read block N in file ...") or worse, silently wrong query results
       after unrelated rows are re-inserted at the now-free table
       locations. This bug has been present since release 8.2, but occurs
       so infrequently that it was not diagnosed until now. If you have
       reason to suspect that it has happened in your database, reindexing
       the affected index will fix things.
     * Fix transient zeroing of shared buffers during WAL replay (Tom
       Lane)
       The replay logic would sometimes zero and refill a shared buffer,
       so that the contents were transiently invalid. In hot standby mode
       this can result in a query that's executing in parallel seeing
       garbage data. Various symptoms could result from that, but the most
       common one seems to be "invalid memory alloc request size".
     * Fix postmaster to attempt restart after a hot-standby crash (Tom
       Lane)
       A logic error caused the postmaster to terminate, rather than
       attempt to restart the cluster, if any backend process crashed
       while operating in hot standby mode.
     * Fix "CLUSTER"/"VACUUM FULL" handling of toast values owned by
       recently-updated rows (Tom Lane)
       This oversight could lead to "duplicate key value violates unique
       constraint" errors being reported against the toast table's index
       during one of these commands.
     * Update per-column permissions, not only per-table permissions, when
       changing table owner (Tom Lane)
       Failure to do this meant that any previously granted column
       permissions were still shown as having been granted by the old
       owner. This meant that neither the new owner nor a superuser could
       revoke the now-untraceable-to-table-owner permissions.
     * Support foreign data wrappers and foreign servers in "REASSIGN
       OWNED" (Alvaro Herrera)
       This command failed with "unexpected classid" errors if it needed
       to change the ownership of any such objects.
     * Allow non-existent values for some settings in "ALTER USER/DATABASE
       SET" (Heikki Linnakangas)
       Allow default_text_search_config, default_tablespace, and
       temp_tablespaces to be set to names that are not known. This is
       because they might be known in another database where the setting
       is intended to be used, or for the tablespace cases because the
       tablespace might not be created yet. The same issue was previously
       recognized for search_path, and these settings now act like that
       one.
     * Avoid crashing when we have problems deleting table files
       post-commit (Tom Lane)
       Dropping a table should lead to deleting the underlying disk files
       only after the transaction commits. In event of failure then (for
       instance, because of wrong file permissions) the code is supposed
       to just emit a warning message and go on, since it's too late to
       abort the transaction. This logic got broken as of release 8.4,
       causing such situations to result in a PANIC and an unrestartable
       database.
     * Recover from errors occurring during WAL replay of "DROP
       TABLESPACE" (Tom Lane)
       Replay will attempt to remove the tablespace's directories, but
       there are various reasons why this might fail (for example,
       incorrect ownership or permissions on those directories). Formerly
       the replay code would panic, rendering the database unrestartable
       without manual intervention. It seems better to log the problem and
       continue, since the only consequence of failure to remove the
       directories is some wasted disk space.
     * Fix race condition in logging AccessExclusiveLocks for hot standby
       (Simon Riggs)
       Sometimes a lock would be logged as being held by "transaction
       zero". This is at least known to produce assertion failures on
       slave servers, and might be the cause of more serious problems.
     * Track the OID counter correctly during WAL replay, even when it
       wraps around (Tom Lane)
       Previously the OID counter would remain stuck at a high value until
       the system exited replay mode. The practical consequences of that
       are usually nil, but there are scenarios wherein a standby server
       that's been promoted to master might take a long time to advance
       the OID counter to a reasonable value once values are needed.
     * Prevent emitting misleading "consistent recovery state reached" log
       message at the beginning of crash recovery (Heikki Linnakangas)
     * Fix initial value of pg_stat_replication.replay_location (Fujii
       Masao)
       Previously, the value shown would be wrong until at least one WAL
       record had been replayed.
     * Fix regular expression back-references with * attached (Tom Lane)
       Rather than enforcing an exact string match, the code would
       effectively accept any string that satisfies the pattern
       sub-expression referenced by the back-reference symbol.
       A similar problem still afflicts back-references that are embedded
       in a larger quantified expression, rather than being the immediate
       subject of the quantifier. This will be addressed in a future
       PostgreSQL release.
     * Fix recently-introduced memory leak in processing of inet/cidr
       values (Heikki Linnakangas)
       A patch in the December 2011 releases of PostgreSQL caused memory
       leakage in these operations, which could be significant in
       scenarios such as building a btree index on such a column.
     * Fix dangling pointer after "CREATE TABLE AS"/"SELECT INTO" in a
       SQL-language function (Tom Lane)
       In most cases this only led to an assertion failure in
       assert-enabled builds, but worse consequences seem possible.
     * Avoid double close of file handle in syslogger on Windows (MauMau)
       Ordinarily this error was invisible, but it would cause an
       exception when running on a debug version of Windows.
     * Fix I/O-conversion-related memory leaks in plpgsql (Andres Freund,
       Jan Urbanski, Tom Lane)
       Certain operations would leak memory until the end of the current
       function.
     * Improve pg_dump's handling of inherited table columns (Tom Lane)
       pg_dump mishandled situations where a child column has a different
       default expression than its parent column. If the default is
       textually identical to the parent's default, but not actually the
       same (for instance, because of schema search path differences) it
       would not be recognized as different, so that after dump and
       restore the child would be allowed to inherit the parent's default.
       Child columns that are NOT NULL where their parent is not could
       also be restored subtly incorrectly.
     * Fix pg_restore's direct-to-database mode for INSERT-style table
       data (Tom Lane)
       Direct-to-database restores from archive files made with
       "--inserts" or "--column-inserts" options fail when using
       pg_restore from a release dated September or December 2011, as a
       result of an oversight in a fix for another problem. The archive
       file itself is not at fault, and text-mode output is okay.
     * Allow pg_upgrade to process tables containing regclass columns
       (Bruce Momjian)
       Since pg_upgrade now takes care to preserve pg_class OIDs, there
       was no longer any reason for this restriction.
     * Make libpq ignore ENOTDIR errors when looking for an SSL client
       certificate file (Magnus Hagander)
       This allows SSL connections to be established, though without a
       certificate, even when the user's home directory is set to
       something like /dev/null.
     * Fix some more field alignment issues in ecpg's SQLDA area (Zoltan
       Boszormenyi)
     * Allow AT option in ecpg DEALLOCATE statements (Michael Meskes)
       The infrastructure to support this has been there for awhile, but
       through an oversight there was still an error check rejecting the
       case.
     * Do not use the variable name when defining a varchar structure in
       ecpg (Michael Meskes)
     * Fix "contrib/auto_explain"'s JSON output mode to produce valid JSON
       (Andrew Dunstan)
       The output used brackets at the top level, when it should have used
       braces.
     * Fix error in "contrib/intarray"'s int[] & int[] operator (Guillaume
       Lelarge)
       If the smallest integer the two input arrays have in common is 1,
       and there are smaller values in either array, then 1 would be
       incorrectly omitted from the result.
     * Fix error detection in "contrib/pgcrypto"'s encrypt_iv() and
       decrypt_iv() (Marko Kreen)
       These functions failed to report certain types of invalid-input
       errors, and would instead return random garbage values for
       incorrect input.
     * Fix one-byte buffer overrun in "contrib/test_parser" (Paul Guyot)
       The code would try to read one more byte than it should, which
       would crash in corner cases. Since "contrib/test_parser" is only
       example code, this is not a security issue in itself, but bad
       example code is still bad.
     * Use __sync_lock_test_and_set() for spinlocks on ARM, if available
       (Martin Pitt)
       This function replaces our previous use of the SWPB instruction,
       which is deprecated and not available on ARMv6 and later. Reports
       suggest that the old code doesn't fail in an obvious way on recent
       ARM boards, but simply doesn't interlock concurrent accesses,
       leading to bizarre failures in multiprocess operation.
     * Use "-fexcess-precision=standard" option when building with gcc
       versions that accept it (Andrew Dunstan)
       This prevents assorted scenarios wherein recent versions of gcc
       will produce creative results.
     * Allow use of threaded Python on FreeBSD (Chris Rees)
       Our configure script previously believed that this combination
       wouldn't work; but FreeBSD fixed the problem, so remove that error
       check.
     __________________________________________________________________

                                Release 9.0.6

     Release Date: 2011-12-05

   This release contains a variety of fixes from 9.0.5. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.6

   A dump/restore is not required for those running 9.0.X.

   However, a longstanding error was discovered in the definition of the
   information_schema.referential_constraints view. If you rely on correct
   results from that view, you should replace its definition as explained
   in the first changelog item below.

   Also, if you are upgrading from a version earlier than 9.0.4, see the
   release notes for 9.0.4.
     __________________________________________________________________

Changes

     * Fix bugs in information_schema.referential_constraints view (Tom
       Lane)
       This view was being insufficiently careful about matching the
       foreign-key constraint to the depended-on primary or unique key
       constraint. That could result in failure to show a foreign key
       constraint at all, or showing it multiple times, or claiming that
       it depends on a different constraint than the one it really does.
       Since the view definition is installed by initdb, merely upgrading
       will not fix the problem. If you need to fix this in an existing
       installation, you can (as a superuser) drop the information_schema
       schema then re-create it by sourcing
       "SHAREDIR/information_schema.sql". (Run pg_config --sharedir if
       you're uncertain where "SHAREDIR" is.) This must be repeated in
       each database to be fixed.
     * Fix possible crash during "UPDATE" or "DELETE" that joins to the
       output of a scalar-returning function (Tom Lane)
       A crash could only occur if the target row had been concurrently
       updated, so this problem surfaced only intermittently.
     * Fix incorrect replay of WAL records for GIN index updates (Tom
       Lane)
       This could result in transiently failing to find index entries
       after a crash, or on a hot-standby server. The problem would be
       repaired by the next "VACUUM" of the index, however.
     * Fix TOAST-related data corruption during CREATE TABLE dest AS
       SELECT * FROM src or INSERT INTO dest SELECT * FROM src (Tom Lane)
       If a table has been modified by "ALTER TABLE ADD COLUMN", attempts
       to copy its data verbatim to another table could produce corrupt
       results in certain corner cases. The problem can only manifest in
       this precise form in 8.4 and later, but we patched earlier versions
       as well in case there are other code paths that could trigger the
       same bug.
     * Fix possible failures during hot standby startup (Simon Riggs)
     * Start hot standby faster when initial snapshot is incomplete (Simon
       Riggs)
     * Fix race condition during toast table access from stale syscache
       entries (Tom Lane)
       The typical symptom was transient errors like "missing chunk number
       0 for toast value NNNNN in pg_toast_2619", where the cited toast
       table would always belong to a system catalog.
     * Track dependencies of functions on items used in parameter default
       expressions (Tom Lane)
       Previously, a referenced object could be dropped without having
       dropped or modified the function, leading to misbehavior when the
       function was used. Note that merely installing this update will not
       fix the missing dependency entries; to do that, you'd need to
       "CREATE OR REPLACE" each such function afterwards. If you have
       functions whose defaults depend on non-built-in objects, doing so
       is recommended.
     * Allow inlining of set-returning SQL functions with multiple OUT
       parameters (Tom Lane)
     * Don't trust deferred-unique indexes for join removal (Tom Lane and
       Marti Raudsepp)
       A deferred uniqueness constraint might not hold intra-transaction,
       so assuming that it does could give incorrect query results.
     * Make DatumGetInetP() unpack inet datums that have a 1-byte header,
       and add a new macro, DatumGetInetPP(), that does not (Heikki
       Linnakangas)
       This change affects no core code, but might prevent crashes in
       add-on code that expects DatumGetInetP() to produce an unpacked
       datum as per usual convention.
     * Improve locale support in money type's input and output (Tom Lane)
       Aside from not supporting all standard lc_monetary formatting
       options, the input and output functions were inconsistent, meaning
       there were locales in which dumped money values could not be
       re-read.
     * Don't let transform_null_equals affect CASE foo WHEN NULL ...
       constructs (Heikki Linnakangas)
       transform_null_equals is only supposed to affect foo = NULL
       expressions written directly by the user, not equality checks
       generated internally by this form of CASE.
     * Change foreign-key trigger creation order to better support
       self-referential foreign keys (Tom Lane)
       For a cascading foreign key that references its own table, a row
       update will fire both the ON UPDATE trigger and the CHECK trigger
       as one event. The ON UPDATE trigger must execute first, else the
       CHECK will check a non-final state of the row and possibly throw an
       inappropriate error. However, the firing order of these triggers is
       determined by their names, which generally sort in creation order
       since the triggers have auto-generated names following the
       convention "RI_ConstraintTrigger_NNNN". A proper fix would require
       modifying that convention, which we will do in 9.2, but it seems
       risky to change it in existing releases. So this patch just changes
       the creation order of the triggers. Users encountering this type of
       error should drop and re-create the foreign key constraint to get
       its triggers into the right order.
     * Avoid floating-point underflow while tracking buffer allocation
       rate (Greg Matthews)
       While harmless in itself, on certain platforms this would result in
       annoying kernel log messages.
     * Preserve configuration file name and line number values when
       starting child processes under Windows (Tom Lane)
       Formerly, these would not be displayed correctly in the pg_settings
       view.
     * Fix incorrect field alignment in ecpg's SQLDA area (Zoltan
       Boszormenyi)
     * Preserve blank lines within commands in psql's command history
       (Robert Haas)
       The former behavior could cause problems if an empty line was
       removed from within a string literal, for example.
     * Fix pg_dump to dump user-defined casts between auto-generated
       types, such as table rowtypes (Tom Lane)
     * Assorted fixes for pg_upgrade (Bruce Momjian)
       Handle exclusion constraints correctly, avoid failures on Windows,
       don't complain about mismatched toast table names in 8.4 databases.
     * Use the preferred version of xsubpp to build PL/Perl, not
       necessarily the operating system's main copy (David Wheeler and
       Alex Hunsaker)
     * Fix incorrect coding in "contrib/dict_int" and "contrib/dict_xsyn"
       (Tom Lane)
       Some functions incorrectly assumed that memory returned by palloc()
       is guaranteed zeroed.
     * Fix assorted errors in "contrib/unaccent"'s configuration file
       parsing (Tom Lane)
     * Honor query cancel interrupts promptly in pgstatindex() (Robert
       Haas)
     * Fix incorrect quoting of log file name in Mac OS X start script
       (Sidar Lopez)
     * Ensure VPATH builds properly install all server header files (Peter
       Eisentraut)
     * Shorten file names reported in verbose error messages (Peter
       Eisentraut)
       Regular builds have always reported just the name of the C file
       containing the error message call, but VPATH builds formerly
       reported an absolute path name.
     * Fix interpretation of Windows timezone names for Central America
       (Tom Lane)
       Map "Central America Standard Time" to CST6, not CST6CDT, because
       DST is generally not observed anywhere in Central America.
     * Update time zone data files to tzdata release 2011n for DST law
       changes in Brazil, Cuba, Fiji, Palestine, Russia, and Samoa; also
       historical corrections for Alaska and British East Africa.
     __________________________________________________________________

                                Release 9.0.5

     Release Date: 2011-09-26

   This release contains a variety of fixes from 9.0.4. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.5

   A dump/restore is not required for those running 9.0.X.

   However, if you are upgrading from a version earlier than 9.0.4, see
   the release notes for 9.0.4.
     __________________________________________________________________

Changes

     * Fix catalog cache invalidation after a "VACUUM FULL" or "CLUSTER"
       on a system catalog (Tom Lane)
       In some cases the relocation of a system catalog row to another
       place would not be recognized by concurrent server processes,
       allowing catalog corruption to occur if they then tried to update
       that row. The worst-case outcome could be as bad as complete loss
       of a table.
     * Fix incorrect order of operations during sinval reset processing,
       and ensure that TOAST OIDs are preserved in system catalogs (Tom
       Lane)
       These mistakes could lead to transient failures after a "VACUUM
       FULL" or "CLUSTER" on a system catalog.
     * Fix bugs in indexing of in-doubt HOT-updated tuples (Tom Lane)
       These bugs could result in index corruption after reindexing a
       system catalog. They are not believed to affect user indexes.
     * Fix multiple bugs in GiST index page split processing (Heikki
       Linnakangas)
       The probability of occurrence was low, but these could lead to
       index corruption.
     * Fix possible buffer overrun in tsvector_concat() (Tom Lane)
       The function could underestimate the amount of memory needed for
       its result, leading to server crashes.
     * Fix crash in xml_recv when processing a "standalone" parameter (Tom
       Lane)
     * Make pg_options_to_table return NULL for an option with no value
       (Tom Lane)
       Previously such cases would result in a server crash.
     * Avoid possibly accessing off the end of memory in "ANALYZE" and in
       SJIS-2004 encoding conversion (Noah Misch)
       This fixes some very-low-probability server crash scenarios.
     * Protect pg_stat_reset_shared() against NULL input (Magnus Hagander)
     * Fix possible failure when a recovery conflict deadlock is detected
       within a sub-transaction (Tom Lane)
     * Avoid spurious conflicts while recycling btree index pages during
       hot standby (Noah Misch, Simon Riggs)
     * Shut down WAL receiver if it's still running at end of recovery
       (Heikki Linnakangas)
       The postmaster formerly panicked in this situation, but it's
       actually a legitimate case.
     * Fix race condition in relcache init file invalidation (Tom Lane)
       There was a window wherein a new backend process could read a stale
       init file but miss the inval messages that would tell it the data
       is stale. The result would be bizarre failures in catalog accesses,
       typically "could not read block 0 in file ..." later during
       startup.
     * Fix memory leak at end of a GiST index scan (Tom Lane)
       Commands that perform many separate GiST index scans, such as
       verification of a new GiST-based exclusion constraint on a table
       already containing many rows, could transiently require large
       amounts of memory due to this leak.
     * Fix memory leak when encoding conversion has to be done on incoming
       command strings and "LISTEN" is active (Tom Lane)
     * Fix incorrect memory accounting (leading to possible memory bloat)
       in tuplestores supporting holdable cursors and plpgsql's RETURN
       NEXT command (Tom Lane)
     * Fix trigger WHEN conditions when both BEFORE and AFTER triggers
       exist (Tom Lane)
       Evaluation of WHEN conditions for AFTER ROW UPDATE triggers could
       crash if there had been a BEFORE ROW trigger fired for the same
       update.
     * Fix performance problem when constructing a large, lossy bitmap
       (Tom Lane)
     * Fix join selectivity estimation for unique columns (Tom Lane)
       This fixes an erroneous planner heuristic that could lead to poor
       estimates of the result size of a join.
     * Fix nested PlaceHolderVar expressions that appear only in
       sub-select target lists (Tom Lane)
       This mistake could result in outputs of an outer join incorrectly
       appearing as NULL.
     * Allow the planner to assume that empty parent tables really are
       empty (Tom Lane)
       Normally an empty table is assumed to have a certain minimum size
       for planning purposes; but this heuristic seems to do more harm
       than good for the parent table of an inheritance hierarchy, which
       often is permanently empty.
     * Allow nested EXISTS queries to be optimized properly (Tom Lane)
     * Fix array- and path-creating functions to ensure padding bytes are
       zeroes (Tom Lane)
       This avoids some situations where the planner will think that
       semantically-equal constants are not equal, resulting in poor
       optimization.
     * Fix "EXPLAIN" to handle gating Result nodes within inner-indexscan
       subplans (Tom Lane)
       The usual symptom of this oversight was "bogus varno" errors.
     * Fix btree preprocessing of "indexedcol" IS NULL conditions (Dean
       Rasheed)
       Such a condition is unsatisfiable if combined with any other type
       of btree-indexable condition on the same index column. The case was
       handled incorrectly in 9.0.0 and later, leading to query output
       where there should be none.
     * Work around gcc 4.6.0 bug that breaks WAL replay (Tom Lane)
       This could lead to loss of committed transactions after a server
       crash.
     * Fix dump bug for VALUES in a view (Tom Lane)
     * Disallow SELECT FOR UPDATE/SHARE on sequences (Tom Lane)
       This operation doesn't work as expected and can lead to failures.
     * Fix "VACUUM" so that it always updates pg_class.reltuples/relpages
       (Tom Lane)
       This fixes some scenarios where autovacuum could make increasingly
       poor decisions about when to vacuum tables.
     * Defend against integer overflow when computing size of a hash table
       (Tom Lane)
     * Fix cases where "CLUSTER" might attempt to access already-removed
       TOAST data (Tom Lane)
     * Fix premature timeout failures during initial authentication
       transaction (Tom Lane)
     * Fix portability bugs in use of credentials control messages for
       "peer" authentication (Tom Lane)
     * Fix SSPI login when multiple roundtrips are required (Ahmed
       Shinwari, Magnus Hagander)
       The typical symptom of this problem was "The function requested is
       not supported" errors during SSPI login.
     * Fix failure when adding a new variable of a custom variable class
       to "postgresql.conf" (Tom Lane)
     * Throw an error if "pg_hba.conf" contains hostssl but SSL is
       disabled (Tom Lane)
       This was concluded to be more user-friendly than the previous
       behavior of silently ignoring such lines.
     * Fix failure when "DROP OWNED BY" attempts to remove default
       privileges on sequences (Shigeru Hanada)
     * Fix typo in pg_srand48 seed initialization (Andres Freund)
       This led to failure to use all bits of the provided seed. This
       function is not used on most platforms (only those without
       srandom), and the potential security exposure from a
       less-random-than-expected seed seems minimal in any case.
     * Avoid integer overflow when the sum of LIMIT and OFFSET values
       exceeds 2^63 (Heikki Linnakangas)
     * Add overflow checks to int4 and int8 versions of generate_series()
       (Robert Haas)
     * Fix trailing-zero removal in to_char() (Marti Raudsepp)
       In a format with FM and no digit positions after the decimal point,
       zeroes to the left of the decimal point could be removed
       incorrectly.
     * Fix pg_size_pretty() to avoid overflow for inputs close to 2^63
       (Tom Lane)
     * Weaken plpgsql's check for typmod matching in record values (Tom
       Lane)
       An overly enthusiastic check could lead to discarding length
       modifiers that should have been kept.
     * Correctly handle quotes in locale names during initdb (Heikki
       Linnakangas)
       The case can arise with some Windows locales, such as "People's
       Republic of China".
     * In pg_upgrade, avoid dumping orphaned temporary tables (Bruce
       Momjian)
       This prevents situations wherein table OID assignments could get
       out of sync between old and new installations.
     * Fix pg_upgrade to preserve toast tables' relfrozenxids during an
       upgrade from 8.3 (Bruce Momjian)
       Failure to do this could lead to "pg_clog" files being removed too
       soon after the upgrade.
     * In pg_upgrade, fix the -l (log) option to work on Windows (Bruce
       Momjian)
     * In pg_ctl, support silent mode for service registrations on Windows
       (MauMau)
     * Fix psql's counting of script file line numbers during COPY from a
       different file (Tom Lane)
     * Fix pg_restore's direct-to-database mode for
       standard_conforming_strings (Tom Lane)
       pg_restore could emit incorrect commands when restoring directly to
       a database server from an archive file that had been made with
       standard_conforming_strings set to on.
     * Be more user-friendly about unsupported cases for parallel
       pg_restore (Tom Lane)
       This change ensures that such cases are detected and reported
       before any restore actions have been taken.
     * Fix write-past-buffer-end and memory leak in libpq's LDAP service
       lookup code (Albe Laurenz)
     * In libpq, avoid failures when using nonblocking I/O and an SSL
       connection (Martin Pihlak, Tom Lane)
     * Improve libpq's handling of failures during connection startup (Tom
       Lane)
       In particular, the response to a server report of fork() failure
       during SSL connection startup is now saner.
     * Improve libpq's error reporting for SSL failures (Tom Lane)
     * Fix PQsetvalue() to avoid possible crash when adding a new tuple to
       a PGresult originally obtained from a server query (Andrew Chernow)
     * Make ecpglib write double values with 15 digits precision (Akira
       Kurosawa)
     * In ecpglib, be sure LC_NUMERIC setting is restored after an error
       (Michael Meskes)
     * Apply upstream fix for blowfish signed-character bug
       (CVE-2011-2483) (Tom Lane)
       "contrib/pg_crypto"'s blowfish encryption code could give wrong
       results on platforms where char is signed (which is most), leading
       to encrypted passwords being weaker than they should be.
     * Fix memory leak in "contrib/seg" (Heikki Linnakangas)
     * Fix pgstatindex() to give consistent results for empty indexes (Tom
       Lane)
     * Allow building with perl 5.14 (Alex Hunsaker)
     * Fix assorted issues with build and install file paths containing
       spaces (Tom Lane)
     * Update time zone data files to tzdata release 2011i for DST law
       changes in Canada, Egypt, Russia, Samoa, and South Sudan.
     __________________________________________________________________

                                Release 9.0.4

     Release Date: 2011-04-18

   This release contains a variety of fixes from 9.0.3. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.4

   A dump/restore is not required for those running 9.0.X.

   However, if your installation was upgraded from a previous major
   release by running pg_upgrade, you should take action to prevent
   possible data loss due to a now-fixed bug in pg_upgrade. The
   recommended solution is to run "VACUUM FREEZE" on all TOAST tables.
   More information is available at
   http://wiki.postgresql.org/wiki/20110408pg_upgrade_fix.
     __________________________________________________________________

Changes

     * Fix pg_upgrade's handling of TOAST tables (Bruce Momjian)
       The pg_class.relfrozenxid value for TOAST tables was not correctly
       copied into the new installation during pg_upgrade. This could
       later result in pg_clog files being discarded while they were still
       needed to validate tuples in the TOAST tables, leading to "could
       not access status of transaction" failures.
       This error poses a significant risk of data loss for installations
       that have been upgraded with pg_upgrade. This patch corrects the
       problem for future uses of pg_upgrade, but does not in itself cure
       the issue in installations that have been processed with a buggy
       version of pg_upgrade.
     * Suppress incorrect "PD_ALL_VISIBLE flag was incorrectly set"
       warning (Heikki Linnakangas)
       "VACUUM" would sometimes issue this warning in cases that are
       actually valid.
     * Use better SQLSTATE error codes for hot standby conflict cases
       (Tatsuo Ishii and Simon Riggs)
       All retryable conflict errors now have an error code that indicates
       that a retry is possible. Also, session closure due to the database
       being dropped on the master is now reported as
       ERRCODE_DATABASE_DROPPED, rather than ERRCODE_ADMIN_SHUTDOWN, so
       that connection poolers can handle the situation correctly.
     * Prevent intermittent hang in interactions of startup process with
       bgwriter process (Simon Riggs)
       This affected recovery in non-hot-standby cases.
     * Disallow including a composite type in itself (Tom Lane)
       This prevents scenarios wherein the server could recurse infinitely
       while processing the composite type. While there are some possible
       uses for such a structure, they don't seem compelling enough to
       justify the effort required to make sure it always works safely.
     * Avoid potential deadlock during catalog cache initialization
       (Nikhil Sontakke)
       In some cases the cache loading code would acquire share lock on a
       system index before locking the index's catalog. This could
       deadlock against processes trying to acquire exclusive locks in the
       other, more standard order.
     * Fix dangling-pointer problem in BEFORE ROW UPDATE trigger handling
       when there was a concurrent update to the target tuple (Tom Lane)
       This bug has been observed to result in intermittent "cannot
       extract system attribute from virtual tuple" failures while trying
       to do UPDATE RETURNING ctid. There is a very small probability of
       more serious errors, such as generating incorrect index entries for
       the updated tuple.
     * Disallow "DROP TABLE" when there are pending deferred trigger
       events for the table (Tom Lane)
       Formerly the "DROP" would go through, leading to "could not open
       relation with OID nnn" errors when the triggers were eventually
       fired.
     * Allow "replication" as a user name in "pg_hba.conf" (Andrew
       Dunstan)
       "replication" is special in the database name column, but it was
       mistakenly also treated as special in the user name column.
     * Prevent crash triggered by constant-false WHERE conditions during
       GEQO optimization (Tom Lane)
     * Improve planner's handling of semi-join and anti-join cases (Tom
       Lane)
     * Fix handling of SELECT FOR UPDATE in a sub-SELECT (Tom Lane)
       This bug typically led to "cannot extract system attribute from
       virtual tuple" errors.
     * Fix selectivity estimation for text search to account for NULLs
       (Jesper Krogh)
     * Fix get_actual_variable_range() to support hypothetical indexes
       injected by an index adviser plugin (Gurjeet Singh)
     * Fix PL/Python memory leak involving array slices (Daniel Popowich)
     * Allow libpq's SSL initialization to succeed when user's home
       directory is unavailable (Tom Lane)
       If the SSL mode is such that a root certificate file is not
       required, there is no need to fail. This change restores the
       behavior to what it was in pre-9.0 releases.
     * Fix libpq to return a useful error message for errors detected in
       conninfo_array_parse (Joseph Adams)
       A typo caused the library to return NULL, rather than the PGconn
       structure containing the error message, to the application.
     * Fix ecpg preprocessor's handling of float constants (Heikki
       Linnakangas)
     * Fix parallel pg_restore to handle comments on POST_DATA items
       correctly (Arnd Hannemann)
     * Fix pg_restore to cope with long lines (over 1KB) in TOC files (Tom
       Lane)
     * Put in more safeguards against crashing due to division-by-zero
       with overly enthusiastic compiler optimization (Aurelien Jarno)
     * Support use of dlopen() in FreeBSD and OpenBSD on MIPS (Tom Lane)
       There was a hard-wired assumption that this system function was not
       available on MIPS hardware on these systems. Use a compile-time
       test instead, since more recent versions have it.
     * Fix compilation failures on HP-UX (Heikki Linnakangas)
     * Avoid crash when trying to write to the Windows console very early
       in process startup (Rushabh Lathia)
     * Support building with MinGW 64 bit compiler for Windows (Andrew
       Dunstan)
     * Fix version-incompatibility problem with libintl on Windows
       (Hiroshi Inoue)
     * Fix usage of xcopy in Windows build scripts to work correctly under
       Windows 7 (Andrew Dunstan)
       This affects the build scripts only, not installation or usage.
     * Fix path separator used by pg_regress on Cygwin (Andrew Dunstan)
     * Update time zone data files to tzdata release 2011f for DST law
       changes in Chile, Cuba, Falkland Islands, Morocco, Samoa, and
       Turkey; also historical corrections for South Australia, Alaska,
       and Hawaii.
     __________________________________________________________________

                                Release 9.0.3

     Release Date: 2011-01-31

   This release contains a variety of fixes from 9.0.2. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.3

   A dump/restore is not required for those running 9.0.X.
     __________________________________________________________________

Changes

     * Before exiting walreceiver, ensure all the received WAL is fsync'd
       to disk (Heikki Linnakangas)
       Otherwise the standby server could replay some un-synced WAL,
       conceivably leading to data corruption if the system crashes just
       at that point.
     * Avoid excess fsync activity in walreceiver (Heikki Linnakangas)
     * Make "ALTER TABLE" revalidate uniqueness and exclusion constraints
       when needed (Noah Misch)
       This was broken in 9.0 by a change that was intended to suppress
       revalidation during "VACUUM FULL" and "CLUSTER", but
       unintentionally affected "ALTER TABLE" as well.
     * Fix EvalPlanQual for "UPDATE" of an inheritance tree in which the
       tables are not all alike (Tom Lane)
       Any variation in the table row types (including dropped columns
       present in only some child tables) would confuse the EvalPlanQual
       code, leading to misbehavior or even crashes. Since EvalPlanQual is
       only executed during concurrent updates to the same row, the
       problem was only seen intermittently.
     * Avoid failures when "EXPLAIN" tries to display a simple-form CASE
       expression (Tom Lane)
       If the CASE's test expression was a constant, the planner could
       simplify the CASE into a form that confused the expression-display
       code, resulting in "unexpected CASE WHEN clause" errors.
     * Fix assignment to an array slice that is before the existing range
       of subscripts (Tom Lane)
       If there was a gap between the newly added subscripts and the first
       pre-existing subscript, the code miscalculated how many entries
       needed to be copied from the old array's null bitmap, potentially
       leading to data corruption or crash.
     * Avoid unexpected conversion overflow in planner for very distant
       date values (Tom Lane)
       The date type supports a wider range of dates than can be
       represented by the timestamp types, but the planner assumed it
       could always convert a date to timestamp with impunity.
     * Fix PL/Python crash when an array contains null entries (Alex
       Hunsaker)
     * Remove ecpg's fixed length limit for constants defining an array
       dimension (Michael Meskes)
     * Fix erroneous parsing of tsquery values containing ... &
       !(subexpression) | ... (Tom Lane)
       Queries containing this combination of operators were not executed
       correctly. The same error existed in "contrib/intarray"'s query_int
       type and "contrib/ltree"'s ltxtquery type.
     * Fix buffer overrun in "contrib/intarray"'s input function for the
       query_int type (Apple)
       This bug is a security risk since the function's return address
       could be overwritten. Thanks to Apple Inc's security team for
       reporting this issue and supplying the fix. (CVE-2010-4015)
     * Fix bug in "contrib/seg"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a seg column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update. (This is identical to the bug that was fixed in
       "contrib/cube" in the previous update.)
     __________________________________________________________________

                                Release 9.0.2

     Release Date: 2010-12-16

   This release contains a variety of fixes from 9.0.1. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.2

   A dump/restore is not required for those running 9.0.X.
     __________________________________________________________________

Changes

     * Force the default wal_sync_method to be fdatasync on Linux (Tom
       Lane, Marti Raudsepp)
       The default on Linux has actually been fdatasync for many years,
       but recent kernel changes caused PostgreSQL to choose open_datasync
       instead. This choice did not result in any performance improvement,
       and caused outright failures on certain filesystems, notably ext4
       with the data=journal mount option.
     * Fix "too many KnownAssignedXids" error during Hot Standby replay
       (Heikki Linnakangas)
     * Fix race condition in lock acquisition during Hot Standby (Simon
       Riggs)
     * Avoid unnecessary conflicts during Hot Standby (Simon Riggs)
       This fixes some cases where replay was considered to conflict with
       standby queries (causing delay of replay or possibly cancellation
       of the queries), but there was no real conflict.
     * Fix assorted bugs in WAL replay logic for GIN indexes (Tom Lane)
       This could result in "bad buffer id: 0" failures or corruption of
       index contents during replication.
     * Fix recovery from base backup when the starting checkpoint WAL
       record is not in the same WAL segment as its redo point (Jeff
       Davis)
     * Fix corner-case bug when streaming replication is enabled
       immediately after creating the master database cluster (Heikki
       Linnakangas)
     * Fix persistent slowdown of autovacuum workers when multiple workers
       remain active for a long time (Tom Lane)
       The effective vacuum_cost_limit for an autovacuum worker could drop
       to nearly zero if it processed enough tables, causing it to run
       extremely slowly.
     * Fix long-term memory leak in autovacuum launcher (Alvaro Herrera)
     * Avoid failure when trying to report an impending transaction
       wraparound condition from outside a transaction (Tom Lane)
       This oversight prevented recovery after transaction wraparound got
       too close, because database startup processing would fail.
     * Add support for detecting register-stack overrun on IA64 (Tom Lane)
       The IA64 architecture has two hardware stacks. Full prevention of
       stack-overrun failures requires checking both.
     * Add a check for stack overflow in copyObject() (Tom Lane)
       Certain code paths could crash due to stack overflow given a
       sufficiently complex query.
     * Fix detection of page splits in temporary GiST indexes (Heikki
       Linnakangas)
       It is possible to have a "concurrent" page split in a temporary
       index, if for example there is an open cursor scanning the index
       when an insertion is done. GiST failed to detect this case and
       hence could deliver wrong results when execution of the cursor
       continued.
     * Fix error checking during early connection processing (Tom Lane)
       The check for too many child processes was skipped in some cases,
       possibly leading to postmaster crash when attempting to add the new
       child process to fixed-size arrays.
     * Improve efficiency of window functions (Tom Lane)
       Certain cases where a large number of tuples needed to be read in
       advance, but work_mem was large enough to allow them all to be held
       in memory, were unexpectedly slow. percent_rank(), cume_dist() and
       ntile() in particular were subject to this problem.
     * Avoid memory leakage while "ANALYZE"'ing complex index expressions
       (Tom Lane)
     * Ensure an index that uses a whole-row Var still depends on its
       table (Tom Lane)
       An index declared like create index i on t (foo(t.*)) would not
       automatically get dropped when its table was dropped.
     * Add missing support in "DROP OWNED BY" for removing foreign data
       wrapper/server privileges belonging to a user (Heikki Linnakangas)
     * Do not "inline" a SQL function with multiple OUT parameters (Tom
       Lane)
       This avoids a possible crash due to loss of information about the
       expected result rowtype.
     * Fix crash when inline-ing a set-returning function whose argument
       list contains a reference to an inline-able user function (Tom
       Lane)
     * Behave correctly if ORDER BY, LIMIT, FOR UPDATE, or WITH is
       attached to the VALUES part of INSERT ... VALUES (Tom Lane)
     * Make the OFF keyword unreserved (Heikki Linnakangas)
       This prevents problems with using off as a variable name in
       PL/pgSQL. That worked before 9.0, but was now broken because
       PL/pgSQL now treats all core reserved words as reserved.
     * Fix constant-folding of COALESCE() expressions (Tom Lane)
       The planner would sometimes attempt to evaluate sub-expressions
       that in fact could never be reached, possibly leading to unexpected
       errors.
     * Fix "could not find pathkey item to sort" planner failure with
       comparison of whole-row Vars (Tom Lane)
     * Fix postmaster crash when connection acceptance (accept() or one of
       the calls made immediately after it) fails, and the postmaster was
       compiled with GSSAPI support (Alexander Chernikov)
     * Retry after receiving an invalid response packet from a RADIUS
       authentication server (Magnus Hagander)
       This fixes a low-risk potential denial of service condition.
     * Fix missed unlink of temporary files when log_temp_files is active
       (Tom Lane)
       If an error occurred while attempting to emit the log message, the
       unlink was not done, resulting in accumulation of temp files.
     * Add print functionality for InhRelation nodes (Tom Lane)
       This avoids a failure when debug_print_parse is enabled and certain
       types of query are executed.
     * Fix incorrect calculation of distance from a point to a horizontal
       line segment (Tom Lane)
       This bug affected several different geometric distance-measurement
       operators.
     * Fix incorrect calculation of transaction status in ecpg (Itagaki
       Takahiro)
     * Fix errors in psql's Unicode-escape support (Tom Lane)
     * Speed up parallel pg_restore when the archive contains many large
       objects (blobs) (Tom Lane)
     * Fix PL/pgSQL's handling of "simple" expressions to not fail in
       recursion or error-recovery cases (Tom Lane)
     * Fix PL/pgSQL's error reporting for no-such-column cases (Tom Lane)
       As of 9.0, it would sometimes report "missing FROM-clause entry for
       table foo" when "record foo has no field bar" would be more
       appropriate.
     * Fix PL/Python to honor typmod (i.e., length or precision
       restrictions) when assigning to tuple fields (Tom Lane)
       This fixes a regression from 8.4.
     * Fix PL/Python's handling of set-returning functions (Jan Urbanski)
       Attempts to call SPI functions within the iterator generating a set
       result would fail.
     * Fix bug in "contrib/cube"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a cube column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update.
     * Don't emit "identifier will be truncated" notices in
       "contrib/dblink" except when creating new connections (Itagaki
       Takahiro)
     * Fix potential coredump on missing public key in "contrib/pgcrypto"
       (Marti Raudsepp)
     * Fix buffer overrun in "contrib/pg_upgrade" (Hernan Gonzalez)
     * Fix memory leak in "contrib/xml2"'s XPath query functions (Tom
       Lane)
     * Update time zone data files to tzdata release 2010o for DST law
       changes in Fiji and Samoa; also historical corrections for Hong
       Kong.
     __________________________________________________________________

                                Release 9.0.1

     Release Date: 2010-10-04

   This release contains a variety of fixes from 9.0.0. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.1

   A dump/restore is not required for those running 9.0.X.
     __________________________________________________________________

Changes

     * Use a separate interpreter for each calling SQL userid in PL/Perl
       and PL/Tcl (Tom Lane)
       This change prevents security problems that can be caused by
       subverting Perl or Tcl code that will be executed later in the same
       session under another SQL user identity (for example, within a
       SECURITY DEFINER function). Most scripting languages offer numerous
       ways that that might be done, such as redefining standard functions
       or operators called by the target function. Without this change,
       any SQL user with Perl or Tcl language usage rights can do
       essentially anything with the SQL privileges of the target
       function's owner.
       The cost of this change is that intentional communication among
       Perl and Tcl functions becomes more difficult. To provide an escape
       hatch, PL/PerlU and PL/TclU functions continue to use only one
       interpreter per session. This is not considered a security issue
       since all such functions execute at the trust level of a database
       superuser already.
       It is likely that third-party procedural languages that claim to
       offer trusted execution have similar security issues. We advise
       contacting the authors of any PL you are depending on for
       security-critical purposes.
       Our thanks to Tim Bunce for pointing out this issue
       (CVE-2010-3433).
     * Improve pg_get_expr() security fix so that the function can still
       be used on the output of a sub-select (Tom Lane)
     * Fix incorrect placement of placeholder evaluation (Tom Lane)
       This bug could result in query outputs being non-null when they
       should be null, in cases where the inner side of an outer join is a
       sub-select with non-strict expressions in its output list.
     * Fix join removal's handling of placeholder expressions (Tom Lane)
     * Fix possible duplicate scans of UNION ALL member relations (Tom
       Lane)
     * Prevent infinite loop in ProcessIncomingNotify() after unlistening
       (Jeff Davis)
     * Prevent show_session_authorization() from crashing within
       autovacuum processes (Tom Lane)
     * Re-allow input of Julian dates prior to 0001-01-01 AD (Tom Lane)
       Input such as 'J100000'::date worked before 8.4, but was
       unintentionally broken by added error-checking.
     * Make psql recognize "DISCARD ALL" as a command that should not be
       encased in a transaction block in autocommit-off mode (Itagaki
       Takahiro)
     * Update build infrastructure and documentation to reflect the source
       code repository's move from CVS to Git (Magnus Hagander and others)
     __________________________________________________________________

                                 Release 9.0

     Release Date: 2010-09-20
     __________________________________________________________________

Overview

   This release of PostgreSQL adds features that have been requested for
   years, such as easy-to-use replication, a mass permission-changing
   facility, and anonymous code blocks. While past major releases have
   been conservative in their scope, this release shows a bold new desire
   to provide facilities that new and existing users of PostgreSQL will
   embrace. This has all been done with few incompatibilities. Major
   enhancements include:

     * Built-in replication based on log shipping. This advance consists
       of two features: Streaming Replication, allowing continuous archive
       (WAL) files to be streamed over a network connection to a standby
       server, and Hot Standby, allowing continuous archive standby
       servers to execute read-only queries. The net effect is to support
       a single master with multiple read-only slave servers.
     * Easier database object permissions management. "GRANT"/"REVOKE IN
       SCHEMA" supports mass permissions changes on existing objects,
       while "ALTER DEFAULT PRIVILEGES" allows control of privileges for
       objects created in the future. Large objects (BLOBs) now support
       permissions management as well.
     * Broadly enhanced stored procedure support. The "DO" statement
       supports ad-hoc or "anonymous" code blocks. Functions can now be
       called using named parameters. PL/pgSQL is now installed by
       default, and PL/Perl and PL/Python have been enhanced in several
       ways, including support for Python3.
     * Full support for 64-bit Windows.
     * More advanced reporting queries, including additional windowing
       options (PRECEDING and FOLLOWING) and the ability to control the
       order in which values are fed to aggregate functions.
     * New trigger features, including SQL-standard-compliant per-column
       triggers and conditional trigger execution.
     * Deferrable unique constraints. Mass updates to unique keys are now
       possible without trickery.
     * Exclusion constraints. These provide a generalized version of
       unique constraints, allowing enforcement of complex conditions.
     * New and enhanced security features, including RADIUS
       authentication, LDAP authentication improvements, and a new contrib
       module "passwordcheck" for testing password strength.
     * New high-performance implementation of the "LISTEN"/"NOTIFY"
       feature. Pending events are now stored in a memory-based queue
       rather than a table. Also, a "payload" string can be sent with each
       event, rather than transmitting just an event name as before.
     * New implementation of "VACUUM FULL". This command now rewrites the
       entire table and indexes, rather than moving individual rows to
       compact space. It is substantially faster in most cases, and no
       longer results in index bloat.
     * New contrib module "pg_upgrade" to support in-place upgrades from
       8.3 or 8.4 to 9.0.
     * Multiple performance enhancements for specific types of queries,
       including elimination of unnecessary joins. This helps optimize
       some automatically-generated queries, such as those produced by
       object-relational mappers (ORMs).
     * "EXPLAIN" enhancements. The output is now available in JSON, XML,
       or YAML format, and includes buffer utilization and other data not
       previously available.
     * "hstore" improvements, including new functions and greater data
       capacity.

   The above items are explained in more detail in the sections below.
     __________________________________________________________________

Migration to Version 9.0

   A dump/restore using pg_dump, or use of pg_upgrade, is required for
   those wishing to migrate data from any previous release.

   Version 9.0 contains a number of changes that selectively break
   backwards compatibility in order to support new features and code
   quality improvements. In particular, users who make extensive use of
   PL/pgSQL, Point-In-Time Recovery (PITR), or Warm Standby should test
   their applications because of slight user-visible changes in those
   areas. Observe the following incompatibilities:
     __________________________________________________________________

Server Settings

     * Remove server parameter add_missing_from, which was defaulted to
       off for many years (Tom Lane)
     * Remove server parameter regex_flavor, which was defaulted to
       advanced for many years (Tom Lane)
     * archive_mode now only affects archive_command; a new setting,
       wal_level, affects the contents of the write-ahead log (Heikki
       Linnakangas)
     * log_temp_files now uses default file size units of kilobytes
       (Robert Haas)
     __________________________________________________________________

Queries

     * When querying a parent table, do not do any separate permission
       checks on child tables scanned as part of the query (Peter
       Eisentraut)
       The SQL standard specifies this behavior, and it is also much more
       convenient in practice than the former behavior of checking
       permissions on each child as well as the parent.
     __________________________________________________________________

Data Types

     * bytea output now appears in hex format by default (Peter
       Eisentraut)
       The server parameter bytea_output can be used to select the
       traditional output format if needed for compatibility.
     * Array input now considers only plain ASCII whitespace characters to
       be potentially ignorable; it will never ignore non-ASCII
       characters, even if they are whitespace according to some locales
       (Tom Lane)
       This avoids some corner cases where array values could be
       interpreted differently depending on the server's locale settings.
     * Improve standards compliance of SIMILAR TO patterns and SQL-style
       substring() patterns (Tom Lane)
       This includes treating ? and {...} as pattern metacharacters, while
       they were simple literal characters before; that corresponds to new
       features added in SQL:2008. Also, ^ and $ are now treated as simple
       literal characters; formerly they were treated as metacharacters,
       as if the pattern were following POSIX rather than SQL rules. Also,
       in SQL-standard substring(), use of parentheses for nesting no
       longer interferes with capturing of a substring. Also, processing
       of bracket expressions (character classes) is now more
       standards-compliant.
     * Reject negative length values in 3-parameter substring() for bit
       strings, per the SQL standard (Tom Lane)
     * Make date_trunc truncate rather than round when reducing precision
       of fractional seconds (Tom Lane)
       The code always acted this way for integer-based dates/times. Now
       float-based dates/times behave similarly.
     __________________________________________________________________

Object Renaming

     * Tighten enforcement of column name consistency during "RENAME" when
       a child table inherits the same column from multiple unrelated
       parents (KaiGai Kohei)
     * No longer automatically rename indexes and index columns when the
       underlying table columns are renamed (Tom Lane)
       Administrators can still rename such indexes and columns manually.
       This change will require an update of the JDBC driver, and possibly
       other drivers, so that unique indexes are correctly recognized
       after a rename.
     * "CREATE OR REPLACE FUNCTION" can no longer change the declared
       names of function parameters (Pavel Stehule)
       In order to avoid creating ambiguity in named-parameter calls, it
       is no longer allowed to change the aliases for input parameters in
       the declaration of an existing function (although names can still
       be assigned to previously unnamed parameters). You now have to
       "DROP" and recreate the function to do that.
     __________________________________________________________________

PL/pgSQL

     * PL/pgSQL now throws an error if a variable name conflicts with a
       column name used in a query (Tom Lane)
       The former behavior was to bind ambiguous names to PL/pgSQL
       variables in preference to query columns, which often resulted in
       surprising misbehavior. Throwing an error allows easy detection of
       ambiguous situations. Although it's recommended that functions
       encountering this type of error be modified to remove the conflict,
       the old behavior can be restored if necessary via the configuration
       parameter plpgsql.variable_conflict, or via the per-function option
       #variable_conflict.
     * PL/pgSQL no longer allows variable names that match certain SQL
       reserved words (Tom Lane)
       This is a consequence of aligning the PL/pgSQL parser to match the
       core SQL parser more closely. If necessary, variable names can be
       double-quoted to avoid this restriction.
     * PL/pgSQL now requires columns of composite results to match the
       expected type modifier as well as base type (Pavel Stehule, Tom
       Lane)
       For example, if a column of the result type is declared as
       NUMERIC(30,2), it is no longer acceptable to return a NUMERIC of
       some other precision in that column. Previous versions neglected to
       check the type modifier and would thus allow result rows that
       didn't actually conform to the declared restrictions.
     * PL/pgSQL now treats selection into composite fields more
       consistently (Tom Lane)
       Formerly, a statement like SELECT ... INTO rec.fld FROM ... was
       treated as a scalar assignment even if the record field "fld" was
       of composite type. Now it is treated as a record assignment, the
       same as when the INTO target is a regular variable of composite
       type. So the values to be assigned to the field's subfields should
       be written as separate columns of the "SELECT" list, not as a
       ROW(...) construct as in previous versions.
       If you need to do this in a way that will work in both 9.0 and
       previous releases, you can write something like rec.fld := ROW(...)
       FROM ....
     * Remove PL/pgSQL's RENAME declaration (Tom Lane)
       Instead of RENAME, use ALIAS, which can now create an alias for any
       variable, not only dollar sign parameter names (such as $1) as
       before.
     __________________________________________________________________

Other Incompatibilities

     * Deprecate use of => as an operator name (Robert Haas)
       Future versions of PostgreSQL will probably reject this operator
       name entirely, in order to support the SQL-standard notation for
       named function parameters. For the moment, it is still allowed, but
       a warning is emitted when such an operator is defined.
     * Remove support for platforms that don't have a working 64-bit
       integer data type (Tom Lane)
       It is believed all still-supported platforms have working 64-bit
       integer data types.
     __________________________________________________________________

Changes

   Version 9.0 has an unprecedented number of new major features, and over
   200 enhancements, improvements, new commands, new functions, and other
   changes.
     __________________________________________________________________

Server

Continuous Archiving and Streaming Replication

   PostgreSQL's existing standby-server capability has been expanded both
   to support read-only queries on standby servers and to greatly reduce
   the lag between master and standby servers. For many users, this will
   be a useful and low-administration form of replication, either for high
   availability or for horizontal scalability.

     * Allow a standby server to accept read-only queries (Simon Riggs,
       Heikki Linnakangas)
       This feature is called Hot Standby. There are new "postgresql.conf"
       and "recovery.conf" settings to control this feature, as well as
       extensive documentation.
     * Allow write-ahead log (WAL) data to be streamed to a standby server
       (Fujii Masao, Heikki Linnakangas)
       This feature is called Streaming Replication. Previously WAL data
       could be sent to standby servers only in units of entire WAL files
       (normally 16 megabytes each). Streaming Replication eliminates this
       inefficiency and allows updates on the master to be propagated to
       standby servers with very little delay. There are new
       "postgresql.conf" and "recovery.conf" settings to control this
       feature, as well as extensive documentation.
     * Add pg_last_xlog_receive_location() and
       pg_last_xlog_replay_location(), which can be used to monitor
       standby server WAL activity (Simon Riggs, Fujii Masao, Heikki
       Linnakangas)
     __________________________________________________________________

Performance

     * Allow per-tablespace values to be set for sequential and random
       page cost estimates (seq_page_cost/random_page_cost) via "ALTER
       TABLESPACE ... SET/RESET" (Robert Haas)
     * Improve performance and reliability of EvalPlanQual rechecks in
       join queries (Tom Lane)
       "UPDATE", "DELETE", and "SELECT FOR UPDATE/SHARE" queries that
       involve joins will now behave much better when encountering
       freshly-updated rows.
     * Improve performance of "TRUNCATE" when the table was created or
       truncated earlier in the same transaction (Tom Lane)
     * Improve performance of finding inheritance child tables (Tom Lane)
     __________________________________________________________________

Optimizer

     * Remove unnecessary outer joins (Robert Haas)
       Outer joins where the inner side is unique and not referenced above
       the join are unnecessary and are therefore now removed. This will
       accelerate many automatically generated queries, such as those
       created by object-relational mappers (ORMs).
     * Allow IS NOT NULL restrictions to use indexes (Tom Lane)
       This is particularly useful for finding MAX()/MIN() values in
       indexes that contain many null values.
     * Improve the optimizer's choices about when to use materialize
       nodes, and when to use sorting versus hashing for DISTINCT (Tom
       Lane)
     * Improve the optimizer's equivalence detection for expressions
       involving boolean <> operators (Tom Lane)
     __________________________________________________________________

GEQO

     * Use the same random seed every time GEQO plans a query (Andres
       Freund)
       While the Genetic Query Optimizer (GEQO) still selects random
       plans, it now always selects the same random plans for identical
       queries, thus giving more consistent performance. You can modify
       geqo_seed to experiment with alternative plans.
     * Improve GEQO plan selection (Tom Lane)
       This avoids the rare error "failed to make a valid plan", and
       should also improve planning speed.
     __________________________________________________________________

Optimizer Statistics

     * Improve "ANALYZE" to support inheritance-tree statistics (Tom Lane)
       This is particularly useful for partitioned tables. However,
       autovacuum does not yet automatically re-analyze parent tables when
       child tables change.
     * Improve autovacuum's detection of when re-analyze is necessary (Tom
       Lane)
     * Improve optimizer's estimation for greater/less-than comparisons
       (Tom Lane)
       When looking up statistics for greater/less-than comparisons, if
       the comparison value is in the first or last histogram bucket, use
       an index (if available) to fetch the current actual column minimum
       or maximum. This greatly improves the accuracy of estimates for
       comparison values near the ends of the data range, particularly if
       the range is constantly changing due to addition of new data.
     * Allow setting of number-of-distinct-values statistics using "ALTER
       TABLE" (Robert Haas)
       This allows users to override the estimated number or percentage of
       distinct values for a column. This statistic is normally computed
       by "ANALYZE", but the estimate can be poor, especially on tables
       with very large numbers of rows.
     __________________________________________________________________

Authentication

     * Add support for RADIUS (Remote Authentication Dial In User Service)
       authentication (Magnus Hagander)
     * Allow LDAP (Lightweight Directory Access Protocol) authentication
       to operate in "search/bind" mode (Robert Fleming, Magnus Hagander)
       This allows the user to be looked up first, then the system uses
       the DN (Distinguished Name) returned for that user.
     * Add samehost and samenet designations to "pg_hba.conf" (Stef
       Walter)
       These match the server's IP address and subnet address
       respectively.
     * Pass trusted SSL root certificate names to the client so the client
       can return an appropriate client certificate (Craig Ringer)
     __________________________________________________________________

Monitoring

     * Add the ability for clients to set an application name, which is
       displayed in pg_stat_activity (Dave Page)
       This allows administrators to characterize database traffic and
       troubleshoot problems by source application.
     * Add a SQLSTATE option (%e) to log_line_prefix (Guillaume Smet)
       This allows users to compile statistics on errors and messages by
       error code number.
     * Write to the Windows event log in UTF16 encoding (Itagaki Takahiro)
       Now there is true multilingual support for PostgreSQL log messages
       on Windows.
     __________________________________________________________________

Statistics Counters

     * Add pg_stat_reset_shared('bgwriter') to reset the cluster-wide
       shared statistics for the background writer (Greg Smith)
     * Add pg_stat_reset_single_table_counters() and
       pg_stat_reset_single_function_counters() to allow resetting the
       statistics counters for individual tables and functions (Magnus
       Hagander)
     __________________________________________________________________

Server Settings

     * Allow setting of configuration parameters based on database/role
       combinations (Alvaro Herrera)
       Previously only per-database and per-role settings were possible,
       not combinations. All role and database settings are now stored in
       the new pg_db_role_setting system catalog. A new psql command \drds
       shows these settings. The legacy system views pg_roles, pg_shadow,
       and pg_user do not show combination settings, and therefore no
       longer completely represent the configuration for a user or
       database.
     * Add server parameter bonjour, which controls whether a
       Bonjour-enabled server advertises itself via Bonjour (Tom Lane)
       The default is off, meaning it does not advertise. This allows
       packagers to distribute Bonjour-enabled builds without worrying
       that individual users might not want the feature.
     * Add server parameter enable_material, which controls the use of
       materialize nodes in the optimizer (Robert Haas)
       The default is on. When off, the optimizer will not add materialize
       nodes purely for performance reasons, though they will still be
       used when necessary for correctness.
     * Change server parameter log_temp_files to use default file size
       units of kilobytes (Robert Haas)
       Previously this setting was interpreted in bytes if no units were
       specified.
     * Log changes of parameter values when "postgresql.conf" is reloaded
       (Peter Eisentraut)
       This lets administrators and security staff audit changes of
       database settings, and is also very convenient for checking the
       effects of "postgresql.conf" edits.
     * Properly enforce superuser permissions for custom server parameters
       (Tom Lane)
       Non-superusers can no longer issue "ALTER ROLE"/"DATABASE SET" for
       parameters that are not currently known to the server. This allows
       the server to correctly check that superuser-only parameters are
       only set by superusers. Previously, the SET would be allowed and
       then ignored at session start, making superuser-only custom
       parameters much less useful than they should be.
     __________________________________________________________________

Queries

     * Perform "SELECT FOR UPDATE"/SHARE processing after applying LIMIT,
       so the number of rows returned is always predictable (Tom Lane)
       Previously, changes made by concurrent transactions could cause a
       "SELECT FOR UPDATE" to unexpectedly return fewer rows than
       specified by its LIMIT. FOR UPDATE in combination with ORDER BY can
       still produce surprising results, but that can be corrected by
       placing FOR UPDATE in a subquery.
     * Allow mixing of traditional and SQL-standard LIMIT/OFFSET syntax
       (Tom Lane)
     * Extend the supported frame options in window functions (Hitoshi
       Harada)
       Frames can now start with CURRENT ROW, and the ROWS n
       PRECEDING/FOLLOWING options are now supported.
     * Make "SELECT INTO" and "CREATE TABLE AS" return row counts to the
       client in their command tags (Boszormenyi Zoltan)
       This can save an entire round-trip to the client, allowing result
       counts and pagination to be calculated without an additional
       "COUNT" query.
     __________________________________________________________________

Unicode Strings

     * Support Unicode surrogate pairs (dual 16-bit representation) in U&
       strings and identifiers (Peter Eisentraut)
     * Support Unicode escapes in E'...' strings (Marko Kreen)
     __________________________________________________________________

Object Manipulation

     * Speed up "CREATE DATABASE" by deferring flushes to disk (Andres
       Freund, Greg Stark)
     * Allow comments on columns of tables, views, and composite types
       only, not other relation types such as indexes and TOAST tables
       (Tom Lane)
     * Allow the creation of enumerated types containing no values (Bruce
       Momjian)
     * Let values of columns having storage type MAIN remain on the main
       heap page unless the row cannot fit on a page (Kevin Grittner)
       Previously MAIN values were forced out to TOAST tables until the
       row size was less than one-quarter of the page size.
     __________________________________________________________________

ALTER TABLE

     * Implement IF EXISTS for ALTER TABLE DROP COLUMN and ALTER TABLE
       DROP CONSTRAINT (Andres Freund)
     * Allow "ALTER TABLE" commands that rewrite tables to skip WAL
       logging (Itagaki Takahiro)
       Such operations either produce a new copy of the table or are
       rolled back, so WAL archiving can be skipped, unless running in
       continuous archiving mode. This reduces I/O overhead and improves
       performance.
     * Fix failure of ALTER TABLE table ADD COLUMN col serial when done by
       non-owner of table (Tom Lane)
     __________________________________________________________________

CREATE TABLE

     * Add support for copying COMMENTS and STORAGE settings in "CREATE
       TABLE ... LIKE" commands (Itagaki Takahiro)
     * Add a shortcut for copying all properties in "CREATE TABLE ...
       LIKE" commands (Itagaki Takahiro)
     * Add the SQL-standard CREATE TABLE ... OF type command (Peter
       Eisentraut)
       This allows creation of a table that matches an existing composite
       type. Additional constraints and defaults can be specified in the
       command.
     __________________________________________________________________

Constraints

     * Add deferrable unique constraints (Dean Rasheed)
       This allows mass updates, such as UPDATE tab SET col = col + 1, to
       work reliably on columns that have unique indexes or are marked as
       primary keys. If the constraint is specified as DEFERRABLE it will
       be checked at the end of the statement, rather than after each row
       is updated. The constraint check can also be deferred until the end
       of the current transaction, allowing such updates to be spread over
       multiple SQL commands.
     * Add exclusion constraints (Jeff Davis)
       Exclusion constraints generalize uniqueness constraints by allowing
       arbitrary comparison operators, not just equality. They are created
       with the "CREATE TABLE CONSTRAINT ... EXCLUDE" clause. The most
       common use of exclusion constraints is to specify that column
       entries must not overlap, rather than simply not be equal. This is
       useful for time periods and other ranges, as well as arrays. This
       feature enhances checking of data integrity for many calendaring,
       time-management, and scientific applications.
     * Improve uniqueness-constraint violation error messages to report
       the values causing the failure (Itagaki Takahiro)
       For example, a uniqueness constraint violation might now report Key
       (x)=(2) already exists.
     __________________________________________________________________

Object Permissions

     * Add the ability to make mass permission changes across a whole
       schema using the new "GRANT"/"REVOKE IN SCHEMA" clause (Petr
       Jelinek)
       This simplifies management of object permissions and makes it
       easier to utilize database roles for application data security.
     * Add "ALTER DEFAULT PRIVILEGES" command to control privileges of
       objects created later (Petr Jelinek)
       This greatly simplifies the assignment of object privileges in a
       complex database application. Default privileges can be set for
       tables, views, sequences, and functions. Defaults may be assigned
       on a per-schema basis, or database-wide.
     * Add the ability to control large object (BLOB) permissions with
       "GRANT"/"REVOKE" (KaiGai Kohei)
       Formerly, any database user could read or modify any large object.
       Read and write permissions can now be granted and revoked per large
       object, and the ownership of large objects is tracked.
     __________________________________________________________________

Utility Operations

     * Make "LISTEN"/"NOTIFY" store pending events in a memory queue,
       rather than in a system table (Joachim Wieland)
       This substantially improves performance, while retaining the
       existing features of transactional support and guaranteed delivery.
     * Allow "NOTIFY" to pass an optional "payload" string to listeners
       (Joachim Wieland)
       This greatly improves the usefulness of "LISTEN"/"NOTIFY" as a
       general-purpose event queue system.
     * Allow "CLUSTER" on all per-database system catalogs (Tom Lane)
       Shared catalogs still cannot be clustered.
     __________________________________________________________________

COPY

     * Accept COPY ... CSV FORCE QUOTE * (Itagaki Takahiro)
       Now * can be used as shorthand for "all columns" in the FORCE QUOTE
       clause.
     * Add new "COPY" syntax that allows options to be specified inside
       parentheses (Robert Haas, Emmanuel Cecchet)
       This allows greater flexibility for future "COPY" options. The old
       syntax is still supported, but only for pre-existing options.
     __________________________________________________________________

EXPLAIN

     * Allow "EXPLAIN" to output in XML, JSON, or YAML format (Robert
       Haas, Greg Sabino Mullane)
       The new output formats are easily machine-readable, supporting the
       development of new tools for analysis of "EXPLAIN" output.
     * Add new BUFFERS option to report query buffer usage during "EXPLAIN
       ANALYZE" (Itagaki Takahiro)
       This allows better query profiling for individual queries. Buffer
       usage is no longer reported in the output for log_statement_stats
       and related settings.
     * Add hash usage information to "EXPLAIN" output (Robert Haas)
     * Add new "EXPLAIN" syntax that allows options to be specified inside
       parentheses (Robert Haas)
       This allows greater flexibility for future "EXPLAIN" options. The
       old syntax is still supported, but only for pre-existing options.
     __________________________________________________________________

VACUUM

     * Change "VACUUM FULL" to rewrite the entire table and rebuild its
       indexes, rather than moving individual rows around to compact space
       (Itagaki Takahiro, Tom Lane)
       The previous method was usually slower and caused index bloat. Note
       that the new method will use more disk space transiently during
       "VACUUM FULL"; potentially as much as twice the space normally
       occupied by the table and its indexes.
     * Add new "VACUUM" syntax that allows options to be specified inside
       parentheses (Itagaki Takahiro)
       This allows greater flexibility for future "VACUUM" options. The
       old syntax is still supported, but only for pre-existing options.
     __________________________________________________________________

Indexes

     * Allow an index to be named automatically by omitting the index name
       in "CREATE INDEX" (Tom Lane)
     * By default, multicolumn indexes are now named after all their
       columns; and index expression columns are now named based on their
       expressions (Tom Lane)
     * Reindexing shared system catalogs is now fully transactional and
       crash-safe (Tom Lane)
       Formerly, reindexing a shared index was only allowed in standalone
       mode, and a crash during the operation could leave the index in
       worse condition than it was before.
     * Add point_ops operator class for GiST (Teodor Sigaev)
       This feature permits GiST indexing of point columns. The index can
       be used for several types of queries such as "point" <@ "polygon"
       (point is in polygon). This should make many PostGIS queries
       faster.
     * Use red-black binary trees for GIN index creation (Teodor Sigaev)
       Red-black trees are self-balancing. This avoids slowdowns in cases
       where the input is in nonrandom order.
     __________________________________________________________________

Data Types

     * Allow bytea values to be written in hex notation (Peter Eisentraut)
       The server parameter bytea_output controls whether hex or
       traditional format is used for bytea output. Libpq's
       PQescapeByteaConn() function automatically uses the hex format when
